/****************************************************************************** 
  Dla CZTERY EPM3064
 *****************************************************************************/
// LPC2387 RAM: 0x40000000..0x4000FFFF; Ethernet_RAM: 0x7FE00000..7FE03FFF;
// USB_RAM: 0x7FD00000..7FD03FFF; RTC_RAM: 0xE0084000..0xE00847FF;
 
// UWAGA w WinARM int ma 32 bity oraz int16_t i uint16_t maja 32 bity ! 
 
#include "lpc23xx.h"
//#include "types.h"
#include "inttypes.h"
#include "config.h"
#include "uart.h"
#include <string.h>
#include <stdlib.h>
#include "MmcSdCmd.h"
#include "armVIC.h"
#include "irq.h"
#include "STA310_H.h"

#define OSC27

#define AL_Linii 157

#define IRQ_MASK 0x00000080
#define FIQ_MASK 0x00000040
#define INT_MASK (IRQ_MASK | FIQ_MASK)
#define CLEAR_VIC_INTERRUPT		( ( unsigned int ) 0 )

#define Zgas_Ledy FIO2SET|=0x0007
#define Zapal_Cz  FIO2CLR|=0x0001
#define Zapal_Ze  FIO2CLR|=0x0002
#define Zapal_Zo  FIO2CLR|=0x0004
#define BAUD 38400
#define LOW_S 0x07FE
#define HIGH_S 0x02FE
#define SPI_LOW 0xFE
#define SPI_HIGH 0x06

#define I2C_74A_U20 0x7E
#define I2C_74A_U30 0x76
#define I2C_MAX9485 0xE8
#define I2C_TEA5768 0xC0
#define I2C_STA015  0x86
#define I2C_STA310  0x5C

#define I2C_TDA7461 0x8C
#define I2C_SAA6588 0x22

#define SD_CMD_0 0x40
#define SD_CMD_1 0x41
#define SD_CMD_9 0x49
#define SD_CMD_10 0x4A
#define SD_CMD_16 0x50
#define SD_CMD_17 0x51
#define SD_ACMD_23 0x57
#define SD_CMD_24 0x58
#define SD_CMD_25 0x59
#define SD_CMD_55 0x77
#define SD_CMD_58 0x7A
#define SD_CMD_59 0x7B
#define START_BLOCK_BYTE 0xFE
#define START_BLOCK_WRITE 0xFC
#define SPOP_BLOCK_WRITE 0xFD
#define DATA_ACCEPTED 0x05
// CS_SD#
#define CS_SD_1 IOSET0 |= 1 << 16
#define CS_SD_0 IOCLR0 |= 1 << 16
// CS_SRAM#
#define CS_SRAM_0 FIO3CLR |= 0x02000000
#define CS_SRAM_1 FIO3SET |= 0x02000000
// WM_CE
#define WM_CE_0 IOCLR1 |= 1 << 9
#define WM_CE_1 IOSET1 |= 1 << 9
// CS_VDIP
#define CS_VDIP_1 IOCLR1 |= 1 << 21
#define CS_VDIP_0 IOSET1 |= 1 << 21
// SCLKX
#define SCLKX_1 FIO2SET |= 1 << 8
#define SCLKX_0 FIO2CLR |= 1 << 8
// RESETB
#define RESETB_0 IOCLR1 |= 1 << 10
#define RESETB_1 IOSET1 |= 1 << 10
// BIT_EN
#define BIT_EN_0 IOCLR1 |= 1 << 8
#define BIT_EN_1 IOSET1 |= 1 << 8
// STA_IRQB -> IN P2[4]
#define STA_IRQB FIO2PIN0 & 0x10
// DAVN (FIO3PIN) ukladu SAA6588
#define DAVN_M 0x04000000

#define TDA_Vol_7       0x13
// TDA_Vol         0x11
#define TDA_Vol_0       0x12
// TDA_Vol_0       0x11
#define TDA_Vol_Radio   0x10
// TDA_Vol_Radio   0x11
#define TDA_Vol_S       0x0F
// TDA_Vol_Radio   0x11
#define TDA_Vol_M       0x6F
// TDA_Vol_0       0x6F
// TDA_Vol 0x00=+32, 0x0C=+20, 0x1F=+1, 0x20=0, 0x6F=-79dB 

//#define BYTE unsigned char
//#define WORD uint16_t
//#define DWORD uint32_t

typedef short int16_z;
typedef unsigned short uint16_z;

typedef uint8_t BYTE;
typedef uint16_t WORD;
typedef uint32_t DWORD;
typedef uint64_t QWORD;

#define KKWARC 3
// Poslizg_40 = 0x3500 daje 40s
#define Poslizg_40 0x4F80

#define FALSE 0
#define TRUE 1
#define RES_OK 0

#define MAX_wskr 4097

#define uc_Test_Zapisu 253
#define uc_Make_Directory 252
#define uc_Wejscie 251
#define uc_Freq 250
#define uc_Freq_Adj 249
#define uc_REC 246
#define uc_Ustaw_czas 245
#define uc_Rec 244

#define LOBYTE(a) (BYTE)(a)
#define HIBYTE(a) (BYTE)((a)>>8)
#define LOWORD(a) (WORD)(a)
#define HIWORD(a) (WORD)((a)>>16)
#define MAKEWORD(a,b) (WORD)(((a)&0xff)|((b)<<8))
#define MAKELONG(a,b) (DWORD)(((a)&0xffff)|((b)<<16))
#define Tab_Klaster(a) Tab_32_USB[(a)<<2]
#define Tab_Rozmiar(a) Tab_32_USB[((a)<<2)+1]
#define Tab_Atrybut(a) Tab_32_USB[((a)<<2)+2]
#define Tab_Indexb(a)  Tab_32_USB[((a)<<2)+3]
#define MAX_INDEX 511
#define Tab_RozmiarP(a) Tab_32_Eth[((a)*5)+4]
#define Tab_AtrybutP(a) Tab_32_Eth[((a)*5)+3]
#define MAX_INDEXP 819

#define CTRL1_GRAJ_WAV 0x91
#define CTRL2_GRAJ_WAV 0x7A
#define CTRL3_GRAJ_WAV 0xE0
#define CTRLs_GRAJ_WAV 0xE07A91
#define MUX123_GRAJ_WAV 0x7A
#define MUX45_GRAJ_WAV 0x0E
// MUX123 = CTRL2;
// MUX45 = CTRL3 >> 4;

#define CTRL1_GRAJ_MP3 0x51
#define CTRL2_GRAJ_MP3 0x75
#define CTRL3_GRAJ_MP3 0x50
#define CTRLs_GRAJ_MP3 0x507551
#define MUX123_GRAJ_MP3 0x75
#define MUX45_GRAJ_MP3 0x05

#define CTRL1_GRAJ_ADC_DD_M 0x91
#define CTRL2_GRAJ_ADC_DD_M 0xF0
#define CTRL3_GRAJ_ADC_DD_M 0x00
#define CTRLs_GRAJ_ADC_DD_M 0x00F091
#define MUX123_GRAJ_ADC_DD_M 0xF0
#define MUX45_GRAJ_ADC_DD_M 0x00

#define CTRL1_GRAJ_WAV_DD 0x91
#define CTRL2_GRAJ_WAV_DD 0xF8
#define CTRL3_GRAJ_WAV_DD 0xC1
#define CTRLs_GRAJ_WAV_DD 0xC1F891
#define MUX123_GRAJ_WAV_DD 0xF8
#define MUX45_GRAJ_WAV_DD 0x0C

#define CTRL1_GRAJ_MP3_DD 0x51
#define CTRL2_GRAJ_MP3_DD 0xF4
#define CTRL3_GRAJ_MP3_DD 0x41
#define CTRLs_GRAJ_MP3_DD 0x41F451
#define MUX123_GRAJ_MP3_DD 0xF4
#define MUX45_GRAJ_MP3_DD 0x04

#define CTRL1_GRAJ_ADC_DD 0x91
#define CTRL2_GRAJ_ADC_DD 0xF0
#define CTRL3_GRAJ_ADC_DD 0xC1
#define CTRLs_GRAJ_ADC_DD 0xC1F091
#define MUX123_GRAJ_ADC_DD 0xF0
#define MUX45_GRAJ_ADC_DD 0x0C

#define CTRL1_GRAJ_ADC_R_DD 0x91
#define CTRL2_GRAJ_ADC_R_DD 0xB0
#define CTRL3_GRAJ_ADC_R_DD 0xC1
#define CTRLs_GRAJ_ADC_R_DD 0xC1B091
#define MUX123_GRAJ_ADC_R_DD 0xB0
#define MUX45_GRAJ_ADC_R_DD 0x0C

#define CTRL1_REC_SPDIF_DD_M 0x91
#define CTRL2_REC_SPDIF_DD_M 0xB8
#define CTRL3_REC_SPDIF_DD_M 0x00
#define CTRLs_REC_SPDIF_DD_M 0x00B891
#define MUX123_REC_SPDIF_DD_M 0xB8
#define MUX45_REC_SPDIF_DD_M 0x00

#define CTRL1_MASK_AND 0x3C
#define CTRL2_MASK_AND 0x00
#define CTRL3_MASK_AND 0x0F
#define CTRLs_MASK_AND 0xF0FFC3

#define CTRL1_DSTEREO_OR 0x02
#define CTRL1_DSTEREO_AND 0xFD


#define DI disableIRQ();
#define EI enableIRQ();
#define LCD_X ELcd = ELcd_X 
#define LCD_On ELcd |= SLcd
#define LCD_Off ELcd &= 0x02
#define ECHO_On ELcd |= 0x02
#define ECHO_Off ELcd &= 0x05
#define b_PCM 0x00;
#define b_AC3 0x01;
#define b_DTS 0x02; 
#define b_DPL 0x04;
#define b_Circle 0x05; 
#define b_SRS 0x08;
#define b_VMAX 0x09;

#define LedCzer 0x00;
#define LedNieb 0x01;
#define LedZolt 0x02;
#define LedZiel 0x03;

void    delayx(int x);
void    piszc(char x);
void    piszl(char x);
void    piszhl(char x);
void    piszs(char *s);
int     hex2ascii(int x);
int     piszhex(long unsigned int x);
void    piszdec(unsigned int xdec, unsigned char lend);
void    reverse(char s[]);
void    itoa(int n, char s[]);
void    PLL_Str(void);
int     i2c_write_a(char ch);
int     i2c_write_dn(char ch);
int     i2c_write_de(char ch);
int     i2c_read_a(char xx);
int     i2c_read_a1(char xx);
int     i2c_read_dn(void);
int     i2c_read_de(void);
int     i2c1_write_a(char ch);
int     i2c1_write_dn(char ch);
int     i2c1_write_de(char ch);
int     i2c1_read_a(char xx);
int     i2c1_read_a1(char xx);
int     i2c1_read_dn(void);
int     i2c1_read_de(void);
char    i2c1_write_reg(char adress, char reg, char dat);
int     i2c_write_STA015(char _sadr_, char _dane_);
int     i2c_read_STA015(char _sadr_);
int     SD_Reset(void);
int     SD_Command(unsigned char dat, uint32_t arg);
int     SD_Read(char *buf, uint32_t sec);
int     SD_Write(char *buf, uint32_t sec);
int     SD_Write_M(char *buf, uint32_t sec);
int     SD_Write_N(char *buf, uint32_t sec);
unsigned long gethex(void);
unsigned long getdec(void);
int     read_n_sec(void);
int     write_n_sec(void);
int     read_n_sec_x(unsigned long differ);
int     read_n_sec_p(char *ptr);
int     write_n_sec_x(unsigned long differ);
int     write_n_sec_p(char *ptr);
unsigned short GFAT0(unsigned short KlasterF);
int     KlawX(void);
int     getch(void);
int     getchu(void);
unsigned char disk_initialize(unsigned char drv);
unsigned char send_cmd(BYTE cmd, DWORD arg);
unsigned char disk_write (BYTE drv, char *buff, DWORD sector, unsigned char count);
unsigned char disk_read (BYTE drv, char *buff, DWORD sector, unsigned char count);
unsigned char disk_ioctl (BYTE drv, BYTE ctrl, void *buff);
void LD_Latch_n(unsigned char dane, unsigned char latch);
void LD_Latch_s(unsigned long ctrls);
int write_WM8770(unsigned char adr, WORD data);
long int oblicz_freq(unsigned int a );
long int oblicz_FM(unsigned int b );
int Open_SD(void);
unsigned short GetFreeFAT(unsigned short KlasterS);
unsigned short GetFreeFATX(unsigned short KlasterS);
unsigned short GetFreeFATY(unsigned short KlasterS);
unsigned short GetFreeFATZ(unsigned short KlasterS);
unsigned long Wolne_Sec(void);
unsigned short Inic_SRAM(void);
unsigned short WR_SRAM(unsigned short adr, char *buff);
unsigned short RD_SRAM(unsigned short adr, char *buff);
unsigned char Read_DIR(unsigned short Klaster);
unsigned long Graj_PCM(short Index);
unsigned long Graj_WAV(short Index);
unsigned long Graj_MP3(short Index);
unsigned long Graj_PCM_WAV(short Index, short tryb);
unsigned short SzukajNazwy(char szukanan[]);
void SetFAT(unsigned int KlasterF, unsigned int NewClus);
void DelFAT(unsigned int KlasterF);
unsigned short Zapisz_FATy(void);
void Get_1_SEC(unsigned short XClusf);
void Put_1_SEC(unsigned short XClusf);
void Nagrywanie(void);
void Nagrywanie_X(void);
unsigned short GetTimeF(void);
unsigned short GetDateF(void);
void Rec_Audio(void);
void Rec_Audio_X(void);
void Read_STA015(void);
void Write_STA015(void);
void Write_dot_DIR(unsigned short Indexb);
void Write_root_DIR(unsigned short Indexb);
unsigned char bin2bcd(unsigned char xyz);
unsigned char bcd2bin(unsigned char xyz);
unsigned short Get_Index(void);
unsigned short Put_1_Okno(unsigned short Klaster_O, unsigned long okno);
unsigned short Put_1_Okno_X(unsigned short Klaster_O, unsigned long okno);
unsigned short Put_1_Okno_Y(unsigned short Klaster_O, unsigned long okno);
unsigned short Put_1_Okno_Z(unsigned short Klaster_O, unsigned long okno);
unsigned short RD_VDIP(void);
unsigned short WR_VDIP(unsigned char dane);
unsigned short GC_VDIP(void);
unsigned short GL_VDIP(void);
unsigned short GR_VDIP(void);
unsigned short Get_AtrP(char *buff);
unsigned short Put_NameP(char *buff, unsigned short atryb);
unsigned short Get_NameP(char *buff);
unsigned short Get_Name(char *buff, short indx);
unsigned long Put_RozmiarP(char *buff);
unsigned short Open_VDIP(void);
unsigned long Graj_MP3_P(unsigned long rpm);
unsigned long RD_n_VDIP(unsigned long bajtow, unsigned long pocz);
unsigned long SEEK_VDIP(unsigned long pocz);
void Make_DIR(void);
unsigned short Get_Word(unsigned long wsk);
unsigned long Set_Word(unsigned long wsk, unsigned short dat);
void MazaniePlikow(unsigned int Index_M);
unsigned short getpilot(void);
unsigned short GetTimeF(void);
unsigned short GetDateF(void);
void zapis_lcd_c(unsigned char x);
void zapis_lcd_d(unsigned char x);
void gotoxy(char x, char y);
void CLS_LCD(void);
int RDS_RD(char *buff);
int Inic_Tuner(void);
int TEA_Quality(void);
int i2c_write_reg(char adr_slave, char adr_reg, char dat);
int i2c_read_reg(char adr_slave, char adr_reg);
// STA310 (DD)
void STA_softreset(void);
void STA_write(char addr, char data);
uint8_t STA_read(char addr);
void decoder(void);
uint8_t int_STA310(void);
void write_sys_pll(uint8_t addr, uint8_t data);
void PLL(char Md);
void STAint(void);
void STAsynch(void);
void STA_PLL_in(uint8_t s, uint8_t a);
void DACconf(void);
void STAdecoder(uint8_t dec);
void STAeff(void);
void STArsteff(void);
void STAbass(uint8_t bass);
void STAvolume(uint8_t vol);
void Set_PCM(void);
void Set_PLL2PCM(uint8_t spdif, uint8_t audiopll);
void Set_STA(void);
void STAplay(void);
void STA_Auto(void);
void STAcross(char cros);
void VCROut(void);
void SPDIFOut(char modeso);
void New_STA310(void);
unsigned char Vol_PH(short vol);
unsigned char Vol_SPK(short vol);
unsigned char Set_Vol_SPK(char plusm);
unsigned char Set_Vol_Spk(char plusm);
void linia1(char x1, char x2);
void linia2(char x1, char x2);
void WM_Out_Mix(char wm_m1, char wm_m2, char wm_m3, char wm_m4);
void CircleSurr(void);
void NormalSurr(void);
void Res_Delay(void);
void STA_Restart(char mode);
void Set_SPDIF(void);
void Set_SIN1(char slave);
void EPM_SPDIF(char fiber_n_coax);// CTRL3[2][1]: 0 - Coaxial, 1..3 - Fiberoptic1..3
void EPM_DNL(char onoff);       // CTRL3[2]: 1 - DNL on, 0 - DNL off
void EPM_WM_SCK(char WMnMP3);   // CTRL1[7][6]: 10 - WM SCK1, 01 - MP3 SCK1
void EPM_MP3_SCK(char MP3nWM);  // CTRL1[7][6]: 10 - WM SCK1, 01 - MP3 SCK1
void EPM_Set_OUT(char Out);     // CTRL1[5][4][3][2]: SET OUTx1 OUTx2 OUTx3 OUTx4
void EPM_Res_OUT(char Out);     // CTRL1[5][4][3][2]: CLR OUTx1 OUTx2 OUTx3 OUTx4
void EPM_DD_MASTER(char Mast);  // CTRL3[0]: 1 - DD SLAVE, 0 - DD MASTER
void Set_ADC_ATT(void);
void Set_Input(void);
void Set_Input_q(void);
void Display_Input(void);
void inic_lcd(void);
void zapis_lcd_ci_4H(char dane);
void zapis_lcd_ci(char dane);
void zapis_lcd_di(char dane);
void wr_LCD(char dane);
void wr_LCD_4H(char dane);
void DIR_AB(short ab);
void DIR_ABP(short ab);
unsigned short FM_Plus_Minus(char ucx);
void MUTE_On(void);
void MUTE_Off(void);
void UnmuteF(void);
void Unmute(void);
void Rec_RAM(void);
void MP3_SRART(int freq_mp3);
void MP3_STOP(void);
int Delta_ALFreq(void);
int Set_IN7(void);
int Restore_IN(void);
void Display_Freq(char x, char y);
short ADCm(void);
void Set_MODE_DIG(void);
void WM_DIG_ATT(char dac1, char dac2, char dac3, char dac4);
void TDA_Vol(char vol);
void Konfiguracja(void);
long int Szumy(void);
void Nawigacja_SD(void);
void Nawigacja_VDIP(void);
int  Open_Part(void);
void Menu_Power(void);
void Ustaw_czas(void);
int Set_Bit(int zmienna, char bitx);
int Res_Bit(int zmienna, char bitx);
int Test_Bit(int zmienna, char bitx);
char Set_BassTreble_F(void);
char Act_Dec(void);
void Set_Delay(void);
void Ustaw_WE(char xx_);
void Ustaw_WE_Q(char xx_);
char Szumy_X(void);
int Progres(int maxim, int curent);
void MP3_Sopran_Booster(void);
void MP3_Bass_Booster(void);
void MP3_Booster_Off(void);
void Ustaw_Prg(int xx);
void Balance(int *Blx, short lim);
int rd_KL(void);
void wyl(void);
char AC3_Ch_X(void);
void cros(char cr);
int  al_read(unsigned int _sadr_);
int  al_read_5(unsigned int _sadr_);
unsigned long al_read_4(unsigned int _sadr_);
int  al_write(unsigned int _sadr_, char _dane_);
int  al_write_5(unsigned int _sadr_, char _dane_4, char _dane_3, char _dane_2, char _dane_1, char _dane_0);
unsigned long al_write_4(unsigned int _sadr_, unsigned long _dane_);
unsigned long Get_File(short Index);
void Get_32_SEC(unsigned short XClusf);
unsigned long asciih2bin(char *asci);
void DSP_On(void);
void DSP_Off(void);
int Load_AL(int linii);
int Load_AL_FL(int linii);
int Load_AL_73(int linii);
int Load_AL_Exxx(void);
// ===================================================================================================

#define Buf_FAT	    ((volatile uint16_t*) 0x40000E00)
#define DIR0			  ((volatile uint8_t*) 0x40008000)
#define Buf_8			  ((volatile uint8_t*) 0x40001E00)
#define Buf_16			((volatile uint16_t*) 0x40001E00)
#define Buf_32			((volatile uint32_t*) 0x40001E00)
#define Buf_8_2k		((volatile uint8_t*) 0x40002000)
#define Buf_16_2k		((volatile uint16_t*) 0x40002000)
#define Buf_32_2k		((volatile uint32_t*) 0x40002000)
#define Tab_8			  ((volatile uint8_t*) 0x40000000)
#define Tab_16			((volatile short*) 0x40000000)
#define Tab_32			((volatile uint32_t*) 0x40000000)
#define Tab_32_Eth		((volatile uint32_t*) 0x7FE00000)
#define Tab_32_USB		((volatile uint32_t*) 0x7FD00000) 
#define Tab_32_RTC		((volatile uint32_t*) 0xE0084000)
#define Buf_16_FAT		((volatile uint16_t*) 0x4000E000)

// RTC_RAM 0xE0084000 (512 x long)
#define CMOS       ((volatile uint32_t*) 0xE0084000)
#define Flag_C     (*(volatile unsigned long *)(0xE0084000 + 0x0000))
#define freq       (*(volatile unsigned long *)(0xE0084000 + 0x0004))
#define VnC        (*(volatile unsigned long *)(0xE0084000 + 0x0008))
#define DDAdr      (*(volatile unsigned long *)(0xE0084000 + 0x000C))
#define Tryb_44    (*(volatile unsigned long *)(0xE0084000 + 0x0010))
#define SHUTDN     (*(volatile unsigned long *)(0xE0084000 + 0x0014))
#define Input      (*(volatile unsigned long *)(0xE0084000 + 0x0018))
#define VOL_PH     (*(volatile unsigned long *)(0xE0084000 + 0x001C))
#define VOL_SPK    (*(volatile unsigned long *)(0xE0084000 + 0x0020))
#define ADC_ATTL   (*(volatile unsigned long *)(0xE0084000 + 0x0024))
#define ADC_ATTH   (*(volatile unsigned long *)(0xE0084000 + 0x0028))
#define DOWNMIX    (*(volatile unsigned long *)(0xE0084000 + 0x002C))
#define MODE_DIG   (*(volatile unsigned long *)(0xE0084000+0x0030))
#define _FM_0      (*(volatile unsigned long *)(0xE0084000 + 0x0034))
#define _FM_1      (*(volatile unsigned long *)(0xE0084000 + 0x0038))
#define _FM_2      (*(volatile unsigned long *)(0xE0084000 + 0x003C))
#define _FM_3      (*(volatile unsigned long *)(0xE0084000 + 0x0040))
#define _FM_4      (*(volatile unsigned long *)(0xE0084000 + 0x0044))
#define _FM_5      (*(volatile unsigned long *)(0xE0084000 + 0x0048))
#define _FM_6      (*(volatile unsigned long *)(0xE0084000 + 0x004C))
#define _FM_7      (*(volatile unsigned long *)(0xE0084000 + 0x0050))
#define _FM_8      (*(volatile unsigned long *)(0xE0084000 + 0x0054))
#define _FM_9      (*(volatile unsigned long *)(0xE0084000 + 0x0058))
#define _FM_x      (*(volatile unsigned long *)(0xE0084000 + 0x005C))
#define _FM_y      (*(volatile unsigned long *)(0xE0084000 + 0x0060))
#define _FM_z      (*(volatile unsigned long *)(0xE0084000 + 0x0064))
#define _FM_       (*(volatile unsigned long *)(0xE0084000 + 0x0068))
#define BlR        (*(volatile long *)(0xE0084000 + 0x006C))
#define BlC        (*(volatile long *)(0xE0084000 + 0x0070))
#define BlS        (*(volatile long *)(0xE0084000 + 0x0074))
#define BlLs       (*(volatile long *)(0xE0084000 + 0x0078))
#define BlRs       (*(volatile long *)(0xE0084000 + 0x007C))
#define Pro_L_Circle    (*(volatile unsigned long *)(0xE0084000 + 0x0080))
#define Music_Film_Wide (*(volatile unsigned long *)(0xE0084000 + 0x0084))
#define SRS_VMAX        (*(volatile unsigned long *)(0xE0084000 + 0x0088))
#define TDA_Bass        (*(volatile unsigned long *)(0xE0084000 + 0x008C))
#define TDA_Sop         (*(volatile unsigned long *)(0xE0084000 + 0x0090))
#define TDA_BTFilter    (*(volatile unsigned long *)(0xE0084000 + 0x0094))
#define STA_DELAY  (*(volatile unsigned long *)(0xE0084000 + 0x0098))
// LRDLY=STA_DELAY[7..0], C_DLY=STA_DELAY[15..8], LSxDLY=STA_DELAY[23..16], RSxDLY=STA_DELAY[31..24]
#define Glosniki   (*(volatile unsigned long *)(0xE0084000 + 0x009C))
// Glosniki[3..0]: NO_RS#[3], NO_LS#[2], NO_SUB#[1], NO_C#[0]
#define MUXS       (*(volatile unsigned long *)(0xE0084000 + 0x00A0))
#define MP3Boost   (*(volatile unsigned long *)(0xE0084000 + 0x00A4))
// MP3 Booster [1]-Sopran, [0]-Bass
#define MP3_Bass_F      (*(volatile unsigned long *)(0xE0084000 + 0x00A8))
#define MP3_Sop_F       (*(volatile unsigned long *)(0xE0084000 + 0x00AC))
#define MP3_Ton_A       (*(volatile unsigned long *)(0xE0084000 + 0x00B0))
#define IMPULSATOR      (*(volatile unsigned long *)(0xE0084000 + 0x00B4))
#define Virtual_Dim     (*(volatile unsigned long *)(0xE0084000 + 0x00B8))
#define Tryb_44_X       (*(volatile unsigned long *)(0xE0084000 + 0x00BC))
#define Last_Input_7    (*(volatile unsigned long *)(0xE0084000 + 0x00C0))
#define DSP_En          (*(volatile unsigned long *)(0xE0084000 + 0x00C4))
#define IN_5_DIR        (*(volatile unsigned long *)(0xE0084000 + 0x00C8))

#define DIRDIT          (*(volatile unsigned long *)(0xE0084000 + 0x00CC))

#define AL_DIR0         (*(volatile unsigned long *)(0xE0084000 + 0x00D0))
#define AL_DIR1         (*(volatile unsigned long *)(0xE0084000 + 0x00D4))
#define AL_DIR2         (*(volatile unsigned long *)(0xE0084000 + 0x00D8))
#define AL_DIR3         (*(volatile unsigned long *)(0xE0084000 + 0x00DC))
#define AL_DIR4         (*(volatile unsigned long *)(0xE0084000 + 0x00E0))
#define AL_DIR5         (*(volatile unsigned long *)(0xE0084000 + 0x00E4))
#define AL_DIR6         (*(volatile unsigned long *)(0xE0084000 + 0x00E8))
#define AL_DIR7         (*(volatile unsigned long *)(0xE0084000 + 0x00EC))

#define Zapal_SD Wy_76&=0x7F;i2c_write_a(0x76);i2c_write_de(Wy_76)
#define Zgas_SD Wy_76|=0x80;i2c_write_a(0x76);i2c_write_de(Wy_76)

//#define DSP_On Wy_76&=0xBF;i2c_write_a(0x76);i2c_write_de(Wy_76)
//#define DSP_Off Wy_76|=0x40;i2c_write_a(0x76);i2c_write_de(Wy_76)

#define C_MIX_EN Wy_7E&=0xFE;i2c_write_a(0x7E);i2c_write_de(Wy_7E)
#define C_MIX_DIS Wy_7E|=0x01;i2c_write_a(0x7E);i2c_write_de(Wy_7E)

#define RS20     IOCLR0 |= 1 << 21
#define RS21     IOSET0 |= 1 << 21
#define RW20     FIO2CLR |= 1 << 7
#define RW21     FIO2SET |= 1 << 7
#define Enable20 FIO2CLR |= 1 << 6
#define Enable21 FIO2SET |= 1 << 6

#define Input_5_1_Off   IOSET1 |= 1 << 29
#define Input_5_1_On    IOCLR1 |= 1 << 29

#define KL_W020  IOCLR1 |= 1 << 25
#define KL_W021  IOSET1 |= 1 << 25
#define KL_W120  IOCLR1 |= 1 << 26
#define KL_W121  IOSET1 |= 1 << 26

#define ALCLK20  IOCLR1 |= 1
#define ALCLK21  IOSET1 |= 1
#define ALDATA20 IOCLR1 |= 2
#define ALDATA21 IOSET1 |= 2
#define ALDATAPin IOPIN1 & 2
#define ALDATAIn IODIR1 &= 0xFFFFFFFD
#define ALDATAOut IODIR1 |= 2

#define DIR_AUDIO IOPIN1 & 0x00010000
#define DIR_EMPH  IOPIN1 & 0x00020000
// ----------------------------------------------------------------------------------------------------

#include "Poczatek.c"

// = zmienne ============================================================================================================= ########### VARIBLES ##########

volatile unsigned int _delay_x_, differ;

char xlcd, preerase, usb_s, SD_error, SD_CXX[17], SD_Name[9], name32[33], RDS_str[65], RDS_PS0[9], RDS_PS1[9], L_RDS_S[9];
char MUX123, MUX45, KOLORLED, OUTX, DNL, loopx, DSTEREO, MODE_STEREO, Display_RDS, Shift, SPDIF_Er;
int LKey, MODE_DIG_B, MODE_DIG_F, Frames_2m, Frames_Sh, Frames_DD, Frames_Ch, Frames_120, KorC;
unsigned short RDSA, RDSB, RDSC, RDSD, RDSDn[4], RDSDx, RDSs, RDS_In[8], RDSt[8], AB, CD;
unsigned short PILOT_Dec, repp, pilotm, TEA_Tuned, TEA_IF, TEA_ST, TEA_Poziom, ADCLLm, ADCLRm;
unsigned long cur_spi_spd, cur_sec, secl, sech, SD_SN, error, PILOT_0[4], Pilot_o, ALFreq_h, MP_Freq;
unsigned long Szumy_1, Szumy_2, Szumy_3, Szumy_4;
uint32_t  SD_SECTORS, SD_FILE_FORMAT, ARM_CPSR, SecPerClusL, RecLoopLenL, Audio_SEC, Input_Start;
uint32_t  DIRSec, JestFat, FATZmod, LastFat, Rozmiar_Pliku, Indexow, Index_1, Unmute_F; 
unsigned short MAX_Klaster, Klaster_dot, Klaster_dot_B, ELcd, ELcd_X, SLcd, DIR_n;
unsigned short wskr, wskr_0, wskr_C, wskr_E, wskr_M, wskr_T, wskr_L, wskr_N, Poslizg_X;
char *ch_ptr, counts, zs[65], sekundy, h_sekund, DSP_X; //DSP_En; // DIR08[256]; // DIR0[256]
unsigned char CTRL1, CTRL2, CTRL3, Wy_76, Wy_7E, ESC, BACK, TAB, ENTER, Atrybut, Typ_Pliku, FATE, inxi;
unsigned char CTRL1B, CTRL2B, CTRL3B, CTRL1BB, CTRL2BB, CTRL3BB, Flag_B, BCDH, BCDL, MP3Freq, MP3TAG;
unsigned char WM_OUT_MX, WM_OUT_MXn[5], WM_IN, STA015_ATT, SecPerClus, Name8[9], Ext3[4], DIR_DOT, DIR_OK, DIR_DOT_P, DIR_OK_P;
unsigned char WM_OUT_MXB, WM_INB, BassTrebleATT_TDA_4, BassTrebleFilter_TDA_5, Bass_Q, Bass_F, Sop_F;
unsigned char New_s, New_sx, Last_lcd_d, LRDLY, C_DLY, LSxDLY, RSxDLY, Vol_SPK_X, Vol_PH_X, OCFG, AUTO;
char ADC_ATT[8], SAA6588, Mute_Abs, Buf_zs[25];

short *w_ptr, LastDirEnt, DIRow, Plikow, Poziom, RecRoll, RecLoop, Clus_N_Buf, Clus_O_Buf, Clus_0_Buf;
short Stat_REC, CurrDirEnt, BigClus, Ulamek, Hot_Klastry[8], Clus_C_Buf, Clus_1_File, Key;
unsigned short Clus_0_File, Klaster, INDEX, INDEXB, Clus_E_Buf, LastClusRec, Klast_M, Sample_R;
unsigned short INDEXP, IndexowP, DIRowP, PlikowP, AttP, FF1, ADCLLb, ADCLRb, PLL_DD, PLL_DTS;
uint32_t *dw_ptr, AtrybTot, Rozmiar_REC, Nagrane, Rozmiar_Pliku_P, DISK_32_B;

unsigned char ERROR, ERROR_h, SYNC, SYNC_h, SYNC_x, COUNT, HEAD, PTS, PTS_0, PTS_1, PTS_2, PTS_3; 
unsigned char act_decoder, last_decoder, update_decoder, sfreq, data, audiopll, IZ, Displ_I;
unsigned short STA_INT, STA_INT_h, STA_INT_F, VOL_b, TDA_Bass_X, AL0, AL1, AL2, AL3, AL4;
unsigned char act_decoder_b, AC3_Ch, AC3_LFE, AC3_Ch_b, LCh, AC3_LFE_b, SPDIF, Input_BS, Power_On;
unsigned long status, status2_reg, timer, Input_B, AUDIOX, h_Bity_6, h_Bity_7, Blok_6, Blok_7;
int LastU, Cisza;

int16_t INT_16t;
int16_z INT_16z;
int32_t INT_32t;
uint16_t UINT_16t;
uint16_t UINT_16z;
uint32_t UINT_32t;

uint32_t Boot_0, FAT_0, FAT_1, DIR_0, DATA_0, Liczba_Sektorow, Pierwszy_Sektor;
// = main ================================================================================================================ ############# MAIN ############
int main(void)
{
  char ch, s[65], Buf_We[65];
  unsigned char inx, flg, ch1, ch2, AL0m, AL1m, AL2m, AL3m, AL4m, AL5m;
  int c1, c2, c3, c4, c5, c6, c7, c8;
  int cx, cy, mx, my, uc, lz, f, ff, xx, yy, rdsd_ok;

  KOLORLED = 0; // LedCzer
  Shift = 0;
  OUTX = 3;
  DNL = 0;
  Unmute_F = 0;
  MUXS &= 0x0003; 
  // MUXS = (Input & 0x0030) >> 4;
  MUX123 = CTRL2_GRAJ_WAV;
  MUX45 = (CTRL3_GRAJ_WAV & 0xF0) >> 4;
  
  Record = 0;

  AUDIOX = 0;

  DDAdr = 0;

  OCFG = 0x80; // 0x80, 0x85
  AUTO = 0x00; // 0, 1, 2, 3
  PLL_DD  = 1; // 1, 2, 3, 4,(5, 6)
  PLL_DTS = 3; // 1, 2, 3, 4,(5, 6)

  SPDIF_Er = 0;

  Power_On = 1; // Start op wlaczeniu zasilania

  Tryb_44 = 1; // Tryb 44kHz (Sample Rate)
  if((Tryb_44_X != 44) && (Tryb_44_X != 48))
    Tryb_44_X = 44;

  cx = 0x00001000;
  mx = 1;
  lz =0;
  inx = 0;
  cur_spi_spd = 8; //6 lub 8;
  cur_sec = 2;
  ch_ptr = (uint8_t)Buf_8;
  w_ptr = (uint16_t)Tab_16;
  dw_ptr = Tab_32;
  rdsd_ok = 0;
  Stat = 0;
  DISK_32_B = 0x12345678; // Tryb 8 bitowy, Dla 0x5A63A653 -> Tryb 32 bitowy
  FATE = 0; // FAT Error 0000 00 1-zapis do niezerowego Fat'a  1-zapis zera do Fat'a
  preerase = 0;
  usb_s = 0;
  SD_error = 0x7E;
  secl=0;
  sech=0;
  Wy_76 = 0xFF;
  Wy_7E = 0x0F;
  Mp3_P = 0;
  STA015_ATT = 0x02; // DLA, DRA DSP Outpud Attenuation
  Flag_B = 0;
  WM_IN = Input & 0x0007;
  Last_Input_7 &= 0x07;
  Frames = 0;
  Timer_0 = 0;
  Timer_1 = 0;
  Timer_2 = 0;
  Timer_M = 0;
  Timer_U = 0;
  Poslizg_X = 212; // Poslizg_40 / SecPerClus;
  IZ = 0;

  AL0m = 0;
  AL1m = 0;
  AL2m = 0;
  AL3m = 0;
  AL4m = 0;
  AL5m = 0;

  if(IMPULSATOR > 1)
      IMPULSATOR = 0;
  Blok_6 = 0;
  Blok_7 = 0;

  strcpy(L_RDS_S, " RDS... ");
  Display_RDS = 0;

  if(Music_Film_Wide > 3)
    Music_Film_Wide = 0;

  if(Pro_L_Circle > 3)
    Pro_L_Circle = 0;
  DSTEREO = 0;
  if(Pro_L_Circle > 2)
    DSTEREO = 1;

  MODE_STEREO = 1;

  KorC = 0;

  if(BlR > 3)
    BlR = 3;
  if(BlR < -3)
    BlR = -3;

  if(BlC > 10)
    BlC = 10;
  if(BlC < -10)
    BlC = -10;

  if(BlS > 20)
    BlS = 20;
  if(BlS < -20)
    BlS = -20;

  if(BlRs > 10)
    BlRs = 10;
  if(BlRs < -10)
    BlRs = -10;

  if(BlLs > 10)
    BlLs = 10;
  if(BlLs < -10)
    BlLs = -10;

  if(SRS_VMAX > 2)
    SRS_VMAX = 0;

  VOL_PH &= 0x1F;
  VOL_SPK &= 0x7E;
  if(VOL_SPK < 0x20)
      VOL_SPK = 0x20;
// Ograniczenie Vol_SPK do 98 (70 na wyswietlaczu)
  if(VOL_SPK > 98)
    VOL_SPK = 98;
  VOL_b = VOL_SPK;

  ADC_ATTL &= 0x1F1F1F1F;
  ADC_ATTH &= 0x1F1F1F1F;
  for(f=0;f<4;f++)
  {
    ADC_ATT[f] = ADC_ATTL >> (8 * f);
  }
  for(f=0;f<4;f++)
  {
    ADC_ATT[f+4] = ADC_ATTH >> (8 * f);
  }

  Virtual_Dim &= 0x010F;
  if((Virtual_Dim & 0x000F) > 10)
  {
    Virtual_Dim &= 0x0100;
    Virtual_Dim += 10;
  }

  WskFiq = 0;
  TCXX = 0;
  Pilot_w = 0;
  repp = 0;
  Timer_p = 0;
  PILOT_Dec = 0;
  PILOT_0[0] = 0;
  PILOT_0[1] = 0;
  PILOT_0[2] = 0;
  PILOT_0[3] = 0;

  CS_VDIP_0;

  Wy_76 = 0xFE; // RESET# TAS5611

  ELcd = 0x03; // [2]Symulacja, [1]uart0, [0]LCD
  ELcd_X = ELcd;
  SLcd = 0x01;

  name32[12]=0;
  TEA_ST = 0; 
  TEA_Poziom = 0;

  act_decoder = 1; // 0 - PCM, 1 - AC3, 2 - DTS
  act_decoder_b = 0xFE;

  AC3_Ch = 2;
  AC3_LFE = 0;
  AC3_Ch_b = 0x0E;
  AC3_LFE = 0x0E;

  STA_INT = 0;
  STA_INT_h = 1;
  ERROR = 0;
  ERROR_h = 1;
  SYNC = 0;
  SYNC_h = 1;
  SYNC_x = 0;
  ALFreq = 48000;
  FreqX = 0;

  IXI = 0;
  IXL = 0;
  LZN = 0;

// TDA7461 Bass, Sopran
  if((TDA_Bass == 0)||(TDA_Bass > 8))
      TDA_Bass = 2; // +2dB
  TDA_Bass_X = TDA_Bass;   
  if((TDA_Sop == 0)||(TDA_Sop > 8))
      TDA_Sop = 3; // +4dB

  xx = TDA_Bass - 1;
  xx = 7 - TDA_Bass; 
  xx |= 0x08;
  xx = xx << 4;
  BassTrebleATT_TDA_4 = xx; // 0xFF -> 0dB

  xx = TDA_Sop - 1;
  xx = 7 - TDA_Sop; 
  xx |= 0x08;
  BassTrebleATT_TDA_4 |= xx; 
  // BassTrebleATT_TDA_4 = 0xEB; // [7..4]Bass, [3..0]Treble: F=0dB, E=+2dB .. 8 = +14dB
  // BassTrebleFilter_TDA_5 = 0x8A;
  TDA_BTFilter &= 0x3F;
  BassTrebleFilter_TDA_5 = TDA_BTFilter;
  BassTrebleFilter_TDA_5 |= 0x80; // Wstepnie ustawiamy internally connected
  Bass_Q = TDA_BTFilter >> 4;
  Bass_Q &= 0x03; 
  Bass_F = TDA_BTFilter >> 2;
  Bass_F &= 0x03;
  Sop_F  = TDA_BTFilter & 0x03;

// STA015 Bass, Sporan
  if((MP3_Bass_F < 40)||(MP3_Bass_F > 1000))
      MP3_Bass_F = 300; // 100Hz szczyt, Fx = 3 * Fszczyt
  if((MP3_Sop_F < 2050)||(MP3_Sop_F > 16000))
      MP3_Sop_F = 6860; // 12kHz szczyt, Fx = Fszczyt / 1.75 
  if((MP3_Ton_A < 2)||(MP3_Ton_A > 4))
      MP3_Ton_A = 3; // 1 > -1.5dB, 2 > -3dB ... 

  MODE_DIG_B = MODE_DIG;
  MODE_DIG_F = MODE_DIG;

  STA_DELAY &= 0x3F3F0700; // ograniczenie zakresu
  LRDLY =    STA_DELAY & 0x000000FF;
  C_DLY =   (STA_DELAY & 0x0000FF00) >> 8;
  LSxDLY =  (STA_DELAY & 0x00FF0000) >> 16;
  RSxDLY =  (STA_DELAY & 0xFF000000) >> 24;


//  VnC = 0; // Programowanie TEA5768: 0 -> -225kHz; 1 -> +225kHz;
  if(VnC > 1)
    VnC = 0;
// Czestotliwosc FM
  if((_FM_ < 87500) || _FM_ > 108000)
    _FM_ = 98000;
  if(_FM_x > 8)
  {
    _FM_x = 0; // index do tabeli czestotliwosci
  }

  SD_SECTORS = 0; // Liczba sektorw karty SD
  SD_FILE_FORMAT = 0; // 00 -> Partycja i Boot_Sec; 01 -> Boot_Sec only

  JestFat = 0;
  LastFat = 0;

  DIR_DOT = 0;

  RecLoopLenL = 12480; // w sektorach 12480(6240kB) = 40s
  RecLoop = 0;
  Sample_R = 44100;

  strcpy(RDS_str, "RDS SRCH");
  strcpy(RDS_PS0, "RDS SRCH");
  strcpy(RDS_PS1, "RDS SRCH");
  RDS_str[8] = 0;

// --- Testy -----------------------------------------------------------------------
//  Tab_8[0x1E08]++;
  INT_16t = 0xAB16;
  INT_16z = 0xEF16;
  INT_32t = 0xABCDEF32;
  UINT_16t = 0xAB16;
  UINT_16z = 0xEF16;
  UINT_32t = 0xABCDEF32;

// ---------------------------------------------------------------------------------
// DD(STA-310)
  //CTRL1 = 0x83; // EPM3064 Latch_1; 0x80, 43, 83
  //CTRL2 = 0xD0; // EPM3064 Latch_2; 0x83, 45, 4A
  //CTRL3 = 0x0A; // EPM3064 Latch_3; 0xE2, 5A, EA
  CTRL1 = CTRL1_GRAJ_WAV & 0xCF; //CTRL1_GRAJ_ADC_DD_M;
  CTRL2 = CTRL2_GRAJ_WAV;        //CTRL2_GRAJ_ADC_DD_M;
  CTRL3 = CTRL3_GRAJ_WAV;        //CTRL3_GRAJ_ADC_DD_M;

  Frames = 0;
  differ = 0x2000;
  WM_OUT_MX = 5;
  WM_OUT_MXn[0] = WM_OUT_MX;
  WM_OUT_MXn[1] = WM_OUT_MX;
  WM_OUT_MXn[2] = WM_OUT_MX;
  WM_OUT_MXn[3] = WM_OUT_MX;
  WM_OUT_MXn[4] = WM_OUT_MX;

  IODIR0 |= 1 << 16; // CS_SD#
  IODIR0 |= 1 << 10; // CTRL0 DATA
  IODIR0 |= 1 << 11; // CTRL1 CLK
  IODIR0 |= 1 << 5;  // CTRL3 Latch_2
  IODIR0 |= 1 << 4;  // CTRL4 Latch_3
  FIO2DIR |= 1 << 5; // CTRL2 Latch_1
  IODIR1 |= 1 << 9;  // WM_CE
  IODIR1 |= 1 << 21; // CS_VDIP
  IODIR1 |= 1 << 25; // KL_W0
  IODIR1 |= 1 << 26; // KL_W1
  IODIR1 |= 1 << 10; // RESETB
  IODIR1 |= 1 << 8;  // BIT_EN
  IODIR1 |= 0x0003; // ALDATA[1], ALCLK[0]
  IODIR1 |= 1 << 29;  // INPUT_5.1

  IOSET1 |= 1 << 29;  // INPUT_5.1

  // LCD
  FIO2DIR |= 0x0F;   // DAT7, DAT6, DAT5, DAT4
  FIO2DIR |= 1 << 7; // RW
  FIO2DIR |= 1 << 6; // Enable
  IODIR0  |= 1 << 21;// RS
  FIO2CLR |= 1 << 6; // Enable -> '0'
  FIO2CLR |= 7;
  FIO3DIR |= 0x02000000; // CS_SRAM#

  FIO2DIR |= 1 << 8; // SCLKX 
  SCLKX_1; // SCLKX = 1 -> narmalny SCLKX_VD

  FIO2DIR |= 1<<11 | 1<<12 | 1<<13; // <===========================================================================
  FIO2CLR |= 1<<11 | 1<<12 | 1<<13; // <===========================================================================

  systemInit(); // <======================================= SYSTEM Init ===========================================
// void uart0Init(short baud)
  FIO2SET |= 0x0007;
  FIO2CLR |= 0x0001;

// MAX9485
  i2c_write_a(0xE8);
#ifdef OSC27
  i2c_write_de(0xE2); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288 /MCLK EN = bit7/
#else
  i2c_write_de(0x62); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288 /MCLK EN = bit7/
#endif

// ======================================================== POCZATEK Funkcji, I2S ... ============================

  delayx(0x00013210);

  DSP_Off(); // <------------------------------------------------------------------------------ Wstepnie DSP Off -

Restart_x:

  Frames_2m = 400;
  Frames_Sh = 0;
  Frames_DD = 16;
  Frames_Ch = 999;
  Frames_120 = 120;
  Frames = 0;
  KOLORLED = 0; // LedCzer
  WM_IN = Input & 0x0007;
  Input_Start = Input;
  Cisza = 0;
  DIR_OK =  0;
  DIR_OK_P = 0;
  TDA_Vol(TDA_Vol_M); // -79dB
  //Konfiguracja();
  if(DDAdr)
  {
    STA_softreset();
    PLL(0);
    STAint();
    STAsynch();
    STA_Auto();
  }

// POWER / SHUTDN
// PCF8574A(U19)[0x7E] - MUTE_A[7], EXT_11[6], SD_2#[5], SD_1#[4], NO_RS#[3], NO_LS#[2], NO_SUB#[1], NO_C#[0]; 
  xx = i2c_write_a(0x7E);
  Wy_7E &= 0xCF;    // Wylacz TAS3120
  xx = i2c_write_de(Wy_7E);
  delayx(0x00013210);

  Wy_76 &= 0xFE;    // Wylacz TAS5611
  yy = i2c_write_a(0x76);
  xx = i2c_write_de(Wy_76);

  Glosniki &= 0x000F;
  Wy_7E &= 0xF0;
  Wy_7E |= (char)Glosniki;
  yy = i2c_write_a(0x7E);
  xx = i2c_write_de(Wy_7E);

// PCF8574A(U30) - LED_SD[7], EXT_P6[6], EXT_P5[5], READY[4], CLIP#[3], OTWx#[2], SD#[1], RESET#[0];   
  i2c_write_a(0x76);i2c_write_de(Wy_76);
  
// TEA5768HL -----------------------------------------------------------------------

  FIO4CLR |= 0x10000000;
  delayx(0x00000001);
  FIO4SET |= 0x10000000; // BUSENABLE must be '1' least 10us before RD/WR operation
  delayx(0x00001234); 
 
// === PLL =========================================================================
  PLL_Str();
  FIO2SET |= 0x0007;
  FIO2CLR |= 0x0002;
  //for(int i=1; i<500; i++)
    // {
  uart0Init(37);// 40 -> 115200/12.288; 37 -> 115200/11.2896 
    // uart0Puts("DUPA");
    // uart0Putch(i & 0x7F);
    // }
  FIO2SET |= 0x0007;
  FIO2CLR |= 0x0004;

  EPM_Set_OUT(0x0C);
// Test ---------------------------
   uart0TxFlush();
   uart0Putch(0x0A); // LF
   uart0Putch(0x0D); // CR
   uart0Putch('H');
   uart0Putch('A');
   uart0Putch('L');
   uart0Putch('L');
   uart0Putch('O');
   uart0Putch(' ');

   inic_lcd();
   delayx(0x00010000);
   zapis_lcd_ci(0x80); // Adres DRAM
   zapis_lcd_di('A');
   zapis_lcd_di('b');
   zapis_lcd_di('c');
   zapis_lcd_di('d');
   zapis_lcd_di('e');
   zapis_lcd_di(' ');   
   zapis_lcd_di(0x5C);   
   zapis_lcd_di('-');   
   zapis_lcd_di(0x2F);   
   zapis_lcd_di(0x7C);   
   zapis_lcd_di('O');   
   zapis_lcd_di('K');   
   zapis_lcd_di('?');   
   zapis_lcd_di(' ');   
   zapis_lcd_di('&');   
   zapis_lcd_di(' ');

   uart0Putch('.');
   delayx(0x00010000);
   uart0Putch('.');

// Test LDC +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   FIO2SET |= 0x0007;
   FIO2CLR |= 0x0004;

// Test I2C *******************************************************************************************************

  /*piszs("i2c:");
  for(f=0; f<255; f=f+2)
  {
   if(f != 0xE8)
   {   
       if(i2c_write_a(f) >= 0)
       {
           i2c_write_dn(0x01);
           i2c_write_de(0x01);
           piszc('[');
           piszhex(f);
           piszc('^');
           piszc(']');
       }
       else
       {
           piszhex(f);
           piszc('_');
           piszc(' ');
           delayx(0x00001234);
       }
   }
  }*/


// --- TIMER SET -------------------------------------------------------------------
  T0IR =  0x3F;
  T0TCR = 0x02; // Reset
  T0TC =  0x00000000;
  T0PR =  0x00000000; // ~200/s
  T0PC =  0x00000000;
  T0MCR = 0x0000; // 0x0003 INTERRUPT od MR0
  T0MR0 = 0x00000012;
  T0CTCR = 0x05;
  T0TCR = 0x01; // Go

// --- TIMER SET -------------------------------------------------------------------
  T1IR =  0x3F;
  T1TCR = 0x02; // Reset
  T1TC =  0x00000000;
  T1PR =  0x000002C0; // 0x0160 ~10us   ; 0x000022BE ~200/s
  T1PC =  0x00000000;
  T1MCR = 0x0000; // 0x0000 0x0002 ( 0x0003, 0x0001 INTERRUPT od MR0)
  T1MR0 = 0x0000000A; // 0x0012 ~200/s
  T1CTCR = 0x00;
  T1TCR = 0x01; // Go
  T1CCR = 0x38; // 0 0 IntEn CAP1FE CAP1RE 0 0 0   

// --- TIMER SET -------------------------------------------------------------------
  T2IR =  0x3F;
  T2TCR = 0x02; // Reset
  T2TC =  0x00000000;
  T2PR =  0x000022BD; // ~200/s
  T2PC =  0x00000000;
  T2MCR = 0x0002; // 0x0003 INTERRUPT od MR2
  T2MR0 = 0x00000012;
  T2CTCR = 0x00;
  T2TCR = 0x01; // Go

// --- INTERRUPT--------------------------------------------------------------------

  xx = __get_cpsr();piszs("\n\rCPSR=");piszhex(xx);
//  xx = (uint32_t) Irq_Timer_0;piszs("; VICVectAddr4=");piszhex(xx);piszs(" "); 
  xx = (uint32_t) Irq_Timer_2;piszs("; VICVectAddr26=");piszhex(xx);piszs(" "); 

  ARM_CPSR = disableFIQ();
  ARM_CPSR = disableIRQ();

//  VICVectAddr4 = (uint32_t) Irq_Timer_0; // Timer 0
  VICVectAddr26 = (uint32_t) Irq_Timer_2; // Timer 2
  VICVectAddr31 = (uint32_t) Irq_I2S_Tx; // I2S_Tx; I2S_Rx

  VICVectPriority4 = 0x00;
  VICVectPriority26 = 0x00;
  VICVectPriority31 = 0x01;
    
  VICIntSelect = 0x00000020; // FIQ / IRQ#
  VICIntEnable = 0x84000030; // TIMER_2: 1<<26; TIMER_0: 1<<4; TIMER_1: 1<<5, I2S: 1<<31 

  ARM_CPSR = enableIRQ(); // Odpalenie przerwan IRQ
  ARM_CPSR = enableFIQ(); // Odpalenie przerwan IRQ

//  T0MCR = 0x0003; // 0x0003 INTERRUPT
  T2MCR = 0x0003; // 0x0003 INTERRUPT
//  T1MCR = 0x0003; // 0x0003 INTERRUPT

// Set LPC2368 I2S ======================================================
 
  I2S_DAO = 0x0001 + 0x0010 + 0 + (0x1F<<6) ; // 16 bitow, reset(10), Master(20#), WSx64  
  I2S_DAI = 0x0001 + 0x0010 + 0x0020 + (0x1F<<6) ; // 16 bitow, reset(10), Slave(20), WSx64
  I2S_IRQ = 0 + 0x0000 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx
  I2S_RXRATE = 11; // Rx Clock Rata 
  I2S_TXRATE = 11; // Tx Clock Rata 
  I2S_DAO = 0x0001 + 0x0010 + 0x0000 + (0x1F<<6) ; // 16 bitow, reset(10), Master(20#), WSx64
  I2S_DAI = 0x0001 + 0x0010 + 0x0020 + (0x1F<<6) ; // 16 bitow, reset(10), Slave(20), WSx64
  I2S_DAO = 0x0001 + 0x0000 + 0x0000 + (0x1F<<6) ; // 16 bitow, reset(10), Master(20#), WSx64
  I2S_DAI = 0x0001 + 0x0000 + 0x0020 + (0x1F<<6) ; // 16 bitow, reset(10), Slave(20), WSx64

// Fill RAM -----------------------------------------------------------------------

  memset(Tab_8 + 0x2100, 0xFF, 24320); // RAM od 0x2100 do 0x7FFF wypalni 0xFF
  memset(Tab_32_Eth, 0x00000000, 4096);
  memset(Tab_32_USB, 0x00000000, 4096); // 2048

  Tryb_44 = 1; // 1 - 44k, 0 - 48k
  //Tryb_44_48(44); // Tryb 44100 po wylaczeniu
  Tryb_n_27M(44); // Tryb 44100 bez 27MHz po wylaczeniu

// Konfiguracja poczatkowa ---------------------------------------------------------

  KOLORLED = 0; // Czerwona
  Shift = 0;
  Frames_Sh = 0;

  CTRL1B = CTRL1;
  CTRL1 = CTRL1_GRAJ_WAV_DD;
  CTRL1 = CTRL1 & 0xC3;
  CTRL1 = CTRL1 | (OUTX << 2);
  CTRL1 = CTRL1 & 0xCF;
  LD_Latch_n(CTRL1, 1);

  CTRL2B = CTRL2;
  CTRL2 = CTRL2_GRAJ_WAV_DD;
  LD_Latch_n(CTRL2, 2);

  CTRL3B = CTRL3;
  CTRL3 = CTRL3_GRAJ_WAV_DD;
  if(DNL)
    CTRL3 |= 0x08; // DNL
  else
    CTRL3 &= 0xF7; // DNL
  LD_Latch_n(CTRL3, 3);

  write_WM8770(0x1B, 0x077); // LMX(2,1,0); RMX(6,5,4)
  write_WM8770(0x06, 0x040); // DACL4 7F->0dB, 79->-6dB ...
  write_WM8770(0x07, 0x140); // DACR4 7F->0dB, 79->-6dB ... bit[8]-Update 
  write_WM8770(0x19, 0); // ADC_ATT_L(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
  write_WM8770(0x1A, 0); // ADC_ATT_R(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 

// Czekaj na znak -----------------------------------------
  if(Power_On)
  {  
      Power_On = 0;
      xx = 0;
  }
  else
      while(1)
      {
       xx = getch();
       if((xx==0x0D)||(xx==0x1B)||(xx=='Y')||((xx >= '0')&&(xx <= '9')))
           break;
      }

// Tryb nastawiony 44 albo 48 kHz z 27MHz
  Tryb_44_48(Tryb_44_X);

  Mute_Abs = 0;

  CTRL1 = CTRL1B;
  CTRL2 = CTRL2B;
  CTRL3 = CTRL3B;

  if((xx!=0x0D)&&(xx!='Y'))
     switch(xx)
     {
     case '1'  : Input_Start = 1;
                 break;
     case '2'  : Input_Start = 2;
                 break;
     case '3'  : Input_Start = 3;
                 break;
     case 0x1B : Input_Start = 0;
                 break;
     }
     Input = Input_Start;
     if(!(Input & 8))
       Last_Input_7 = Input;

// Po wlaczeniu nie ustawia wej SPDIF
     if(Input & 8)
     {
       Input = Last_Input_7;
       SPDIF = 0;
     }

// EPM3064 - konfiguracja =========================================================
   Konfiguracja();
  // LD_Latch_n(CTRL1, 1);
  // LD_Latch_n(CTRL2, 2);
  // LD_Latch_n(CTRL3, 3);

// AL3102 DSP ================================================================================================
  for(f = 0x0C00; f < 0x0C0F; f++)
  {
    al_write_4(f, 0);
  }

  gotoxy(1,2);
  piszs("DSP_73 Load..");
  my = Load_AL_73(AL_Linii);
  if(!my)
    piszs("OK ");
  else
  {
    piszdec(my,6);
    piszc(' ');
  }

  al_write_4(0x0C00, AL_DIR0); // x
  al_write_4(0x0C01, AL_DIR1); // M1
  al_write_4(0x0C02, AL_DIR2); // M1
  al_write_4(0x0C03, AL_DIR3); // M1
  al_write_4(0x0C04, AL_DIR4); // M1
  al_write_4(0x0C05, AL_DIR5); // M1
  al_write_4(0x0C06, AL_DIR6); // M1
  al_write_4(0x0C07, AL_DIR7); // M1

// AL3102 DSP EDN ============================================================================================

// ---------------------------------------------------------------------------------- DSP On/Off -------------
  if(DSP_En)
  {  
    if(MODE_DIG==2)
      DSP_On();
    piszs("On ");
  }
  else
  {
    DSP_Off();
    piszs("Off ");
  }

   piszs("------------------------------------------\r\n");
   gotoxy(1,1);
   piszdec(RTC_YEAR,4);
   piszc('-');
   piszdec(RTC_MONTH,2);
   piszc('-');
   piszdec(RTC_DOM,2);
   piszc(' ');
   piszdec(RTC_HOUR ,2);
   piszc('-');
   piszdec(RTC_MIN ,2);
   piszc('-');
   piszdec(RTC_SEC ,2);
   piszc(' ');

   KOLORLED = 0x01; // LedNieb
   WM_IN = Input & 0x0007;
   if(Input & 0x0008)
       SPDIF = 1;
   Konfiguracja();

// Wyswietl tajne informacje ====================================================

   linia2(1,24);
   switch(DOWNMIX)
   {
                 //123456789012345678901234
   case 0 : piszs("Downmix, 2/0 LT,RT      ");
       break;
   case 1 : piszs("Downmix, 1/0 Ceter      ");
       break;
   case 2 : piszs("Downmix, 2/0 L0,R0      ");
       break;
   case 3 : piszs("Downmix, 3/0 L,C,R      ");
       break;
   case 4 : piszs("Downmix, 2/1 L,R,S      ");
       break;
   case 5 : piszs("Downmix, 3/1 L,C,R,S    ");
       break;
   case 6 : piszs("Downmix, 2/2 L,R,LS,RS  ");
       break;
   case 7 : piszs("Downmix, 3/2 L,C,R,LS,RS");
       break;
   }
   
   delayx(0x00040000);
   gotoxy(1,1);
   switch(MODE_DIG)
   {
   case 0   :   piszs(" AAA ");
                break;
   case 1   :   piszs(" DAA ");
                break;
   case 2   :   piszs(" DDD ");
                break;
   case 3   :   piszs(" DSD ");
                break;
   }

   switch(SRS_VMAX)
   {
   case  0 : piszs("LIN ");
             break;
   case  1 : piszs("SRS ");
             break;
   case  2 : piszs("VMAX ");
             break;
   }

   switch(Pro_L_Circle)
   {
   case  0 : piszs("Surr Off ");
             break;
   case  1 : piszs("Pro Log. ");
             break;
   case  2 : piszs("Circle   ");
             break;
   }

   delayx(0x00040000);
   gotoxy(1,2);
	
// IC/Ukady programowalne ========================================================
// WM8770 - Set SPI MODE
  RESETB_0;
  delayx(100);
  WM_CE_1;
  delayx(100);
  RESETB_1;
  // Analog ATT
  write_WM8770(0x00, 0x40); // DACL1 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x01, 0x40); // DACR1 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x02, 0x40); // DACL2 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x03, 0x40); // DACR2 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x04, 0x40); // DACL3 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x05, 0x40); // DACR3 7F->0dB, 79->-6dB ...VOL_SPK
  write_WM8770(0x06, 0x07F); // DACL4 7F->0dB, 79->-6dB ...
  write_WM8770(0x07, 0x17F); // DACR4 7F->0dB, 79->-6dB ... bit[8]-Update 
  // Digital ATT
  write_WM8770(0x09, 0x0FE); // DACL1 FF->0dB, F9->-6dB ...
  write_WM8770(0x0A, 0x0FE); // DACR1 FF->0dB, F9->-6dB ...
  write_WM8770(0x0B, 0x0FE); // DACL2 FF->0dB, F9->-6dB ...
  write_WM8770(0x0C, 0x0FE); // DACR2 FF->0dB, F9->-6dB ...
  write_WM8770(0x0D, 0x0FE); // DACL3 FF->0dB, F9->-6dB ...
  write_WM8770(0x0E, 0x0FE); // DACR3 FF->0dB, F9->-6dB ...
  write_WM8770(0x0F, 0x0FE); // DACL4 FF->0dB, F9->-6dB ...
  write_WM8770(0x10, 0x1FE); // DACR4 FF->0dB, F9->-6dB ... bit[8]-Update
  // WM8770 ...
  write_WM8770(0x13, 0x090); // DAC Ctrl 0x90->L,R; 0x60->R,L; 0xF0->MONO: (L+R)/2
  write_WM8770(0x14, 0x020);
  write_WM8770(0x16, 0x001); // Interface ctrl[16b]: 002 - I2S, L,R; 006 - I2S, R,L; 001 - L Just, L,R; 0x005 R,L  
                             // Interface ctrl[24b]: 022 - I2S, L,R; 026 - I2S, R,L; 021 - L Just, L,R; 0x025 R,L 
  write_WM8770(0x17, 0x022); // 0x122 -  Master 
  write_WM8770(0x18, 0x000);   
  write_WM8770(0x19, 0x00C); // ADC_ATT_L(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
  write_WM8770(0x1A, 0x00C); // ADC_ATT_R(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
  write_WM8770(0x1B, 0x001 | 1<<4); // LMX(2,1,0); RMX(6,5,4) 
  write_WM8770(0x1C, 0x009); // Output Mux: MX2(5,4,3) -> Bypass[5], AUX2[4], DAC2[3]; MX1(2,1,0) -> Bypass[2], AUX1[1], DAC1[0]  
  write_WM8770(0x1D, 0x009); // Output Mux: MX4(4,3) -> Bypass[4], DAC4[3]; MX3(2,1,0) -> Bypass[2], AUX3[1], DAC3[0]   

  WM_IN = WM_IN & 0x07;
  xx = WM_IN << 4;
  write_WM8770(0x1B, WM_IN | xx); // LMX(2,1,0); RMX(6,5,4)
  write_WM8770(0x19, ADC_ATT[WM_IN]); // ADC_ATT_L(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
  write_WM8770(0x1A, ADC_ATT[WM_IN]); // ADC_ATT_R(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 

// Ustawienia wspepne ------------------------------------------------------

  if(i2c1_write_a(0x8C) != -1)
  {
   i2c1_write_dn(0x2F); // Test mode
   i2c1_write_de(0xFE);

   piszs(" TDA7461 OK. ");

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x00); // Input selector - CD Quasi Differ., AM STEREO
   i2c1_write_de(0xF9); // F9 = CAS, FC = Stereo dec., F8 = CD, EB = AM 

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x03); // Softmute / Beep
   i2c1_write_de(0xC1);

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x02); // Volume
   i2c1_write_de(TDA_Vol_0 + (TDA_Bass_X>>1)); // 0x20->0dB, 0x10->+16dB ...

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x0A); // Stereodecoder
   i2c1_write_de(0xF6); // 34, 86, B2, F6

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x06); // Att LF (X, Auto-Zero, Test, Increment, 3, 2, 1, 0) [L Phones]
   i2c1_write_de(0xC0 + VOL_PH); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x07); // Att LR [L Surroud]
   i2c1_write_de(0xC0 + (Virtual_Dim & 0x000F)); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x08); // Att RF, Output 15 & 16 [R Phones]
   i2c1_write_de(0x80 + VOL_PH); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x09); // Att RR, Blank time [L Surroud]
   i2c1_write_de(0x80 + (Virtual_Dim & 0x000F)); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x04); // Bass & Treble
   i2c1_write_de(BassTrebleATT_TDA_4); // Bass +6dB(C), Treble +12dB(9)

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x05); // Bass & Treble Filter, AC Connection
   i2c1_write_de(BassTrebleFilter_TDA_5); // Bit[7] - AC Coupling 0-External, 1-Interial

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x0E); // Stereodecoder Adj.
   i2c1_write_de(0x78); // LEVEL: 78->10db, 58->7.5dB, 38->5dB, 18 - 2.5dB, 00-> 0dB

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x0B); // Noiseblanker
   i2c1_write_de(0xD3);

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x0C); // Fildst_
   i2c1_write_de(0x33);

   i2c1_write_a(0x8C);
   i2c1_write_dn(0x0D); // Confog
   i2c1_write_de(0xF1);
  }
  else
   piszs(" TDA7461 Error ");

  if(i2c1_write_a(0x22) >= 0)
  {
      i2c1_write_dn(0x52);
      i2c1_write_dn(0xA0);
      i2c1_write_de(0x64); // 8.664 MHz
      piszs(" RDS OK ");
      SAA6588 = 0x22;
  }
  else
  {
      piszs(" SAA6588 Error ");
      SAA6588 = 0;
  }

  for(f=0;f<10;f++)
  {
      FM_Plus_Minus('+');
      delayx(0x00012222);
      FM_Plus_Minus('-');
      if(TEA_Quality()> 2)
          break;
      delayx(0x00012222);


  }

  Vol_SPK(VOL_SPK);

// = Przetwornik A/D AD0.3 i AD0.5 ======================================================

  AD0CR = 0x00207E08; // CLKDIV=7F, AD0.3: 0x..08, AD0.5: 0x..20, START: 0x01xxxxxx
  AD0FF = 0;          // AD0 Flip/Flop 

// DD = STA310 Identyfikacja 1 ----------------------------------------------------------
  yy = 0;
  if(i2c_write_a(0xB8) >= 0)
  {
      i2c_write_dn(0x01); // DD IDENT
      xx = i2c_read_a(0xB8);
      piszs(" STA310[B8]=");
      piszhex(xx);
      piszc(' ');
      DDAdr = 0xB8;
      yy++;
  }

// DD = STA310 Identyfikacja 2
  if(i2c_write_a(0x5E) >= 0)
  {
      i2c_write_dn(0x01); // DD IDENT
      xx = i2c_read_a(0x5E);
      piszs(" STA310[5E]=");
      piszhex(xx);
      piszc(' ');
      DDAdr = 0x5E;
      yy++;
  }

  if(yy == 0)
  {
      DDAdr = 0;
      piszs(" DD[8B]/[5E] NACK ");
      MODE_DIG &= 0x01; // Mode Digital 0 lub 1
      // detekcja DIR9001 / DIT4096 -----------------------------------------------
      xx = (DIR_EMPH) | (DIR_AUDIO); // EMPH[17] zwykle 0, AUDIO[16] = 0 dla PCM i NotError 
      if(xx != 0x00030000)
      {
        DIRDIT = xx >> 16; // Jest plytka DIR9001 / DIT4096
        DIRDIT ^= 0x0002;
        AUDIOX = DIRDIT & 0x0001; // 1 = AUDIO PCM
        piszs(" DIR/DIT OK ");
      }
  }
  else
  {
      DIRDIT = 0; // Brak plytki DIR9001 / DIT4096
      xx = i2c_read_reg(DDAdr, 0x71);
      piszs(" DD Soft v.:");
      piszhex(xx);
      piszc(' ');
  }

  Timer_M = 120;
  MUTE_On();

// TEST DD/STA310/

// Ustaw konfiguracje ======================================================
  if(DDAdr)
  {
    Set_MODE_DIG();
//    Set_PLL2PCM(0, 2);
//    act_decoder = 0;
//    STA_write(0x4C, 0x03);
//    STA_write(0x4D, 0x03);
//    STA_write(0x05, 0x01);
//    SPDIFOut(1);
    Set_PCM(); // < ----------------------------------------------- Wstepnie ustaw PCM
    //Set_Delay();
  }
  else
  {
    //CTRL1 = CTRL1_GRAJ_WAV;
    //CTRL2 = CTRL2_GRAJ_WAV;
    //CTRL3 = CTRL3_GRAJ_WAV;
    //LD_Latch_n(CTRL1, 1);
    //LD_Latch_n(CTRL2, 2);
    //LD_Latch_n(CTRL3, 3);
    Set_MODE_DIG();
  }

  if(DDAdr)
  {
    SPDIF = 1;
    audiopll = 1;
    status2_reg = 0;
    act_decoder = 0;
    update_decoder = 0;

    act_decoder_b = act_decoder;

    int_STA310();
    piszs("*STA_INT-");  piszhex(STA_INT);  STA_INT_h = STA_INT;
    piszs("*SYNC-");  piszhex(SYNC);  SYNC_h = SYNC;
    piszs("*ERROR-");  piszhex(ERROR);  ERROR_h = ERROR;
    piszc('*');

    piszs("\n\rSTA310 dec=");
    piszhex(act_decoder);
    piszc(' ');

    Set_MODE_DIG();
    VCROut();
    SPDIFOut(1);
  //Set_Delay(); // Delay: wartosc 3 -> 1ms dla 48kHz, suma <= 105, mozna ustawic tylko po Hart Reset
    Res_Delay();

    delayx(0x00001234);
// ---------------------

    Timer_M = 180;
    MUTE_On();

    New_STA310(); // Napisz nazwe strumienia
    if((AC3_Ch >= 3) && act_decoder)
      NormalSurr();
    else
      CircleSurr();

    SPDIFOut(1);
    //Set_Delay();
    SPDIF = 0;
  }
// --------------------------------------------------------------------------------------

  piszs("F=");
  piszdec(ALFreq, 6);
  piszc('*');

  //MUTE_Off();
  //while(Timer_M);
  //UnmuteF();
 
// --------------------------------------------------------------------------------------

// STA015 XTAL = 14.7456 MHz
  BIT_EN_0;

  if(i2c_write_STA015(0x10, 0x01) != -1) // Soft_Reset On
  {
   piszs("#STA015_OK#"); 
   //i2c_write_STA015(0x10, 0x01);  // Soft_Reset On
   i2c_write_STA015(0x10, 0x00);  // Soft_Reset Off

   i2c_write_STA015(0x13, 0x00);  // PLAY
   i2c_write_STA015(0x14, 0x01);  // MUTE

   i2c_write_STA015(6, 12);    // 0x06 M
   i2c_write_STA015(11, 3);    // 0x0B (N)
   i2c_write_STA015(97, 15);   // 0x61 X 48
   i2c_write_STA015(80, 16);   // 0x50 X 44.1
   i2c_write_STA015(101, 85); // 0x65 PLLFRAC_H 48
   i2c_write_STA015(82, 4);   // 0x52 PLLFRAC_H 44.1
   i2c_write_STA015(100, 85);  // 0x64 PLLFRAC_L 48
   i2c_write_STA015(81, 0);   // 0x51 PLLFRAC_L 44.1
   i2c_write_STA015(5, 0xA1);  // 0x05 0xA1 -> OCLK OUT, 0x81 -> OCLK IN

   i2c_write_STA015(0x54, 0x01);  // PCM_DIV
   i2c_write_STA015(0x55, 0x2B);  // PCMCONF 0x33 - I2S, 0x2B - L Just
   i2c_write_STA015(0x0D, 0x00);  // SCLK_POL
   i2c_write_STA015(0x18, 0x04);  // DATA_REQ_ENABLE
   i2c_write_STA015(0x0C, 0x01);  // DATA_REQ_POL
   i2c_write_STA015(0x4D, 0x00);  // CHIP_MODE: 00 - MP3, 04 - ADC
                                  
   i2c_write_STA015(0x63, 0x00);  // DAC_CLK_MODE
   i2c_write_STA015(0xC0, 0x1F);  // ADC_WLEN
   i2c_write_STA015(0xC1, 0x01);  // ADC_WPOS
   i2c_write_STA015(0xBC, 0x01);  // ADC_COFIG  0x03 - I2S, 0x01 - L Just
   i2c_write_STA015(0xBB, 0x00);  // ADC_EN -> 0x01

   i2c_write_STA015(0x46, STA015_ATT);  // DLA ATT, Normalnie DLA, DRA = STA015_ATT, DLB, DRB = 0xFF
   i2c_write_STA015(0x48, STA015_ATT);  // DRA ATT   

   i2c_write_STA015(0x47, 0xFF);  // DLB ATT, Dla L<->R DLB, DRB = STA015_ATT, DLA, DRA = 0xFF
   i2c_write_STA015(0x49, 0xFF);  // DRB ATT

   if(MP3Boost)
     i2c_write_STA015(0x7D, MP3_Ton_A + 3);  // TONE_ATT x 1.5 dB
   else
     i2c_write_STA015(0x7D, 3);  // TONE_ATT x 1.5 dB

   i2c_write_STA015(0x13, 0x00);  // PLAY
   i2c_write_STA015(0x14, 0x00);  // MUTE
                                  
   i2c_write_STA015(0x13, 0x00);  // PLAY
   i2c_write_STA015(0x14, 0x01);  // MUTE

   i2c_write_STA015(0x13, 0x01);  // PLAY
   i2c_write_STA015(0x14, 0x01);  // MUTE

   i2c_write_STA015(0x13, 0x01);  // PLAY
   i2c_write_STA015(0x14, 0x00);  // MUTE

   i2c_write_STA015(0x72, 0x00);  // RUN_MODE -> 0x01

   MP3Boost = MP3Boost & 0x0003;
   if(MP3Boost & 0x0001)
       MP3_Bass_Booster();
   if(MP3Boost & 0x0002)
       MP3_Sopran_Booster();
   if(!MP3Boost)
       MP3_Booster_Off();
  }

// Test LED'ow ----------------------------------------------------------
  FIO2SET |= 0x0007;
  FIO2CLR |= 0x0002;

// Pro_L_Circle SRS_VMAX Virtual_Dim dla DIRDIG
  if( !DDAdr )
  {
    Pro_L_Circle = 0;
    SRS_VMAX = 0;
    Virtual_Dim &= 0xFFFFFEFF;
  }

// Testy ===========================================================================================
  memcpy(Kat_Pliku.Name, "ZBYSZEKP.TXT" ,11);

  Kat_Pliku.Ext[0] = 'A';
  Kat_Pliku.Ext[1] = 'B';
  Kat_Pliku.Ext[2] = 'C';
  Kat_Pliku.Rozmiar = 0x76543210;
  Kat_Pliku.Atrybuty = 0x10;
  Kat_Pliku.Czas = 0x3210;         // Czas 0x16: h[15..11], m[10..5], s/2[4..0]
  Kat_Pliku.Data = 0x3210;         // Data 0x18: r[15..9],  m[8..5],  d[4..0]
  Kat_Pliku.Klaster = 0x3210;     // Pierwszy Klaster 0x1A:

  FIO2SET |= 0x0007;
  FIO2CLR |= 0x0006;

  Inic_Tuner();

  //uart0Init(UART_BAUD(BAUD), UART_8N1, UART_FIFO_8); // setup the UART
	
	//uart0Putch('M');
	
	//uart0Puts("\r\nHello from WinARM!\r\n");
	//uart0Puts("Demo based on code from R O Software\r\n");
	
// Open SD --------------------------------------------------------------
  for(f=0;f<10;f++)
  {
    xx = Open_SD();
    if(!xx)
    {
     piszs("\n\r");
     gotoxy(1, 1);
     piszs("SD");
     if(BlkAddr)
      piszs("_HC_");
     else
      piszs("_SD_");
  
     piszs("0x");
     piszhex(SD_SECTORS);
     piszc('/');
     piszdec(SD_SECTORS, 0);
     piszc('/');
     piszhex(SD_FILE_FORMAT);
     piszs(" N:");
     piszs(SD_Name);
     piszs(" S:");
     piszhex((long)SD_SN);

     break;
    }
  }
  if(xx)
   piszs(" SD Error ! ");
  piszs(" SEC=");piszdec(cur_sec, 0);piszc(' ');
  gotoxy(1,1);
  piszs("\n\r");
// -------------------------------------------------------------------------

  Frames_2m = Frames + 400;
  Frames_Sh = 0;

  Set_Vol_SPK(VOL_SPK);

// Ustaw ostatnie wejscie ====================================================
  Input = Input_Start;
  if(!(Input & 8))
    Last_Input_7 = Input;
  if(Input & 0x0008)
  { 
    Input &= 0x00F0;
    Input |= Last_Input_7;  
    SPDIF = 0;
  }
  WM_IN = Input;
  Set_Input();
  SPDIFOut(1);
  //Set_Delay();

  xx = 1;
  yy = 3;
  while( yy && xx )
  {
    Timer_M = 500;
    MUTE_On();
    xx = Szumy_X();
      if(xx > 1)
        {    
            Timer_M = 500;
            xx = Szumy_X();
        }
      if(xx > 1)
        {
            gotoxy(1,2);
            piszs("* SZUMY * ");
        }
    if(yy)
      yy--;
    if(KlawX() == 0x1B)
        break;
  }

// Test ----------------------------------------------------------------------------------------------------------
   //piszs(" SPI=");piszhl(cur_spi_spd);piszc(' ');

// Uruchom koncowki mocy
  xx = (SHUTDN & 0x06) << 3; // SHUTDN[2]->PCF[5], SHUTDN[1]->PCF[4]
  xx = xx & 0x0030;
  Wy_7E &= 0xCF;
  Wy_7E |= (char)xx;
  yy = i2c_write_a(0x7E);
  xx = i2c_write_de(Wy_7E);

  xx = SHUTDN;
  xx = SHUTDN & 0x0001; // SHUTDN[0]->PCF[0] = RESET#(TAS5611)
  Wy_76 &= 0xFE;
  Wy_76 |= (char)xx;
  yy = i2c_write_a(0x76);
  xx = i2c_write_de(Wy_76);

// Pierwsze Unmute ----------------------------------------------------------------------------------------------- 
  while(Timer_M);
  //MUTE_Off();
  UnmuteF();

// LOOP ################################################################################################### LOOP #
  Timer_0 = 40; // 20 -> 0.1s, 40 -> 0.2s ...
  FF1 = 0;
  ADCLLb = 0;
  ADCLRb = 0;
// LOOP ################################################################################################### LOOP #
  while(1) 
   {
    // TestIO(1234);
    
    // Frames &= 0x&7FFF;

// Ulamek sekundy -------------------------------------------------------------------------------------------------
   if(!Timer_0)
   {
       Timer_0 = 40; // 50
       FF1++;

       ECHO_Off;

       if(FF1 < 4)
       {
         if(DSP_En)
         {
             // Peak Meters
             // 0x508/9 - VCR, 0x50A/B - L/R, 0x50C/D - C/Sub, 0x50E/F - Ls/Rs
              AL0 = al_read(0x50A) >> 4; // L
              AL1 = al_read(0x50B) >> 4; // R
              AL0m += AL0;
              AL1m += AL1;
  
              AL2 = al_read(0x50E) >> 4; // Ls
              AL3 = al_read(0x50F) >> 4; // Rs
              AL2m += AL2;
              AL3m += AL3;
  
              AL4 = al_read(0x50C) >> 4; // C
              xx  = al_read(0x50D) >> 4; // Sub
              AL4m += AL4;
              AL5m += xx;
         }
         else
         {
          ADCm(); // Pomiar poziomu sygnalu AUDIO L R
          if(ADCLLm >= ADCLLb)
             ADCLLb = ADCLLm;
          if(ADCLRm >= ADCLRb)
             ADCLRb = ADCLRm;
         }
       }

// Display Lavel --------------------------------------------------------------------------------------------------
      if(FF1 >=4)
      {
       FF1 = 0;
       if(DSP_En)
       {
           // Peak Meters
           // 0x508/9 - VCR, 0x50A/B - L/R, 0x50C/D - C/Sub, 0x50E/F - Ls/Rs
            AL0 = al_read(0x50A) >> 4; // L
            AL1 = al_read(0x50B) >> 4; // R
            AL0m += AL0;
            AL1m += AL1;
            AL0 = AL0m / 4;
            AL1 = AL1m / 4;
            gotoxy(1,2); // L
            if(AL0 < 10)
              piszc(AL0 + 0x30);
            else
              piszc(AL0 + 0x37);
            piszc('<');
            gotoxy(7,2); // R
            piszc('>');
            if(AL1 < 10)
              piszc(AL1 + 0x30);
            else
              piszc(AL1 + 0x37);
            piszc(' ');

            AL2 = al_read(0x50E) >> 4; // Ls
            AL3 = al_read(0x50F) >> 4; // Rs
            AL2m += AL2;
            AL3m += AL3;
            AL2 = AL2m / 4;
            AL3 = AL3m / 4;
            gotoxy(3,2); // Ls
            if(AL2 < 10)
              piszc(AL2 + 0x30);
            else
              piszc(AL2 + 0x37);
            gotoxy(6,2); // Rs
            if(AL3 < 10)
              piszc(AL3 + 0x30);
            else
              piszc(AL3 + 0x37);
          
            AL4 = al_read(0x50C) >> 4; // C
            xx  = al_read(0x50D) >> 4; // Sub
            AL4m += AL4;
            AL5m += xx;
            AL4 = AL4m / 4;
            xx = AL5m / 4;
            gotoxy(4,2); // C
            if(AL4 < 10)
              piszc(AL4 + 0x30);
            else
              piszc(AL4 + 0x37);
            gotoxy(5,2); // Sub
            if(xx < 10)
              piszc(xx + 0x30);
            else
              piszc(xx + 0x37);
            AL0m = 0;
            AL1m = 0;
            AL2m = 0;
            AL3m = 0;
            AL4m = 0;
            AL5m = 0;
       }
       else
       {
             gotoxy(1,2);
             piszc('L');
             piszdec(ADCLLb, 3);
             piszc('R');
             piszdec(ADCLRb, 3);
             piszc(' ');
             ADCLLb = 0;
             ADCLRb = 0;
       }
     }
       LCD_X;
   }
// ----------------------------------------------------------------------------------------------------------------
    New_s = 0; 
    sekundy = RTC_SEC;

// SEKUNDY --------------------------- 
    if(sekundy != h_sekund)
    {
                h_sekund = sekundy;
                New_s++;
                New_sx++;

                Display_Freq(19,2);

                if( !DDAdr && SPDIF )
                {
                  xx = (DIR_EMPH) | (DIR_AUDIO); // EMPH[17] zwykle 0, AUDIO[16] = 0 dla PCM i NotError 
                  if(xx != 0x00030000)
                  {
                    DIRDIT = xx >> 16; // Jest plytka DIR9001 / DIT4096
                    DIRDIT ^= 0x0002;
                    AUDIOX = DIRDIT & 0x0001; // 1 = AUDIO PCM
                  }
                  if((DIRDIT & 0x0001) == 0)
                  {
                    Timer_M = 500;
                    MUTE_On();
                  }
                }

                if(DDAdr)
                  FIO2DIR &= 0xFFFFFFEF; // SPDIF_TX# -> DDIRQB

                if(DIRDIT)
                {
                  FIO2DIR |= 0x00000010; // SPDIF_TX#
                  if(SPDIF)
                    FIO2SET |= 0x00000010; // SPDIF_TX# ECHO
                  else
                    FIO2CLR |= 0x00000010; // SPDIF_TX# DIT4096
                }

                //xx = 0x76; // PCF8574A(U30) - LED_SD[7], EXT_P6[6], EXT_P5[5], READY[4], CLIP#[3], OTWx#[2], SD#[1], RESET#[0]; 
                //xx = i2c_write_a(xx);
                //if(xx >= 0)
                //    {
                //     xx = sekundy;
                //     xx = (xx & 0x1F);
                //     Wy_76 = (Wy_76 & 0xE0) | xx;
                //     xx = i2c_write_de(Wy_76);
                //    }

                //xx = 0x7E; // PCF8574A(U19) - MUTE_A[7], EXT_11[6], SD_2#[5], SD_1#[4], NO_RS#[3], NO_LS#[2], NO_SUB#[1], NO_C#[0]; 
                /*xx = i2c_write_a(xx);
                if(xx >= 0)
                    {
                     xx = sekundy;
                     xx = xx & 0x3F;
                     xx = i2c_write_de(xx);
                    } */
                // TEST EPM3064
                // LD_Latch_n(CTRL1 + ((sekundy & 0x02)<< 4) + ((sekundy & 0x01)<< 4), 1);

     //if((act_decoder == 0) && SPDIF)
       //         write_WM8770(0x16, 0x005); // Interface ctrl: 002 - I2S, L,R; 006 - I2S, R,L
     //else
       //         write_WM8770(0x16, 0x001); // Interface ctrl: 002 - I2S, L,R; 006 - I2S, R,L
    }

//    if((STA_IRQB)==0)
//      goto  STA_IRQ;

// 1/12.5 sekundy ----------------------------------------------------------------------------
    if( Frames > Frames_DD )
    {
     Frames_DD = Frames + 16;
// ALFreq --------------------------------------------------------------------------
     xx = Delta_ALFreq();
     if(xx > 384)
     {
       piszs("F=");
       piszdec(ALFreq, 6);
       piszc('*');
     }
     if(DSP_En)
     {
       if((ALFreq > 31000) && (ALFreq < 49000) && (DSP_X == 0) && (MODE_DIG==2))
         DSP_On();
       if(((ALFreq <= 31000) && (ALFreq >= 49000) && DSP_X) || ((MODE_DIG!=2) && DSP_X))
         DSP_Off();
     }

// DD STA310 INT ===================================================================
STA_IRQ:
      if(SPDIF && DDAdr && ((STA_IRQB)==0))
        {
                    int_STA310();
                    STA_INT_F = STA_INT;
                    STA_INT &= 0x300D; //0xFEDD; // 0xFEDF;
// STA_INT [D]UnLock [C]NewAudioFormat [B]FIFO_Over [A]FB_Free [9]FB_Full
//         [8]PCM_Out_Underflow [7]- [6]PTS_First_Bit [5]BOF_First_Bit_Frame [4]DEM_De-emphasis_ch.
//         [3]SFR_Samplie_Rare_ch. [2]ERR_Error_Detected [1]HDR_Valid_Header_Reg. [0]SYN_Change_Syhch.
                    if(SYNC != SYNC_x)
                    {
                      LCD_Off;
                      piszs("S=");
                      piszhex(SYNC);
                      piszc('/');
                      piszdec(RTC_MIN,2);
                      piszdec(sekundy,2);
                      SYNC_x = SYNC;
                      LCD_X;
                    }
                    SYNC &=0x0A; // 0x0A [3,2]PAC_Status, [1,0]FRA_Frame_Status
                    if((STA_INT != STA_INT_h)||(ERROR != ERROR_h)||(SYNC != SYNC_h))
                    {
                      STA_INT_h = STA_INT;
                      SYNC_h = SYNC;
                      ERROR_h = ERROR;
                        
                      if((act_decoder != 1) || (STA_INT & 0x3000)) 
                      {
                        MUTE_On();
                        Timer_M = 140;
                        gotoxy(16,1);
                        piszs("*STAI:");  piszhex(STA_INT);  
                        gotoxy(1,2);
                        //piszs("*STAS:");  piszhex(SYNC);  
                        piszs("*STAE:");  piszhex(ERROR);
                        piszc('*');
                        
                        //if((STA_read(0x4C)==0x05)&&(STA_read(0x4D)==0x06))
                        //{
                          // DTS
                          if( (STA_INT&0x300C)!=0 )
                            update_decoder = 1;
                        //if( ERROR && (ERROR != 0x21) && (ERROR != 0x01) )
                        //    update_decoder = 1;
                        //  if( (SYNC & 0x01)!=0 )
                        //    update_decoder = 1;
                        //}
                        //else
                        //  update_decoder = 1;
                        //Displ_I++;
                      }
                    }
                    
                    if(last_decoder != Act_Dec())
                      update_decoder = 1;

                    if(LCh != AC3_Ch)
                    {  
                      update_decoder = 1;
                      Set_Input();
                      //Set_MODE_DIG();
                    }

                    //if(update_decoder)
                      //Displ_I++;

                    if((STA_read(0x4C)==5)&&(STA_read(0x4D)==0))
                    {
                      // AC3
                        AC3_Ch_X(); //AC3_Ch = STA_read(0x77);
                        //if(AC3_Ch > 6)
                          //  AC3_Ch = 6;
                        if((AC3_Ch_b != AC3_Ch) || (AC3_LFE_b != AC3_LFE))
                        {
                            // New_STA310(); // Zmiana tylko Postprocesing'u
                              if((AC3_Ch >= 3) && act_decoder)
                              {
                                  NormalSurr();
                                  if(Virtual_Dim & 0x0100)
                                     piszs("VirlualT,");
                                  else
                                     piszs("*NSurr,");
                                  LCD_Off;
                                  switch(SRS_VMAX)
                                  {
                                  case  0 : piszs("Off*");
                                            break;
                                  case  1 : piszs("SRS*");
                                            break;
                                  case  2 : piszs("VMAX*");
                                            break;
                                  }
                                  LCD_X;
                              }
                              else
                              {    
                                  CircleSurr();
                                  piszs("*CSurr,");
                                  LCD_Off;
                                  switch(Pro_L_Circle)
                                  {
                                  case  0 : piszs("Off*");
                                            break;
                                  case  1 : piszs("Pro_L*");
                                            break;
                                  case  2 : piszs("Circle*");
                                            break;
                                  }
                                  LCD_X;
                              }
                           Displ_I++;
                           AC3_Ch_b = AC3_Ch;
                           AC3_LFE_b = AC3_LFE;
                        }

                        // VCROut();
                        // SPDIFOut(1); // VCR
                        //Set_Delay();
                    }

                    if(update_decoder)
                    {
                        MUTE_On();
                        piszs("*Mute*");
                        Timer_M = 100;
                        update_decoder = 0;
                        if((STA_read(0x4C)==0x05)&&(STA_read(0x4D)==0x06))
                            act_decoder = 2; // DTS
                          last_decoder = act_decoder;
                        STAdecoder(act_decoder); // Set_STA(); // <========================== Szybka zmiana dekodera
                        delayx(0x00001000);
                        New_STA310();
                        AC3_Ch_X();
                        if((AC3_Ch >= 3) && act_decoder)
                          {
                              NormalSurr();
                              LCD_Off;
                              if(Virtual_Dim & 0x0100)
                                 piszs("VirlualT,");
                              else
                                 piszs("*NSurr,");
                              switch(SRS_VMAX)
                              {
                              case  0 : piszs("Off*");
                                        break;
                              case  1 : piszs("SRS*");
                                        break;
                              case  2 : piszs("VMAX*");
                                        break;
                              }
                              LCD_X;
                          }
                          else
                          {    
                              CircleSurr();
                              LCD_Off;
                              piszs("*CSurr,");
                              switch(Pro_L_Circle)
                              {
                              case  0 : piszs("Off*");
                                        break;
                              case  1 : piszs("Pro_L*");
                                        break;
                              case  2 : piszs("Circle*");
                                        break;
                              }
                              LCD_X;
                          }
                        VCROut();
                        if((act_decoder > 0)&&(AC3_Ch > 2))
                          SPDIFOut(2); // 0 - L/R, 1 - VCR, 2 - AC3/DTS
                        else
                          SPDIFOut(1); // VCR
                        //Set_Delay();
                        if((AC3_Ch_b != AC3_Ch)||(AC3_LFE_b != AC3_LFE)||(act_decoder_b != act_decoder))
                          Displ_I++;
                    }

                    if((STA_INT_F & 0x09) && (update_decoder == 0))
                    {
                      MUTE_On(); // ...
                      Timer_M = 99;
                      STA_INT_F = 0;
                    }

                    if(act_decoder > 0)
                        AC3_Ch_X();
                    if((AC3_Ch_b != AC3_Ch) || (AC3_LFE_b != AC3_LFE))
                    {
                        // New_STA310(); // Zmiana tylko Postprocesing'u
                          if((AC3_Ch >= 3) && act_decoder)
                          {
                              LCD_Off;
                              NormalSurr();
                              if(Virtual_Dim & 0x0100)
                                 piszs("VirlualT,");
                              else
                                 piszs("*NSurr,");
                              switch(SRS_VMAX)
                              {
                              case  0 : piszs("Off*");
                                        break;
                              case  1 : piszs("SRS*");
                                        break;
                              case  2 : piszs("VMAX*");
                                        break;
                              }
                              LCD_X;
                          }
                          else
                          {    
                              CircleSurr();
                              LCD_Off;
                              piszs("*CSurr,");
                              switch(Pro_L_Circle)
                              {
                              case  0 : piszs("Off*");
                                        break;
                              case  1 : piszs("Pro_L*");
                                        break;
                              case  2 : piszs("Circle*");
                                        break;
                              }
                              LCD_X;
                          }
                       Displ_I++;
                       AC3_Ch_b = AC3_Ch;
                       AC3_LFE_b = AC3_LFE;
                   }


        }

      if(SPDIF & DIRDIT)
      {
        if((DIR_AUDIO)==0)
        {
          Timer_M = 390;

          LCD_Off;

          MUTE_On();
          if(Timer_M < 100)
            Timer_M = 100;
          piszs("*Mute/Audio*");
  //        Input += 0x0010;
  //        Input &= 0x0FBF;
          Set_Input();
          Displ_I++; 
          SPDIF_Er++;
          if(SPDIF_Er > 19)
          {
            SPDIF_Er = 0;
            SPDIF = 0;
            Input &= Last_Input_7;
            Set_Input();
          }
            //Set_Delay();
          while(Timer_M > 20);
          LCD_X;
          xx = KlawX();
          if(xx > 0)
            uc = xx;
          if(uc == 0x1B)
          {
            uc = 0x20;
            SPDIF_Er = 0;
            SPDIF = 0;
            Input &= Last_Input_7;
            Set_Input();
          }

        }
      }

      if((SPDIF && DDAdr)&&(Frames > Frames_Ch))
      {
        Frames_Ch = Frames + 999;
        AC3_Ch_X(); //AC3_Ch = STA_read(0x77);
          if((AC3_Ch_b != AC3_Ch) || (AC3_LFE_b != AC3_LFE))
          {
            Set_Input();
            // New_STA310(); // Zmiana tylko Postprocesing'u
            if((AC3_Ch >= 3) && act_decoder)
             {
                  NormalSurr();
                  if(Virtual_Dim & 0x0100)
                     piszs("VirlualT,");
                  else
                     piszs("*NSurr,");
                  LCD_Off;
                  switch(SRS_VMAX)
                  {
                  case  0 : piszs("Off*");
                            break;
                  case  1 : piszs("SRS*");
                            break;
                  case  2 : piszs("VMAX*");
                            break;
                  }
                  LCD_X;
             }
            else
             {    
                  CircleSurr();
                  piszs("*CSurr,");
                  LCD_Off;
                  switch(Pro_L_Circle)
                  {
                  case  0 : piszs("Off*");
                            break;
                  case  1 : piszs("Pro_L*");
                            break;
                  case  2 : piszs("Circle*");
                            break;
                  }
                  LCD_X;
             }
            Displ_I++;
            AC3_Ch_b = AC3_Ch;
            AC3_LFE_b = AC3_LFE;
          }
      }
      // -------------------------------------------------------------------------------------------------

      if(SPDIF && DDAdr)
      {
        if((New_sx > 1) && ((ALFreq > 40000)&&(ALFreq < 49000)) && (MODE_DIG >= 2))
        {
          Rec_RAM();
          xx = Szumy(); 
          Szumy_4 = Szumy_3;// Wykrywanie piskow
          Szumy_3 = Szumy_2;
          Szumy_2 = Szumy_1;
          Szumy_1 = xx;
          if((xx > 0x0289EEEE) || (xx < 0x00000100)) // 0x0321EEEE
          {
           if(xx < 0x00000100)
             Cisza++;
           if((xx > 0x0289EEEE)||(Cisza > 9)) 
           {
            Cisza = 0; 

            LCD_Off;

            Timer_M = 180;
            MUTE_On();
            piszs("*Mute*");

            update_decoder = 0;
            if((STA_read(0x4C)==0x05)&&(STA_read(0x4D)==0x06))
              act_decoder = 2; // DTS
            last_decoder = act_decoder;

            if(xx > 0x0389EEEE)
            {
              piszs("*Szumy*");
              Set_STA();
              delayx(0x00001000);
              New_STA310();
              if((AC3_Ch >= 3) && act_decoder)
                NormalSurr();
              else
                CircleSurr();
              VCROut();
              if((act_decoder > 0)&&(AC3_Ch > 2))
                SPDIFOut(2); // 0 - L/R, 1 - VCR, 2 - AC2/DTS
              else
                SPDIFOut(1); // VCR
               //Set_Delay();
            }
            else
            {  
              piszs("*Cisza*");
              Set_Input();
              if(DSP_En && (MODE_DIG == 2))
              {
                //Load_AL_FL(AL_Linii);
                DSP_On();
              }
            }
              
            LCD_X;
           }
          }
          New_sx = 0;
// Wykrywanie piskow
          xx = 0;
          /*if((Szumy_1 > 0x00020123)&&(Szumy_2 > 0x00020123)&&(Szumy_3 > 0x00020123)&&(Szumy_4 > 0x00020123))
          {
            if(Szumy_1 > Szumy_2)
              xx = Szumy_1 - Szumy_2;
            else
              xx = Szumy_2 - Szumy_1;
            if(Szumy_2 > Szumy_3)
              yy = Szumy_2 - Szumy_3;
            else
              yy = Szumy_3 - Szumy_2;
            if((xx < Szumy_1/16)&&(yy < Szumy_1/16)&&(xx < Szumy_2/16)&&(yy < Szumy_2/16))
            {  
              if(Szumy_3 > Szumy_4)
                xx = Szumy_3 - Szumy_4;
              else
                xx = Szumy_4 - Szumy_3;
              if((xx < Szumy_3/16)&&(yy < Szumy_3/16)&&(xx < Szumy_4/16)&&(yy < Szumy_4/16))
              {  
                LCD_Off;
                piszs("*Sinus*");
                update_decoder = 0;
                if((STA_read(0x4C)==0x05)&&(STA_read(0x4D)==0x06))
                  act_decoder = 2; // DTS
                last_decoder = act_decoder;
                Set_STA();
                delayx(0x00001000);
                New_STA310();
                if((AC3_Ch >= 3) && act_decoder)
                  NormalSurr();
                else
                  CircleSurr();
                VCROut();
                if((act_decoder > 0)&&(AC3_Ch > 2))
                  SPDIFOut(2); // 0 - L/R, 1 - VCR, 2 - AC2/DTS
                else
                  SPDIFOut(1); // VCR
                 //Set_Delay();
                LCD_X;
              }
            }
          } */
        }
        if(LCh != AC3_Ch)
        {  
          update_decoder = 1;
          Set_Input();
          //Set_MODE_DIG();
        }
      }

      if(((ALFreq < 27000)||(ALFreq > 98000)) && SPDIF)
      {
        Timer_M = 390;

        LCD_Off;

        MUTE_On();
        if(Timer_M < 100)
          Timer_M = 100;
        piszs("*Mute/Freq*");
//        Input += 0x0010;
//        Input &= 0x0FBF;
        Set_Input();
        Displ_I++; 
        SPDIF_Er++;
        if(SPDIF_Er > 19)
        {
          SPDIF_Er = 0;
          SPDIF = 0;
          Input &= Last_Input_7;
          Set_Input();
        }
        else
        {
          update_decoder = 1;
          if((STA_read(0x4C)==0x05)&&(STA_read(0x4D)==0x06))
             act_decoder = 2; // DTS
          last_decoder = act_decoder;
          Set_STA();
          delayx(0x00013210);
          New_STA310();
          if((AC3_Ch >= 3) && act_decoder)
             NormalSurr();
          else
             CircleSurr();
          VCROut();
          if((act_decoder > 0)&&(AC3_Ch > 2))
             SPDIFOut(2); // 0 - L/R, 1 - VCR, 2 - AC2/DTS
          else
             SPDIFOut(1); // VCR
          delayx(0x00013210);
        }
          //Set_Delay();
        while(Timer_M > 20);
        LCD_X;
        xx = KlawX();
        if(xx > 0)
          uc = xx;
        if(uc == 0x1B)
        {
          uc = 0x20;
          SPDIF_Er = 0;
          SPDIF = 0;
          Input &= Last_Input_7;
          Set_Input();
        }
      }


      if( (!Timer_M)&&(VOL_b <= 0x1A)&&(!Mute_Abs))
        {    
            UnmuteF(); //MUTE_Off();
            piszs("*UnMute*");
        }

      LCD_X;
      if(Displ_I)
      {
       ELcd &= 0x05; // Tylko LCD
       Display_Input();
       ELcd = ELcd_X;
       Displ_I = 0;
      }
  }

  if(Frames > Frames_2m)
  {    
    Frames_2m = Frames + 400;
    Displ_I++;
/*    LCD_Off;
    if(SPDIF && (AC3_Ch > 2))
    {    
     NormalSurr();
     piszs("/NSurr/");
    }
    else
    {
     CircleSurr();
     piszs("/CSurr/");
    }
    LCD_X; */
  }

  if(Displ_I)
  {
   ELcd &= 0x05; // Tylko LCD
   Display_Input();
   ELcd = ELcd_X;
   Displ_I = 0;
  }

  if(!Timer_M && (VOL_b <= 0x1A))
    MUTE_Off();


// Przelaczanie LED'ow
/*		FIO2SET |= 0x0007;
		cx = cx & 0x0003FFFF;
		ch = cx >> 15;
		FIO2CLR0 |= ch & 0x06;
		cx++; */
		//if ((ch = uart0Getch()) >= 0) {
			//uart0Puts("You pressed : ");
			//uart0Putch(ch);
			//uart0Puts("\r\n");
		//}

// -------------------------------------------------------- USB --------------------------------------------------
      loopx++;
      loopx = loopx & 0x00000007;
      if((Timer_U > 0) && (Timer_U < 4))
      {
        gotoxy(1,1);
        piszs("*USB END* ");
      }
      if(loopx == 0x01)
      {
       uc = KlawX();
       if((uc == 'x')&&(LastU == 'x')&&(inx == 0)&&((ELcd & 0x02) == 0))
       {
           ELcd_X = ELcd_X | 0x02;
           ELcd = ELcd_X;
           uc = 0;
       }
       if((LastU == 0x01) && (uc == 0x01) && (inx == 0))
       {
        DI; 

        ELcd &= 0x79; //0x7B;
        Timer_U = 200;
        ELcd_X = ELcd;
        SLcd = 0x01;

        Buf_We[inx] = LastU;
        inx++;
        for(f=1;f<8;f++)
        {
         Buf_We[inx] = (char)getchu();
         inx++;
        }

        EI;

        if(!ELcd)
          ELcd = 1;
        gotoxy(1,1);
        piszs("*USB* ");

        flg = 0;

// ---------------------------------------------------------
		if(flg < 8)
         {
          flg = 0; // WR Buff caly
          for(f=0;f<8;f++)
          {
           if(Buf_We[f] == REQ_RB[f])
           flg++;
          }
          if(flg == 8)
          {
           piszs("WR_Buf_f"); 
           Timer_U = 500;
           DI;
           uart0Putch(0x02); // Poginaj (IBM Start)
           for(f = 0x2000; f <= 0xFFFF; f++) // 0x7FFF
             Tab_8[f] = (char)getchu();
           EI;
           piszc('.');
           piszhex(f);
           delayx(0x00054321);
           for(f=0; f<8; f++)
            {
             uart0Putch(ACK_RD_AT_WR_PC[f]); // piszc
            }
           piszs("A ");
           delayx(0x00014321);
           gotoxy(7,1);
          }
         }

// ---------------------------------------------------------
    if(flg < 8)
         {
          flg = 0; // WR Buff (n Sektorow)
          for(f=0;f<8;f++)
          {
           if(Buf_We[f] == REQ_RB[f])
            flg++;
           else
            if(f==2)flg++; // REQ_RB[2] == n_Sektorow
          }
          if(flg == 8)
          {
           piszs("WR_Buf_n");
           Timer_U = 500;
           ff = 8192 + (Buf_We[2]<<9); 
           if(ff > 65536)ff = 65536; // 32768
           DI;
           uart0Putch(0x02); // Poginaj (IBM Start)
           for(f=8192; f<ff; f++)
             Tab_8[f] = (char)getchu();
           EI;
           piszc('.');
           delayx(0x00054321);
           for(f=0; f<8; f++)
            {
             uart0Putch(ACK_RX[f]); // piszc
            }
           piszs("A ");
           delayx(0x00014321);
           gotoxy(7,1);
          }
         }

// ---------------------------------------------------------
    if(flg < 8)
         {
          flg = 0; // WR CMOS
          for(f=0;f<8;f++)
          {
           if(Buf_We[f] == REQ_RC[f])
            flg++;
           else
            if(f==2)flg++; // REQ_RC[2] == 0x10
          }
          if(flg == 8)
          {
           piszs("WR_CMOS ");
           Timer_U = 500;
           DI;
           uart0Putch(0x02); // Poginaj (IBM Start)
           for(f=0; f<512; f++) // 2048
            {
             uc = (char)getchu();
             xx = 0x000000FF & uc;
             uc = (char)getchu();
             xx |= ((uc<<8) & 0x0000FF00);
             uc = (char)getchu();
             xx |= ((uc<<16) & 0x00FF0000);
             uc = (char)getchu();
             xx |= ((uc<<24) & 0xFF000000);
             CMOS[f] = xx;
             Buf_32_2k[f] = xx;
            }
           uc = 0x20;
           EI;
           piszc('.');
           delayx(0x00054321);
           for(f=0; f<8; f++)
            {
             uart0Putch(ACK_RX[f]); // piszc
            }
           piszs("A ");
           delayx(0x00014321);
           gotoxy(7,1);
          }
         }

// ---------------------------------------------------------
     if(flg < 8)
     {
          flg = 0; // RD RAM Full
          for(f=0;f<8;f++)
           {
            if(Buf_We[f] == REQ_WF[f])
             flg++;
           }
          if(flg == 8)
           {
            piszs("Fill_RAM ");
            Timer_U = 500;
            for(f=0; f<65536; f++) // 32768
              {
               uart0Putch(Tab_8[f]); // piszc(Tab_8[f]);
              }
           }
      
     }

// ---------------------------------------------------------
		if(flg < 8)
         {
		      flg = 0; // RD Buff
          for(f=0;f<8;f++)
          {
           if(Buf_We[f] == REQ_WB[f])
           flg++;
          }
          if(flg == 8)
          {
           piszs("RD_Buf   ");
           Timer_U = 500;
           for(f=8192; f<65536; f++) // 32768
            {
             uart0Putch(Tab_8[f]); // piszc(Tab_8[f]);
            }
          }
		 }
		 
// - CMOS ---------------------------------------------------
		if(flg < 8)
         {
		      flg = 0; // RD CMOS
          for(f=0;f<8;f++)
          {
           if(Buf_We[f] == REQ_WC[f])
           flg++;
          }
          if(flg == 8)
          {
           piszs("RD_CMOS  ");
           Timer_U = 500;
           for(f=0; f<512; f++) // 2048
            {
             xx = CMOS[f];
             uc = xx & 0x000000FF;
             uart0Putch(uc); // piszc(uc);
             uc = (xx & 0x0000FF00)>>8;
             uart0Putch(uc); // piszc(uc);
             uc = (xx & 0x00FF0000)>>16;
             uart0Putch(uc); // piszc(uc);
             uc = (xx & 0xFF000000)>>24;
             uart0Putch(uc); // piszc(uc);
             Buf_32_2k[f] = xx;
            }
           uc = 0x20;
          }
		 }
		 
// ---------------------------------------------------------
    if((flg < 8)&&(usb_s==0))
         {
          flg = 0; // RD SEC
          if((Buf_We[1]==RD_SECb[1])&&(Buf_We[7]==RD_SECb[7]))
          {
           secl = Buf_We[3];
           secl = secl + (Buf_We[4]<<8);
           secl = secl + (Buf_We[5]<<16);
           secl = secl + (Buf_We[6]<<24);
           sech = secl;
           if((!SD_error)&&(SD_SECTORS>sech))
           {
            usb_s = 1;
            for(f=0; f<8; f++)
            {
             uart0Putch(ACK_EX[f]); // piszc
            }
            piszs("rd sec A ");
            delayx(0x00054321);
           }
           else
           {
            usb_s = 0;
            for(f=0; f<8; f++)
            {
             uart0Putch(NOT_RDY[f]); // piszc
            }
           }
           flg = 8;
          }
         }

// ---------------------------------------------------------
    if((flg < 8)&&(usb_s==1))
         {
          flg = 0; // RD SEC 1
          usb_s = 0;    
          for(f=0;f<2;f++)
          {
           if(Buf_We[f] == REQ_WB[f])
           flg++;
          }
          if(flg == 2)
          {
           usb_s = 0;
           yy = Buf_We[2];
           if(yy>48)
            yy=48; 
           sech = sech + yy - 1; // liczba sektorow
           Zapal_SD;
           xx = read_n_sec();
           Zgas_SD;
           if(!xx)
           {
            piszs("RD_SEC   ");
            Timer_U = 500;
            xx = 0x2000 + (yy<<9);
            for(f=0x2000;f<xx;f++)
             uart0Putch(Tab_8[f]); // piszc(Tab_8[f]);
           }
           flg = 8;
          }
         }

// ---------------------------------------------------------
    if((flg < 8)&&(usb_s==0))
         {
          flg = 0; // WR SEC
          if((Buf_We[1]==WR_SECb[1])&&(Buf_We[7]==WR_SECb[7]))
          {
           secl = Buf_We[3];
           secl = secl + (Buf_We[4]<<8);
           secl = secl + (Buf_We[5]<<16);
           secl = secl + (Buf_We[6]<<24);
           sech = secl;
           if((!SD_error)&&(SD_SECTORS>sech))
           {
            yy = Buf_We[2]; // Sektorow
            if(yy>48)
             yy=48; 
            sech = sech + yy - 1; // liczba sektorow
            piszs("WR_SEC   ");
            // ---- Zapisz sektory -----------------
            DI;
            Timer_U = 500;
            Zapal_SD;
            xx = write_n_sec();
            Zgas_SD;
            // ---- Wyslij potwierdzenie -----------
            for(f=0; f<8; f++)
            {
             uart0Putch(ACK_EX[f]); // piszc
            }
            EI;
           }
           else
           {
            for(f=0; f<8; f++)
            {
             uart0Putch(NOT_RDY[f]); // piszc
            }
           }
           flg = 8;
          }
         }

// ---------------------------------------------------------
    if((flg < 8)&&(usb_s==0))
         {
          flg = 0; // Ident PCCI
          if((Buf_We[1]==RD_PCCI[1])&&(Buf_We[7]==RD_PCCI[7]))
          {

           // Open_SD(); // Open disk SD ------------------------

           if((!SD_error)&&(SD_SECTORS > 0))
           {
            RD_PCCIu[0] = SD_SECTORS & 0x000000FF;
            RD_PCCIu[1] = (SD_SECTORS >> 8) & 0x000000FF;
            RD_PCCIu[2] = (SD_SECTORS >> 16) & 0x000000FF;
            RD_PCCIu[3] = (SD_SECTORS >> 24) & 0x000000FF;
            RD_PCCIu[4] = BlkAddr & 0x000000FF;
            RD_PCCIu[5] = SD_FILE_FORMAT & 0x000000FF;
            RD_PCCIu[6] = 0;
            RD_PCCIu[7] = 0;
            // ---- Wyslij dane _ _ _ -------------------------
            piszs("IDENT ");
            Timer_U = 500;
            for(f=0; f<8; f++)
            {
             uart0Putch(RD_PCCIu[f]); // piszc
            }

            RD_PCCIu[0] = SD_CXX[12];  //0x00000000;
            RD_PCCIu[1] = SD_CXX[11]; //0x00000000;
            RD_PCCIu[2] = SD_CXX[10]; //0x00000055;
            RD_PCCIu[3] = SD_CXX[9]; //0x000000AA;
            RD_PCCIu[5] = 0;
            RD_PCCIu[6] = 0;
            // ---- Wyslij dane _ _ _ -----------
            for(f=0; f<8; f++)
            {
             uart0Putch(RD_PCCIu[f]); // piszc
            }

            RD_PCCIu[0] = SD_CXX[1]; //0x00000000;
            RD_PCCIu[1] = SD_CXX[2]; //0x00000000;
            RD_PCCIu[2] = SD_CXX[3]; //0x00000055;
            RD_PCCIu[3] = SD_CXX[4]; //0x000000AA;
            RD_PCCIu[4] = SD_CXX[5]; //0x00000000;
            RD_PCCIu[5] = SD_CXX[6]; //0x00000055;
            RD_PCCIu[6] = SD_CXX[7]; //0x000000AA;
            RD_PCCIu[7] = 0;
            // ---- Wyslij dane _ _ _ -----------
            for(f=0; f<8; f++)
            {
             uart0Putch(RD_PCCIu[f]); // piszc
            }
           }
           else
           {
            for(f=0; f<8; f++)
            {
             uart0Putch(NOT_RDY[f]); // piszc
            }
            for(f=0; f<8; f++)
            {
             uart0Putch(ACK_EX[f]); // piszc
            }
            for(f=0; f<8; f++)
            {
             uart0Putch(NOT_RDY[f]); // piszc
            }
           }
           flg = 8;
          }
         }

// --------------------------------------------------        	
         uc = 0;
         inx = 0;
        }

   if((Frames & 0x0021) == (Frames & 0x007F))
   {  
     ELcd &= 0x05; // Tylko LCD
     Display_Input();
     ELcd = ELcd_X;
   }

// RDS -----------------------------
   xx = Frames & 0x007F;
   if(Frames >= Frames_120)//((xx == 0x01)||(xx == 0x12)||(xx == 024)||(xx == 0x38)||(xx == 0x50)||(xx == 0x62))
   {
     Frames_120 = Frames + 120;
     yy = TEA_Quality();
     if((yy > 5) && ((Input & 0x000F)==0))// && (xx==0x38)
     {
       LCD_On; // Tylko LCD
       ECHO_Off;
       gotoxy(9,2);
       piszc(' ');

       RDSDx = 0;
       yy = 0;
       while((Frames & 0x007F) < 0x0075)
       {
         yy = RDS_RD(zs);
         if(yy)
         {
           // piszs("\010\010\010\010\010\010\010\010\010");
           gotoxy(10,2);
           if(Display_RDS > 10)
               piszs(zs); // RDS_PS1
           strcpy(L_RDS_S, zs);
           // piszc('/');
           Display_RDS++;
         }
         if(yy > 2)
           break;
         delayx(100);
       }
       if(yy <= 2)
       {    
           gotoxy(10,2);
           if(Display_RDS > 10)
           piszs(L_RDS_S);
       }
       gotoxy(18,2);
       piszc(' ');
       gotoxy(1,2);
       LCD_X; //ELcd = ELcd_X;  
     }

     if((Display_RDS <= 10) && !SPDIF)
     {
      // TEA Quality
       yy = TEA_Quality();
       LCD_On; // Tylko LCD
       ECHO_Off;
       gotoxy(9,2);

       piszs(" Q:");
       piszdec(yy ,2); // Quality 0..15
       piszc('/'); // TEA_IF = 0x38(56) = 100%
       piszdec(TEA_IF + 44, 3); // Dostrojenie w [%]

       gotoxy(18,2);
       piszc(' ');
       gotoxy(1,2);
       LCD_X; //ELcd = ELcd_X;  
     }

     if((Input & 0x000F) != 0)
     {
       LCD_On; // Tylko LCD
       ECHO_Off;
       gotoxy(9,2);
       piszc(' ');

       piszdec(RTC_HOUR ,2);
       piszc('-');
       piszdec(RTC_MIN ,2);
       piszc('-');
       piszdec(RTC_SEC ,2);

       gotoxy(18,2);
       piszc(' ');
       gotoxy(1,2);
       LCD_X; //ELcd = ELcd_X;  
     }
   }


// Obsluga klawiatury ================================================================================

   if(IZ)
   {
     IZ = 0;
     // uc = getch();
     uc = ' ';
   }

// T E S T ============================================================================================
/*   if(KL_1234 || KL_5678)
   {
     gotoxy(1,1);
     piszc('K');
     piszhex((KL_5678<<4)+KL_1234);
   } */
   
   if(uc == 0x0D)
   {
     Set_Input();
     if(DSP_En)
     {
       gotoxy(10, 2);
       piszs("Loading..");
       my = Load_AL_Exxx(); //Load_AL_73(AL_Linii);
       if(!my)
         piszs(" OK ");
       else
         piszs(" Er ");
       delayx(0x00012345);
     }
     uc = 0;
   }

   if(uc == 0x1B)
   {
     linia1(1,24);
     piszs("* Shutdown/Wylaczyc ??? ");
     uc = getch();
     if(uc == 0x0D)
     {  
       linia1(1,24); // --------------
       piszs("* Shutdown/Wylaczam ... ");
       linia2(1,24); // --------------
       piszs("IN = ");
       piszhex(Input);
       piszs("  - OFF -  XXXXXX");
       uc = ' ';
       wyl(); // wylacz
       goto Restart_x;
     }
     else
     {
       linia1(1,24); // --------------
       piszs("*** Praca/Job ... ***   ");
     }
   }

   if(uc == 'Y')
   {  
     linia1(1,24); // --------------
     piszs("* Shutdown/Wylaczam ... ");
     linia2(1,24); // --------------
     piszs("IN = ");
     piszhex(Input);
     piszs("  - OFF -  XXXXXX");
     uc = ' ';
     wyl(); // wylacz
     goto Restart_x;
   }

   if((uc >= 0x04) && (uc <= 255) && (inx == 0))
   {
           piszc(uc); // uart0Putch(uc);

   if((uc == 'm') || (uc == 'M')) // (uc == 0x0D) // MENU
   {
       linia1(13,20);
       piszs(" MENU ");
       linia2(1,24);
            //123456789012345678901234  
       piszs("[1]WEJ/IN [2]PLAY[3/4]FM");

       uc = getch();
       if(uc > 0x40)
         uc &= 0xDF;

       if(uc == '1')
           uc = uc_Wejscie;

       if(uc == '3')
           uc = uc_Freq;

       if(uc == '4')
           uc = uc_Freq_Adj;

       if(uc == '2')
       {    
           linia2(1,24);
                //123456789012345678901234  
           piszs("[1]Play SD [2]Play USB..");
           uc = getch();

           if(uc > '3')
               uc = ' '; // wypad

           if(uc == '1') // Play SD
               uc = 'n';

           if(uc == '2') // Play USB
               uc = 'N';

       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs("[1]DIG/A,[2]AC3/DTS Dow.");

        uc = getch();
        if(uc > 0x40)
           uc &= 0xDF;

        if(uc == '1')
        {
            
            linia2(1,24);
                 //123456789012345678901234
            switch(MODE_DIG)
            {
             case 0  : piszs("DIG/A:[*]AAA[2]DAA[3]DDD");
                       break;
             case 1  : piszs("DIG/A:[1]AAA[*]DAA[3]DDD");
                       break;
             default : piszs("DIG/A:[1]AAA[2]DAA[*]DDD");
                       break;
            }

            uc = getch();
            if((uc >= '1')&&(uc <= '3'))
            {
                MODE_DIG = uc & 0x03;
                MODE_DIG -= 1;
            }

            if(DDAdr)
                MODE_DIG &= 0x0003;
            else
                MODE_DIG &= 0x0001; // <----------------------------------------------- MODE AAA, DAA !

            linia2(1,24);
                 //123456789012345678901234
            switch(MODE_DIG)
            {
             case 0  : piszs("DIG/A:[*]AAA[2]DAA[3]DDD");
                       break;
             case 1  : piszs("DIG/A:[1]AAA[*]DAA[3]DDD");
                       break;
             default : piszs("DIG/A:[1]AAA[2]DAA[*]DDD");
                       break;
            }
            delayx(0x00013210);

            uc = ' ';
            linia2(1,24);

            Timer_M = 500;
            MUTE_On();

            Set_MODE_DIG();

            if(MODE_DIG > 1)
            {    
                xx = Szumy_X();
                if(xx > 1)
                {    
                    Timer_M = 500;
                    xx = Szumy_X();
                }
                if(xx > 1)
                {
                    gotoxy(1,2);
                    piszs("* SZUMY * ");
                }
            }
            while(Timer_M);
            MUTE_Off();
        }

        if(uc == '2')
        {
            linia1(1,24);
            switch(DOWNMIX)
            {
                          //123456789012345678901234
            case 0 : piszs("Downmix, 2/0 LT,RT      ");
                break;
            case 1 : piszs("Downmix, 1/0 Ceter      ");
                break;
            case 2 : piszs("Downmix, 2/0 L0,R0      ");
                break;
            case 3 : piszs("Downmix, 3/0 L,C,R      ");
                break;
            case 4 : piszs("Downmix, 2/1 L,R,S      ");
                break;
            case 5 : piszs("Downmix, 3/1 L,C,R,S    ");
                break;
            case 6 : piszs("Downmix, 2/2 L,R,LS,RS  ");
                break;
            case 7 : piszs("Downmix, 3/2 L,C,R,LS,RS");
                break;
            }

            linia2(1,24);
                 //123456789012345678901234
            piszs("AC3/DTS Downmix(");
            piszc(DOWNMIX + '0');
            piszs(")[0..7]");
    
            uc = getch();

            if(uc > 0x40)
               uc &= 0xDF;
            if((uc>=0x30) && (uc<=0x37))
            {
                uc &= 0x0F;
                DOWNMIX = uc;
                STA_write(0x6F, DOWNMIX); // AC3 Downmix
                linia2(1,24);
                switch(DOWNMIX)
                {
                              //123456789012345678901234
                case 0 : piszs("Downmix, 2/0 LT,RT      ");
                    break;
                case 1 : piszs("Downmix, 1/0 Ceter      ");
                    break;
                case 2 : piszs("Downmix, 2/0 L0,R0      ");
                    break;
                case 3 : piszs("Downmix, 3/0 L,C,R      ");
                    break;
                case 4 : piszs("Downmix, 2/1 L,R,S      ");
                    break;
                case 5 : piszs("Downmix, 3/1 L,C,R,S    ");
                    break;
                case 6 : piszs("Downmix, 2/2 L,R,LS,RS  ");
                    break;
                case 7 : piszs("Downmix, 3/2 L,C,R,LS,RS");
                    break;
                }
            }
         delayx(0x00037000);
         uc = ' ';
        }
       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("[1]Pro_L,[2]SRS,[3]Music");

           uc = getch();

           if(uc == '1')
           {
             linia1(1,24);
             switch(Pro_L_Circle)
               {
                 case  0 : piszs("*Pro Logic/Circle Off*");
                           break;
                 case  1 : piszs("*Dolby Pro Logic On* ");
                           break;
                 case  2 : piszs("*Circle Surround On* ");
                           break;
                 case  3 : piszs("*Double STEREO*      ");
                           break;
               }
             delayx(0x00034567);

             linia2(1,24);
                  //123456789012345678901234
             piszs("[0]Off[1]DPL[2]Circ[3]DS");

             uc = getch();

             if((uc>='0')&&(uc<='3'))
             {
               linia2(1,24);
               Pro_L_Circle = uc & 0x03;
               //if(!(Glosniki&0x01))C_MIX_EN;
               switch(Pro_L_Circle)
               {
                 case  0 : piszs("*Pro Logic/Circle Off*");
                           break;
                 case  1 : piszs("*Dolby Pro Logic On* ");
                           break;
                 case  2 : piszs("*Circle Surround On* ");
                           break;
                 case  3 : piszs("*Double STEREO*      ");
                           //if(!(Glosniki&0x01))C_MIX_DIS; // Dla Double STEREO blokuj Centralny 
                           break;
               }
               Timer_M = 500;
               MUTE_On();
               if((AC3_Ch >= 3) && act_decoder)
                   NormalSurr();
               else
                   CircleSurr();
               Szumy_X();
               while(Timer_M);
               MUTE_Off();

               uc = ' ';
              }
             }

             if(uc == '2')
             {
               linia1(1,14);
               switch(SRS_VMAX)
                 {
                  case  0 : piszs("*No 3D Sound*");
                            break;
                  case  1 : piszs("*SRS On* ");
                            break;
                  case  2 : piszs("*VMAX On* ");
                            break;
                 }
               delayx(0x00034567);

               linia2(1,24);
                    //123456789012345678901234
               piszs("[0]Off [1]SRS [2]VMAX   ");

               uc = getch();

               if((uc>='0')&&(uc<='3'))
               {
                 linia2(1,18);
                 SRS_VMAX = uc & 0x03;
                 switch(SRS_VMAX)
                 {
                  case  0 : piszs("*No 3D Sound*");
                            break;
                  case  1 : piszs("*SRS On* ");
                            break;
                  case  2 : piszs("*VMAX On* ");
                            break;
                 }
                 Timer_M = 100;
                 MUTE_On();
                 if((AC3_Ch >= 3) && act_decoder)
                     NormalSurr();
                 else
                     CircleSurr();
                 Szumy_X();
                 while(Timer_M);
                 MUTE_Off();

                 uc = ' ';
               }
             }              

             if(uc == '3')
             {
               linia1(1,18);
               switch(Music_Film_Wide)
                 {
                  case  0 : piszs("* Mode MUSIC *");
                            break;
                  case  1 : piszs("* Mode FILM  *");
                            break;
                  case  2 : piszs("* MUSIC/Wide *");
                            break;
                  case  3 : piszs("* FILM/Wide  *");
                            break;
                 }
               delayx(0x00034567);

               linia2(1,24);
                    //123456789012345678901234
               piszs("[0/2]Music/W [1/3]Film/W");

               uc = getch();

               if((uc>='0')&&(uc<='3'))
               {
                 linia2(1,18);
                 Music_Film_Wide = uc & 0x03;
                 switch(Music_Film_Wide)
                 {
                  case  0 : piszs("* Mode MUSIC *");
                            break;
                  case  1 : piszs("* MODE FILM  *");
                            break;
                  case  2 : piszs("* MUSIC/Wide *");
                            break;
                  case  3 : piszs("* FILM/Wide  *");
                            break;
                 }
                 Timer_M = 100;
                 MUTE_On();
                 if((AC3_Ch >= 3) && act_decoder)
                     NormalSurr();
                 else
                     CircleSurr();
                 Szumy_X();
                 while(Timer_M);
                 MUTE_Off();

                 uc = ' ';
               }
             }
       }
// ------------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("[1]DSP AL3102[2]Sample R");

           uc = getch();

           if(uc == '1')
           {
             linia1(1,24);
             if(DSP_En)
               piszs("[*]DSP On, [2]DSP off..");
             else
               piszs("[1]DSP On, [*]DSP off..");
             uc = getch();
             if(uc != 0x1B)
             {
               if(uc == '1')
               {
                 DSP_En = 1;
                 DSP_On();
               }
               else
               {
                 DSP_En = 0;
                 DSP_Off();
               }
               uc = ' ';
             }
            }

            if(uc == '2')
            {
              linia1(1,24);
                   //123456789012345678901234
              switch(Tryb_44_X)
                {
                  case  48 : piszs("[1]44100 [*]48000       ");
                             break;
                  default  : piszs("[*]44100 [2]48000       ");
                             break;
                }

              uc = getch();

              if((uc>='1')&&(uc<='3'))
              {
                linia1(1,24);
                uc &= 0x03;
                switch(uc)
                  {
                   case  1  :
                   case  3  :  piszs("Sample Rate -> 44100 kHz");
                               Tryb_44_X = 44;
                               break;
                   case  2  :  
                   default  :  piszs("Sample Rate -> 48000 kHz");
                               Tryb_44_X = 48;
                               break;
                  }
                Tryb_44_48(Tryb_44_X);

                delayx(0x00043210);
              }
              uc = ' ';
            }
       }
// ------------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("[1]Virtal Theater,[2]Dim");

           uc = getch();

           if(uc == '1')
           {
             linia1(1,24);
             switch(Virtual_Dim & 0x0100)
               {
                 case  0x000 : piszs("*Virtal Theater Off*");
                               break;
                 case  0x100 : piszs("*Virtal Theater On* ");
                               break;
               }
             delayx(0x00034567);

             linia2(1,24);
                  //123456789012345678901234
             piszs("[0]Off [1]Virtal Theater");

             uc = getch();

             if((uc>='0')&&(uc<='1'))
             {
               linia2(1,24);
               Virtual_Dim = (uc & 0x01) << 8;
               switch(Virtual_Dim & 0x0100)
                 {
                   case  0x000 : piszs("*Virtal Theater Off*");
                                 break;
                   case  0x100 : piszs("*Virtal Theater On* ");
                                 break;
                 }
               delayx(0x00034567);
               Timer_M = 100;
               MUTE_On();
               if((AC3_Ch >= 3) && act_decoder)
                   NormalSurr();
               else
                   CircleSurr();
               Szumy_X();
               while(Timer_M);
               MUTE_Off();

               uc = ' ';
              }
             }

             if(uc == '2')
             {
               linia1(1,17);
               xx = Virtual_Dim & 0x00F;
               if(xx > 9)
               {
                 xx = 9;
                 Virtual_Dim &= 0x0F00;
                 Virtual_Dim += xx;
               }
               piszs("DIMENSION(00)+/- ");
               gotoxy(11,1);
               piszdec(xx + 1, 2);
               delayx(0x00034567);

               uc = getch();
               while((uc != 0x1B)&&(uc != 0x0D))
               {
                 if((uc == '+')&&(xx < 9))
                   xx++;
                 if((uc == '-')&&(xx > 0))
                   xx--;
                 gotoxy(11,1);
                 piszdec(xx + 1, 2);

                 i2c1_write_a(0x8C);
                 i2c1_write_dn(0x07); // Att LR [L Surroud]
                 i2c1_write_de(0xC0 + xx); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

                 i2c1_write_a(0x8C);
                 i2c1_write_dn(0x09); // Att RR, Blank time [L Surroud]
                 i2c1_write_de(0x80 + xx); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db

                 uc = getch();
               }

               if(uc == 0x0D)
               {
                 // Ustaw Dimension
                 Virtual_Dim &= 0x0F00;
                 Virtual_Dim += xx;

                 xx = Virtual_Dim & 0x000F; // 0..9
                 i2c1_write_a(0x8C);
                 i2c1_write_dn(0x07); // Att LR [L Surroud]
                 i2c1_write_de(0xC0 + xx); // C0 -> 0dB, D0 -> -16dB, D4 -> -20dB, DB -> -30dB, DE -> -40db

                 i2c1_write_a(0x8C);
                 i2c1_write_dn(0x09); // Att RR, Blank time [L Surroud]
                 i2c1_write_de(0x80 + xx); // 80 -> 0dB, 90 -> -16dB, 94 -> -20dB, 9B -> -30dB, 9E -> -40db
               }
                 uc = ' ';
             }
       }
// ------------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs("TDA ATT [1]Bass [2]Sopr.");

        uc = getch();
        if(uc > 0x40)
           uc &= 0xDF;

        if(uc == '1')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("TDA Bass(");
            piszdec(TDA_Bass, 1);
            piszs(")[1..8]");

            uc = getch();
            if((uc >= '1')&&(uc <= '8'))
            {
                TDA_Bass = uc & 0x0F;
                TDA_Bass_X = TDA_Bass;
                piszdec(TDA_Bass, 1);
                uc = TDA_Bass - 1;
                uc = 7 - uc;
                uc = uc | 0x08;
                uc = uc << 4;
                uc = uc & 0xF0;
                BassTrebleATT_TDA_4 &= 0x0F;
                BassTrebleATT_TDA_4 |= uc;
                i2c1_write_reg(I2C_TDA7461, 0x04, BassTrebleATT_TDA_4);
                TDA_Vol(TDA_Vol_0 + (TDA_Bass_X>>1));
                delayx(0x00017000);
            }
         uc = ' ';
        }

        if(uc == '2')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("TDA Sopran(");
            piszdec(TDA_Sop, 1);
            piszs(")[1..8]");

            uc = getch();
            if((uc >= '0')&&(uc <= '8'))
            {
                TDA_Sop = uc & 0x0F;
                piszdec(TDA_Sop, 1);
                uc = TDA_Sop - 1;
                uc = 7 - uc;
                uc = uc | 0x08;
                uc = uc & 0x0F;
                BassTrebleATT_TDA_4 &= 0xF0;
                BassTrebleATT_TDA_4 |= uc;
                i2c1_write_reg(I2C_TDA7461, 0x04, BassTrebleATT_TDA_4);
                delayx(0x00017000);
            }
         uc = ' ';
        }
       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs("TDA F[1]Bas.[2]Sopr.[3]Q");

        uc = getch();
        if(uc > 0x40)
           uc &= 0xDF;

        if(uc == '1')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Bass Fr.(");
            uc = Bass_F;
            if((Bass_F == 3)&&(Bass_Q == 3))
                uc = 5;
            switch(uc)
            {
            case    0   :   piszs("1/60 ");
                break;
            case    1   :   piszs("2/70 ");
                break;
            case    2   :   piszs("3/80 ");
                break;
            case    3   :   piszs("4/100");
                break;
            case    4   :   piszs("5/150");
                break;
            }
            piszs(")[1..5] ");

            uc = getch();
            if((uc >= '1')&&(uc <= '5'))
            {
                uc &= 0x07;
                uc = uc - 1; 
                if( uc < 4)
                    Bass_F = uc & 0x03;
                else                    
                    {   // 150Hz
                        Bass_Q = 3;
                        Bass_F = 3;
                    }
                
                Set_BassTreble_F();

                linia2(1,24);
                     //123456789012345678901234
                piszs("Bass Freq. = ");
                switch(uc)
                {
                case    0   :   piszs(" 60");
                    break;
                case    1   :   piszs(" 70");
                    break;
                case    2   :   piszs(" 80");
                    break;
                case    3   :   piszs("100");
                    break;
                case    4   :   piszs("150");
                    break;
                }
                piszs("Hz ");

                uc = Bass_Q;
                switch(uc)
                {
                case    0   :   piszs("Q 1.0");
                    break;
                case    1   :   piszs("Q 1.2");
                    break;
                case    2   :   piszs("Q 1.5");
                    break;
                case    3   :   piszs("Q 2.0");
                    break;
                }

                delayx(0x00017000);
            }
         uc = ' ';
        }

        if(uc == '2')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Sopran Fr.(");
            uc = Sop_F;
            switch(uc)
            {
            case    0   :   piszs("1/10");
                break;
            case    1   :   piszs("2/12");
                break;
            case    2   :   piszs("3/15");
                break;
            case    3   :   piszs("4/17");
                break;
            }
            piszs("k)[1..4] ");

            uc = getch();
            if((uc >= '1')&&(uc <= '4'))
            {
                uc &= 0x07;
                uc = uc - 1; 
                Sop_F = uc & 0x03;

                Set_BassTreble_F();

                linia2(1,24);
                     //123456789012345678901234
                piszs("Sopr. Freq. = ");
                switch(uc)
                {
                case    0   :   piszs("10");
                    break;
                case    1   :   piszs("12");
                    break;
                case    2   :   piszs("15");
                    break;
                case    3   :   piszs("17");
                    break;
                }
                piszs("k");

                delayx(0x00017000);
            }
         uc = ' ';
        }

        if(uc == '3')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Bass Q(");
            uc = Bass_Q;
            switch(uc)
            {
            case    0   :   piszs("Q 1.0");
                break;
            case    1   :   piszs("Q 1.2");
                break;
            case    2   :   piszs("Q 1.5");
                break;
            case    3   :   piszs("Q 2.0");
                break;
            }
            piszs(")[1..4]");

            uc = getch();
            if((uc >= '1')&&(uc <= '4'))
            {
                uc &= 0x07;
                uc = uc - 1; 
                Bass_Q = uc & 0x03;

                Set_BassTreble_F();

                linia2(1,24);
                     //123456789012345678901234
                piszs("Bass Q = ");
                uc = Bass_Q;
                switch(uc)
                {
                case    0   :   piszs("Q 1.0");
                    break;
                case    1   :   piszs("Q 1.2");
                    break;
                case    2   :   piszs("Q 1.5");
                    break;
                case    3   :   piszs("Q 2.0");
                    break;
                }
                piszs(" ");

                delayx(0x00017000);
            }
         uc = ' ';
        }

       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs("MP3[1]Bas.F[2]Sopr.F[3]A");

        uc = getch();
        if(uc > 0x40)
           uc &= 0xDF;

        if(uc == '1')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Bass Fr.(");
            xx = MP3_Bass_F; // MP3_Bass = 3 * Fgraniczna
            switch(xx)
            {
            case  210   :   piszs("1/ 70");
                break;
            case  300   :   piszs("2/100");
                break;
            case  420   :   piszs("3/140");
                break;
            case  600   :   piszs("4/200");
                break;
            default     :   piszs("5/140");
                            MP3_Bass_F = 420;
                break;
            }
            piszs(")[1..4] ");

            uc = getch();
            if((uc >= '1')&&(uc <= '4'))
            {
                uc &= 0x07;
                switch(uc)
                {
                case    1   :   xx = 210;
                    break;
                case    2   :   xx = 300;
                    break;
                case    3   :   xx = 420;
                    break;
                case    4   :   xx = 600;
                    break;
                }
                
                MP3_Bass_F = xx;
                MP3_Bass_Booster();

                linia2(1,24);
                     //123456789012345678901234
                piszs("Bass Freq. = ");
                switch(xx)
                {
                case  210   :   piszs(" 70");
                    break;
                case  300   :   piszs("100");
                    break;
                case  420   :   piszs("140");
                    break;
                case  600   :   piszs("200");
                    break;
                default     :   piszs("140");
                                MP3_Bass_F = 420;
                    break;
                }
                piszs("Hz ");

                uc = MP3_Ton_A;
                switch(uc)
                {
                case    2   :   piszs("ATT 1");
                    break;
                case    3   :   piszs("ATT 2");
                    break;
                case    4   :   piszs("ATT 3");
                    break;
                case    5   :   piszs("ATT 4");
                    break;
                }

                delayx(0x00017000);
            }
         uc = ' ';
        }

        if(uc == '2')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Sopran Fr.(");
            xx = MP3_Sop_F; // MP3_Sop_F = Fgraniczna / 1.75
            switch(xx)
            {
            case    4570   :   piszs("1/8");
                break;
            case    5710   :   piszs("2/10");
                break;
            case    6860   :   piszs("3/12");
                break;
            case    8570   :   piszs("4/15");
                break;
            default:           piszs("3/12");
                               MP3_Sop_F = 6860;
                               break;
            }
            piszs("k)[1..4] ");

            uc = getch();
            if((uc >= '1')&&(uc <= '4'))
            {
                uc &= 0x07;
                switch(uc)
                {
                case    1   :   xx = 4570;
                    break;
                case    2   :   xx = 5710;
                    break;
                case    3   :   xx = 6860;
                    break;
                case    4   :   xx = 8570;
                    break;
                }

                MP3_Sop_F = xx;
                MP3_Sopran_Booster();

                linia2(1,24);
                     //123456789012345678901234
                piszs("Sopr. Freq.= ");

                xx = MP3_Sop_F; 
                switch(xx)
                {
                case    4570   :   piszs("1/8");
                    break;
                case    5710   :   piszs("2/10");
                    break;
                case    6860   :   piszs("3/12");
                    break;
                case    8570   :   piszs("4/15");
                    break;
                }
                piszs("k ");

                uc = MP3_Ton_A;
                switch(uc)
                {
                case    2   :   piszs("ATT 1");
                    break;
                case    3   :   piszs("ATT 2");
                    break;
                case    4   :   piszs("ATT 3");
                    break;
                case    5   :   piszs("ATT 4");
                    break;
                }

                delayx(0x00017000);
            }
         uc = ' ';
        }

        if(uc == '3')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("Tone ATT (");
            uc = MP3_Ton_A;
            switch(uc)
            {
            case    2   :   piszs("1");
                break;
            case    3   :   piszs("2");
                break;
            case    4   :   piszs("3");
                break;
            case    5   :   piszs("4");
                break;
            }
            piszs(")[1..3]");

            uc = getch();
            if((uc >= '1')&&(uc <= '3'))
            {
                uc &= 0x03;
                MP3_Ton_A = uc + 1; // Tone ATT = 2, 3, 4
                MP3_Ton_A &= 0x07;
                 
                MP3_Bass_Booster();
                MP3_Sopran_Booster();

                linia2(1,24);
                     //123456789012345678901234
                piszs("MP3 Tone ATT = ");
                uc = MP3_Ton_A;
                switch(uc)
                {
                case    2   :   piszs("1/3.0dB");
                    break;
                case    3   :   piszs("2/4.5dB");
                    break;
                case    4   :   piszs("3/6.0dB");
                    break;
                case    5   :   piszs("4/7.5dB");
                    break;
                }
                piszs(" ");

                delayx(0x00017000);
            }
         uc = ' ';
        }

       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("[1]Speakers [2]In 5 DIR ");

           uc = getch();

           if(uc == '1')
           {
             linia1(1,24);
                  //123456789012345678901234
             piszs("[1]C,[2]Sub,[3]LS,[4]RS ");

             uc = getch();

             if((uc>='1')&&(uc<='4'))
             {
               linia2(1,24);
               xx = uc & 0x07; 
               switch(xx)
               {
               case  1 : piszs("Centr.(");
                   if(Glosniki & 0x0001)
                       piszs("On)");
                   else
                       piszs("Off)");
                   piszs("[1]+ [2]-");
                   uc = getch();
                   if(uc == '1')
                   {    
                       Glosniki |= 0x0001;
                       piszs(" On ");
                   }
                   if(uc == '2')
                   {    
                       Glosniki &= 0x000E;
                       piszs(" Off");
                   }
                   break;
               case  2 : piszs("Subw.(");
                   if(Glosniki & 0x0002)
                       piszs("On)");
                   else
                       piszs("Off)");
                   piszs("[1]+ [2]-");
                   uc = getch();
                   if(uc == '1')
                   {    
                       Glosniki |= 0x0002;
                       piszs(" On ");
                   }
                   if(uc == '2')
                   {    
                       Glosniki &= 0x000D;
                       piszs(" Off");
                   }
                   break;
               case  3 : piszs("LSurr.(");
                   if(Glosniki & 0x0004)
                       piszs("On)");
                   else
                       piszs("Off)");
                   piszs("[1]+ [2]-");
                   uc = getch();
                   if(uc == '1')
                   {    
                       Glosniki |= 0x0004;
                       piszs(" On ");
                   }
                   if(uc == '2')
                   {    
                       Glosniki &= 0x000B;
                       piszs(" Off");
                   }
                   break;
               case  4 : piszs("RSurr.(");
                   if(Glosniki & 0x0008)
                       piszs("On)");
                   else
                       piszs("Off)");
                   piszs("[1]+ [2]-");
                   uc = getch();
                   if(uc == '1')
                   {    
                       Glosniki |= 0x0008;
                       piszs(" On ");
                   }
                   if(uc == '2')
                   {    
                       Glosniki &= 0x0007;
                       piszs(" Off");
                   }
                   break;
               default: piszs(" NC ");
                   break;
               }
               Glosniki &= 0x000F;
               Wy_7E &= 0xF0;
               Wy_7E |= (char)Glosniki;
               yy = i2c_write_a(0x7E);
               xx = i2c_write_de(Wy_7E);

               delayx(0x00043210);
              }
              uc = ' ';
           }

           if(uc == '2')
           {
             linia1(1,24);
             if(IN_5_DIR)
               piszs("[*]In5 5.1, [2]In5 2.0..");
             else
               piszs("[1]In5 5.1, [*]In5 2.0..");
             uc = getch();
             if(uc != 0x1B)
             {
               if(uc == '1')
                 IN_5_DIR = 1;
               else
                 IN_5_DIR = 0;
               uc = ' ';
             }
           }

       }
// ------------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("Balans[1..5]R,C,Sw,Rs,Ls");

           uc = getch();

           if(uc == '1')
           {
             linia2(1,24);
                  //123456789012345678901234
             piszs("Balans R-Prawy(");
             if(BlR > 3)
               BlR = 3;
             if(BlR < -3)
               BlR = -3;
             if(BlR < 0)
             {
               piszc('-');
               piszdec(-BlR, 0);
             }
             else
             {
               piszc('+');
               piszdec(BlR, 0);
             }
             piszs(") ");
             uc = getch();
             while((uc == '-') || (uc == '+'))
             {
               if(uc == '-')
                 BlR -= 1;
               else
                 BlR += 1;
               if(BlR > 3)
                 BlR = 3;
               if(BlR < -3)
                 BlR = -3;
               Vol_SPK(VOL_SPK);
               gotoxy(16,2);
               if(BlR < 0)
               {
                 piszc('-');
                 piszdec(-BlR, 0);
               }
               else
               {
                 piszc('+');
                 piszdec(BlR, 0);
               }
               piszs(") ");
               uc = getch();

             }
             delayx(0x00043210);
             uc = ' ';
           }

           if(uc == '2')
           {
             linia2(1,24);
                  //123456789012345678901234
             piszs("Balans C-Centralny(");

             Balance(&BlC, 10); 
             delayx(0x00043210);
             uc = ' ';
           }

           if(uc == '3')
           {
             linia2(1,24);
                  //123456789012345678901234
             piszs("Balans Sw-Subwoof.(");

             Balance(&BlS, 20); 
             delayx(0x00043210);
             uc = ' ';
           }

           if(uc == '4')
           {
             linia2(1,24);
                  //123456789012345678901234
             piszs("Balans Rs-PrawyTyl(");

             Balance(&BlRs, 10); 
             delayx(0x00043210);
             uc = ' ';
           }

           if(uc == '5')
           {
             linia2(1,24);
                  //123456789012345678901234
             piszs("Balans Ls-LewyTyl (");

             Balance(&BlLs, 10); 
             delayx(0x00043210);
             uc = ' ';
           }

       }
// --- End Balans -------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs("DELAY:[1]C,[2]LS,[3]RS..");

        uc = getch();
        if(uc > 0x40)
           uc &= 0xDF;

        if(uc == '1')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("C Delay < 6(");
            piszdec(C_DLY, 0);
            piszs(")?");

            ENTER = 0;
            uc = getdec();
            if(ENTER && ((uc >= 0)&&(uc <= 5)))
            {
                C_DLY = uc;
                piszc('<');
                STA_DELAY &= 0xFFFF00FF;
                STA_DELAY |= (uc << 8);
                //Set_Delay();
                delayx(0x00010000);
            }
         uc = ' ';
        }

        if(uc == '2')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("LS Delay < 46(");
            piszdec(LSxDLY, 0);
            piszs(")?");

            ENTER = 0;
            uc = getdec();
            if(ENTER && ((uc >= 0)&&(uc <= 45)))
            {
                LSxDLY = uc;
                piszc('<');
                STA_DELAY &= 0xFF00FFFF;
                STA_DELAY |= (uc << 16);
                //Set_Delay();
                delayx(0x00010000);
            }
         uc = ' ';
        }

        if(uc == '3')
        {
            linia2(1,24);
                 //123456789012345678901234
            piszs("RS Delay < 46(");
            piszdec(RSxDLY, 0);
            piszs(")?");

            ENTER = 0;
            uc = getdec();
            if(ENTER && ((uc >= 0)&&(uc <= 45)))
            {
                RSxDLY = uc;
                piszc('<');
                STA_DELAY &= 0x00FFFFFF;
                STA_DELAY |= (uc << 16);
                //Set_Delay();
                delayx(0x00010000);
            }
         uc = ' ';
        }

       }
// ---------------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
           linia2(1,24);
                //123456789012345678901234
           piszs("[1]ADCATT [2]Power[3]IMP"); // [Z]-Test zapisu.

          uc = getch();
          if(uc > 0x40)
             uc &= 0xDF;

          if(uc == '1')
          {
            linia2(1,24);
                 //123456789012345678901234
            piszs("[+/-] ADC ATT["); // [Z]-Test zapisu.
            piszhl(WM_IN);
            piszs("]=");
            piszdec(ADC_ATT[WM_IN],2);
            piszc(' ');

            uc = getch();
            while((uc == '+') || (uc == '-'))
            {
              if((uc == '+') && (ADC_ATT[WM_IN] < 0x1F))
              {
                ADC_ATT[WM_IN]++;
              }
              if((uc == '-') && ADC_ATT[WM_IN])
              {
                ADC_ATT[WM_IN]--;
              }
              write_WM8770(0x19, ADC_ATT[WM_IN]); // ADC_ATT_L(4:0); 0->-12dB, 0C->0dB, 1F->+19dB 
              write_WM8770(0x1A, ADC_ATT[WM_IN]); // ADC_ATT_R(4:0); 0->-12dB, 0C->0dB, 1F->+19dB
              linia2(19,24);
              piszdec(ADC_ATT[WM_IN],2);
              piszc(' ');

              uc = getch();
            }

            if(ADC_ATT[7] > 23)
                ADC_ATT[7] = 23;
            if(ADC_ATT[7] < 16)
                ADC_ATT[7] = 16;

            switch(WM_IN)
            {
            case 0 :  ADC_ATTL &= 0x1F1F1F00;
                      ADC_ATTL |= ADC_ATT[0];
                      break;
            case 1 :  ADC_ATTL &= 0x1F1F001F;
                      ADC_ATTL |= (ADC_ATT[1] << 8);
                      break;
            case 2 :  ADC_ATTL &= 0x1F001F1F;
                      ADC_ATTL |= (ADC_ATT[2] << 16);
                      break;
            case 3 :  ADC_ATTL &= 0x001F1F1F;
                      ADC_ATTL |= (ADC_ATT[3] << 24);
                      break;
            case 4 :  ADC_ATTH &= 0x1F1F1F00;
                      ADC_ATTH |= ADC_ATT[4];
                      break;
            case 5 :  ADC_ATTH &= 0x1F1F001F;
                      ADC_ATTH |= (ADC_ATT[5] << 8);
                      break;
            case 6 :  ADC_ATTH &= 0x1F001F1F;
                      ADC_ATTH |= (ADC_ATT[6] << 16);
                      break;
            case 7 :  ADC_ATTH &= 0x001F1F1F;
                      ADC_ATTH |= (ADC_ATT[7] << 24);
                      break;
            }
            Flag_C = 0x534F4D43; // Flaga 'CMOS'
            uc = ' ';
          }

          if(uc == '2')
          {  
            Menu_Power();
            Flag_C = 0x534F4D43; // Flaga 'CMOS'
            uc = ' ';
          }

          if(uc == '3')
          {
            linia2(1,24);
                 //123456789012345678901234
            piszs("1-Przyciki 2-IMPULSATOR ");

            uc = getch();
            if(uc == '2')
                IMPULSATOR = 1;
            else
                IMPULSATOR = 0;
            Flag_C = 0x534F4D43; // Flaga 'CMOS'
            uc = ' ';
          }
       }
// ---------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
          linia2(1,24);
               //123456789012345678901234
          piszs("[1] Ustaw czas/date ... "); // [Z]-Test zapisu.

          uc = getch();
          if(uc == '1')
            Ustaw_czas();
          uc = ' ';
       }
// -----------------------------------------------------------------------

       if((uc == '0') || (uc == 0x0D))
       {
         linia2(1,24);
              //123456789012345678901234
         piszs(" END/STOP               ");

         delayx(0x00023210);
         uc = ' ';
       }

//        if(uc == '2')
//           uc = uc_Make_Directory;

//        if(uc == 'Z')
//           uc = uc_Test_Zapisu;
// ----------------------------------------------------------------------------------------------------
   }
// END MENU ===========================================================================================

   if((uc >= '0') && (uc <= '9'))
   {
       Ustaw_WE_Q(uc);
       uc = ' ';
   }


// WM8770 OUT ---------------------------------------
           if(uc == 'w')
               {
                piszc(8);
                WM_OUT_MX++;
                WM_OUT_MX &= 0x07;

                // 0-MUTE, 1-DAC, 2-AUX, 4-Bypass, 3-AUX/DAC, 5-Byp./DAC, 6-Byp./AUX, 7-AUX/Byp./DAC
                WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX);
               }

// WM8770 OUT ---------------------------------------
           if((uc == 'e') || (uc == uc_Wejscie))
           {
            piszc(8);
            gotoxy(1,2);
            linia2(1,24);
            //     123456789012345678901234
            piszs("[1-7]WE[8]Radio [9]SPDIF"); // MENU
            gotoxy(1,2);

            xx = 0x007F & getch();

            Ustaw_WE(xx);

            uc = ' ';
           }

// Przelaczanie wejsc =================================================================
   if((uc == '<') || (uc == '>'))
   {
     xx = Input & 0x003F;
     if(xx) // Wejscia
     {
         yy = xx;
         if(uc == '<')
         {
           if((xx >= 1) && (xx <= 7))
             yy--;
           if(!xx)
             yy = 0x3F;
           if(xx & 0x08)
           {
             if(xx > 0x0F)
               yy = xx - 0x10;
             else
               yy = 0x07; 
           }
         }
         if(uc == '>')
         {
           if((xx >= 0) && (xx < 7))
             yy++;
           if(xx == 0x07)
             yy = 0x0F;
           if(xx & 0x08)
           {
             if(xx == 0x3F)
               yy = 0x00;
             else
               yy = xx + 0x10; 
           }
         }
         if(yy & 0x08)
         {  
           SPDIF = 1;
           MUXS = yy >> 4;
         }
         Input = yy;
         if(!(Input & 8))
           Last_Input_7 = Input;
    
         gotoxy(1,1);
         piszs("Set Input..");
    
         Set_Input();
         SPDIFOut(1);
         //Set_Delay();
    
         Rec_RAM(); // <------------------------------------------------------------- REC RAM ------------------
         if(Szumy() > 0x0271EEEE) // 0x0321EEEE
         {
           Set_Input();
           SPDIFOut(1);
           //Set_Delay();
         }
    
     }
     else
     { // Programy radiowe
         if(uc == '<')
         {    
             if(_FM_x)
                 _FM_x--;
             else
                 _FM_x = 8;
         }
         if(uc == '>')
         {    
             if(_FM_x < 8)
                 _FM_x++;
             else
                 _FM_x = 0;
         }
         Ustaw_Prg(_FM_x + 1);
     }
     uc = ' ';
   }

// Audio Graj sektory -------------------------------
   if(uc == 'a')
   {
    VICVectAddr31 = (uint32_t) Irq_I2S_Tx; // I2S_Tx; I2S_Rx

    piszs("\010\n\r");
    piszs("GRAJ - Podaj sektor:");
    xx = gethex();
    piszs(" SEC=");piszhex(xx);

    if(SD_SECTORS > xx)
	  {
     secl = xx;
     sech = secl + 47;
     Zapal_SD;
     read_n_sec();
     Zgas_SD;
     secl = secl + 48;
     sech = secl + 15;

     i2s_x=4; // 4
     i2s_y=4; // 4
     i2s_o=0; // 0
     i2s_b=0; // 0 lub 8

     for(f=0;f<8;f++)
     {
      I2S_TX_FIFO = 0;
     }

     xx = i2s_o;

     I2S_IRQ = 0 + 0x0002 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx

     while(1)
     {
      if(xx != i2s_o)
      {
       xx = i2s_o;
       piszc('^');
      }
      /*if((I2S_STATE>>16)>=4)
      {
       for(f=0;f<4;f++)
       {
        I2S_TX_FIFO = Buf_I2S_32[i2s_x];
        i2s_x++;
       }
       if(i2s_x >= 6144)
       {
        i2s_x = 0;
        i2s_o++;
       }
      }*/
      if(i2s_b & 1)
      {
       DI;i2s_b &= 0x0E;EI;
       Zapal_SD;
       read_n_sec_x(0x2000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(i2s_b & 2)
      {
       DI;i2s_b &= 0x0D;EI;
       Zapal_SD;
       read_n_sec_x(0x4000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(i2s_b & 4)
      {
       DI;i2s_b &= 0x0B;EI;
       Zapal_SD;
       read_n_sec_x(0x6000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(KlawX()==0x1B)
      {
       piszc('<');
       break;
      }
     }
// wylacz przerwania IRG_tx(02)
     I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx    

// Wypelnij FIFO wartosciami (0x0303)771/(0xFCFC)-771 bo TX bedzie nadawac w nieskonczonosc !
     for(f=0;f<4;f++)
     {
      I2S_TX_FIFO = 0x01000100; // 1 1
      I2S_TX_FIFO = 0xFEFFFEFF; // -1 -1
     }

     piszs(" x=");piszhex(i2s_x);
     piszs(" y=");piszhex(i2s_y);
     piszs(" o=");piszhex(i2s_o);
     piszs(" SEC=");piszhex(sech + 1);
    }
   }

// (Audio Nagrywaj sektory) -------------------------------
   //if(uc == 'A')
   //{

    /* VICVectAddr31 = (uint32_t) Irq_I2S_Rx; // I2S_Tx; I2S_Rx

    piszs("\010\n\r");
    piszs("Nagraj - Podaj sektor:");
    xx = gethex();
    if(ENTER && !ESC)
    {
    
     piszs(" SEC=");piszhex(xx);
     piszs(" REC.. ");

     secl = xx;
     sech = secl + 15;

     i2s_x=4; // 4
     i2s_y=4; // 4
     i2s_o=0; // 0
     i2s_b=0; // 0 lub 8

     xx = i2s_o;

     I2S_IRQ = 0x0001 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx

     while(1)
     {
      if(xx != i2s_o)
      {
       xx = i2s_o;
       piszc('^');
      }
    if((I2S_STATE>>8)<=4)
     {
      for(f=0;f<4;f++)
      {
       Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
       i2s_x++;
      }
      if(i2s_x >= 6144)
      {
       i2s_x = 0;
       i2s_o++;
      }
     }
      if(i2s_b & 1)
      {
       DI;i2s_b &= 0x0E;EI;
       Zapal_SD;
       write_n_sec_x(0x2000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(i2s_b & 2)
      {
       DI;i2s_b &= 0x0D;EI;
       Zapal_SD;
       write_n_sec_x(0x4000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(i2s_b & 4)
      {
       DI;i2s_b &= 0x0B;EI;
       Zapal_SD;
       write_n_sec_x(0x6000);
       Zgas_SD;
       secl = secl + 16;
       sech = secl + 15;
      }
      if(KlawX()==0x1B)
      {
       piszc('<');
       break;
      }
     }
// Wylacz przerwania IRQ_rx(01)
     I2S_IRQ = 0 + 0 + (4<<8) + (4<<16); // IRQ_rx(01), IRG_tx(02), FIFO_level_rx, FIFO_level_tx    

     piszs(" x=");piszhex(i2s_x);
     piszs(" y=");piszhex(i2s_y);
     piszs(" o=");piszhex(i2s_o);
     piszs(" SEC=");piszhex(sech + 1);
    }
    else
      piszs(" No REC ");*/
   //}

// MP3 Graj sektory -------------------------------
/*   if(uc == 'N')
   {
    piszs("\010\n\r");
    piszs("GRAJ MP3 - Podaj sektor:");
    xx = gethex();
    piszs(" SEC=");piszhex(xx);

    i2c_write_STA015(0x46, 0x7F);  // DLA ATT
    i2c_write_STA015(0x48, 0x7F);  // DRA ATT

    secl = xx;
    sech = secl + 47;
    Zapal_SD;
    read_n_sec();
    Zgas_SD;
    secl = secl + 48;
    sech = secl + 15;

    i2s_x=0; // 0
    i2s_y=0; // 0
    i2s_o=0; // 0
    i2s_b=7; // 7

    CTRL1B = CTRL1;
    CTRL1 = 0x43;
    LD_Latch_n(CTRL1, 1);

	  CTRL2B = CTRL2;
    CTRL2 = 0x45;
    LD_Latch_n(CTRL2, 2);

    CTRL3B = CTRL3;
    CTRL3 = 0x5A;
    LD_Latch_n(CTRL3, 3);

    BIT_EN_1;
    i2c_write_STA015(0x72, 0x01);  // RUN_MODE
    piszs(" STA015_RUN.. 12");
	
    ARM_CPSR = enableIRQ();
    // T2MCR T0MCR = 0x0003; // 0x0003 INTERRUPT
    Mp3_P = 1;

// Fade In
    for(f = 0x0028;f >= STA015_ATT;f = f-2)
    {
     i2c_write_STA015(0x46, f);  // DLA ATT
     i2c_write_STA015(0x48, f);  // DRA ATT
    }

    xx = i2s_o;

    while(1)
    {
     if(xx != i2s_o)
      xx = i2s_o;
     if(i2s_b & 0x0100)
     {
      delayx(0x00003210);
      DI;i2s_b &= 0x0E0E;EI;
      Zapal_SD;
      read_n_sec_x(0x2000);
      Zgas_SD;
      secl = secl + 16;
      sech = secl + 15;
      DI;i2s_b |= 0x0001;EI;
      piszc('1'); 
     }
     if(i2s_b & 0x0200)
     {
      delayx(0x00003210);
      DI;i2s_b &= 0x0D0D;EI;
      Zapal_SD;
      read_n_sec_x(0x4000);
      Zgas_SD;
      secl = secl + 16;
      sech = secl + 15;
      DI;i2s_b |= 0x0002;EI;
      piszc('2');
     }
/*     if(i2s_b & 0x0400)
     {
      delayx(0x00003201);
      DI;i2s_b &= 0x0B0B;EI;
      Zapal_SD;
      read_n_sec_x(0x6000);
      Zgas_SD;
      secl = secl + 16;
      sech = secl + 15;
      DI;i2s_b |= 0x0004;EI;
      piszc('3');
     } */
/*     if(KlawX()==0x1B)
     {
      piszc('<');
      break;
     }
    }

    for(f=6143;f>=0;f--)
     Buf_I2S_32[f] = 0xFFFF0000;

    delayx(0x0002FFFF);

    Mp3_P = 0;
    BIT_EN_0;

    delayx(0x00018888);

    i2c_write_STA015(0x13, 0x01);  // PLAY
    i2c_write_STA015(0x14, 0x00);  // MUTE

    i2c_write_STA015(0x72, 0x00);  // RUN_MODE

    piszs(" STA015_STOP ");

    CTRL1 = CTRL1B;
    LD_Latch_n(CTRL1, 1);

    CTRL2 = CTRL2B;
    LD_Latch_n(CTRL2, 2);

    CTRL3 = CTRL3B;
    LD_Latch_n(CTRL3, 3);

    piszs(" x=");piszhex(i2s_x);
    piszs(" y=");piszhex(i2s_y);
    piszs(" o=");piszhex(i2s_o);
    piszs(" SEC=");piszhex(sech + 1);
   }

// STA015 - DSP ON/OFF   
   if(uc == 'b')
   {
    //i2c_write_STA015(0x05, 0x81);  // OCLK_IN
   if(!Flag_B)
   {
// STA015 - DSP ON
    Flag_B = 1;

    i2c_write_STA015(0x72, 0x00);  // RUN_MODE	

    CTRL1BB = CTRL1;
    CTRL1 = 0x43;
    LD_Latch_n(CTRL1, 1);

	  CTRL2BB = CTRL2;
    CTRL2 = 0x45;
    LD_Latch_n(CTRL2, 2);

    CTRL3BB = CTRL3;
    CTRL3 = 0x5A;
    LD_Latch_n(CTRL3, 3);
	
    i2c_write_STA015(0xBB, 0x01);  // ADC_EN
    i2c_write_STA015(0x4D, 0x04);  // CHIP_MODE

    delayx(0x00003210);
    i2c_write_STA015(0x72, 0x01);  // RUN_MODE	
	
	  piszs("\n\rSTA015 DSP ON ! ");
   }
   else
   {
// ----------------------------------------------
// STA015 - DSP OFF
    Flag_B = 0;

    i2c_write_STA015(0x72, 0x00);  // RUN_MODE	

    CTRL1 = CTRL1BB;
    LD_Latch_n(CTRL1, 1);

    CTRL2 = CTRL2BB;
    LD_Latch_n(CTRL2, 2);

    CTRL3 = CTRL3BB;
    LD_Latch_n(CTRL3, 3);

    //i2c_write_STA015(0x05, 0xA1);  // OCLK_IN


    i2c_write_STA015(0xBB, 0x00);  // ADC_EN
    i2c_write_STA015(0x4D, 0x00);  // CHIP_MODE

    delayx(0x00003210);
    i2c_write_STA015(0x72, 0x01);  // RUN_MODE	

    piszs("\n\rSTA015 DSP OFF ");
   }
  } */

// Ustaw czas/date
   if((uc == 'z') || (uc == uc_Ustaw_czas))
   {
       Ustaw_czas();
   }



// STA015 - Sopran    
   if(uc == 'S')
   {
    MP3_Sopran_Booster();
    gotoxy(9,2);
	  piszs(" Sopran Enhance ");
   }
   
// STA015 - BASS   
   if(uc == 'X')
   {
    MP3_Bass_Booster();   
    gotoxy(9,2);
    piszs(" Bass Enhance   ");
   }
   
// STA015 - Bez Barwy Tonu   
   if(uc == 'Z')
   {
    MP3_Booster_Off();
    gotoxy(9,2);
    piszs(" Bass,Sopran Off");
   }
   
// Dump memory --------------------------------------
   if(uc == 'd')
   {
    piszs("\010\n\r");
        gotoxy(1,1);
    piszs("Dump MEM ADR:");
    xx = gethex();
    piszc('<');
    if(xx <= 0x0000FF00) // dla 2368 0x00007F00
    {
     piszs("\n\r");
     for(ff=xx;ff<(xx+256);ff += 32)
     {
      if(ff<256)
      piszs("00");
      piszhex(ff);
      piszs(":");
      for(f=0;f<32;f++)
      {
       piszc(' ');
       if((f==8)||(f==16)||(f==24)) 
       {
        piszs("| ");
       }
       piszhex(Tab_8[ff+f]);
      }
      piszs("  ASCII -> ");
      for(f=0;f<32;f++)
      {
       yy=Tab_8[ff+f];
       if((yy<32)||(yy>127)) 
        piszc('.');
       else
        piszc(yy);
      }
      piszs("\n\r");
     }
    }
    else
     piszs(" adres poza zakresem RAM'u !\n\r");
   }

// Set memory --------------------------------------
  if(uc == 's')
  {
   piszs("\010\n\r");
       gotoxy(1,1);
   piszs("Set MEM ADR:");
   xx = gethex();
   piszc('<');
   if(xx <= 65535)      // Dla 2368 32767
   for(ff=xx;ff<=65535;ff++)    // Dla 2368 32767
   {
    piszc('(');piszhex(Tab_8[ff]);piszc(')');piszc('=');
    yy = gethex();
    if(ESC)
    {
     piszc('<');
     break;
    }
    else
     if(ENTER)Tab_8[ff]=yy & 0x000000FF;
    if(ff < 65534)      // Dla 2368 32767
        piszc(',');
    piszhex(ff + 1);
   }
   else
    piszs(" adres za duzy RAM'u !\n\r");
  }


// Test ---------------------------
//   if(uc == 'h')
//   {
//    piszs("\n\rPodaj liczbe HEX:");
//        gotoxy(1,1);
//    xx = gethex();
//    if(xx >= 0)
//    {
//     piszc('=');
//     piszdec(xx, 0);
//    }

// GLOSNOSC/Volume SL/PH
  if((uc == ',') || (uc == '.'))
  {
         VOL_PH &= 0x1F; // Att: 0x1F-Mute, 0x00-Max.
         piszc(8);
         gotoxy(18,1);
         piszs(" PH(");

         if(uc == '.') // '+'
         {
           if(VOL_PH)
             VOL_PH--;
         }
         else
         {
           if(VOL_PH < 0x1F)
             VOL_PH++;
         }
         Vol_PH(VOL_PH);
         piszdec(0x1F - VOL_PH, 2);
         piszc(')');
         delayx(0x00007654);
  }

// GLOSNOSC/Volume GL/SPK
  if((uc == '+') || (uc == '-'))
  {
         VOL_SPK &= 0x7F;
         piszc(8);
         gotoxy(18,1);
         piszs(" SP(");

         Set_Vol_SPK(uc);

         if(VOL_SPK > 28)
             piszdec(VOL_SPK - 28, 2); // 01..99
         else
             piszs("00"); // dla 0x1A, 0x1B, 0x1C -> 00
         piszc(')');
         delayx(0x000007654);
  }

// Test ---------------------------
/*           if(uc == 'p')
           {
            // SPI1 -> SRAM
            CS_SRAM_0; // CS_SRAM#
            xx = SPI1(0x01); // Write WRSR 23K256 
            xx = SPI1(0x81); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
            CS_SRAM_1; // CS_SRAM#

            for(f=0;f<10000;f++)
            {
             CS_SRAM_0; // CS_SRAM#
             xx = SPI1(0x05); // Read RDSR 23K256 
             xx = SPI1(0xFF); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
             CS_SRAM_1; // CS_SRAM#
             if(xx == 0x81)
			        break;
			       else
             {
              CS_SRAM_0; // CS_SRAM#
              xx = SPI1(0x01); // Write WRSR 23K256 
              xx = SPI1(0x81); // MODE: Byte - 0x01; Pagre(32) - 0x81; Sequent - 0x41  
              CS_SRAM_1; // CS_SRAM#
			       }
            }

            piszs("M:");piszhl(xx);

            CS_SRAM_0; // CS_SRAM#
            xx = SPI1(0x02); // Write 23K256
            xx = SPI1(0x00); // Adres H
            xx = SPI1(0x20); // Adres L
            for(f=0;f<32;f++)
             xx = SPI1(f+0x41);
            CS_SRAM_1; // CS_SRAM#
            piszs("........................");
            piszc(' ');

            CS_SRAM_0; // CS_SRAM#
            xx = SPI1(0x03); // Read 23K256
            xx = SPI1(0x00); // Adres H
            xx = SPI1(0x20); // Adres L
            for(f=0;f<32;f++)
             Buf_8[f] = SPI1(0x00FF);
            CS_SRAM_1; // CS_SRAM#

            for(f=0;f<32;f++)
             {
              piszs(" d:");
              piszhl(Buf_8[f]);
             }

            piszc(' ');
           } */

// Test --------------------------- Ustaw X
           if(uc == 'U')
           {
            // Ustaw X

              piszc(8); // Backspace
                  gotoxy(1,1);
              piszs("[1,2,3]Ustaw_Latch(1,2,3);[4]Set_DD;[5]Set_DSP ");
              switch(0x00FF & getch())
              {
              case 0x31 : piszs("CTRL1(");
                          piszhex(CTRL1);piszs(")=");
                          xx = gethex();
                          if(xx != -1)
                          {
                           CTRL1 = xx;
                           LD_Latch_n(xx, 1);
                           piszs("< ");
                          }
                          break;
              case 0x32 : piszs("CTRL2(");
                          piszhex(CTRL2);piszs(")=");
                          xx = gethex();
                          if(xx != -1)
                          {
                           CTRL2 = xx;
                           LD_Latch_n(xx, 2);
                           piszs("< ");
                          }
                          break;
              case 0x33 : piszs("CTRL3(");
                          piszhex(CTRL3);piszs(")=");
                          xx = gethex();
                          if(xx != -1)
                          {
                           CTRL3 = xx;
                           LD_Latch_n(xx, 3);
                           piszs("< ");
                          }
                          break;
              case 0x34 : piszs("CTRL2|0x10");
                          xx = CTRL2;
                          xx |= 0x0010;
                          CTRL2 = xx;;
                          LD_Latch_n(xx, 2);
                          DSP_En = 0;
                          DSP_Off();
                          piszs("< ");
                          break;
              case 0x35 : piszs("CTRL2&0x6E");
                          xx = CTRL2;
                          xx &= 0x006E;
                          CTRL2 = xx;;
                          LD_Latch_n(xx, 2);
                          DSP_En++;
                          DSP_On();
                          piszs("< ");
                          break;
              default:    piszs("-Parametr error ! ");
                          break;
              }
           }

// Test --------------------------- Ustaw X
           if(uc == 'u')
           {
           // Ustaw X
           piszc(8);
               gotoxy(1,1);
           piszs("Ustaw:1=TDA7461, 2=SAA6588, 3=STA310(w), 4=STA310(r), 5=STA310(L), ");
           piszs("6=STA310(R) 7=RDR(r), 8=ABCD, 9=RDS: ");
           cx = 0x00FF & getch();
           cx = cx - 0x30;
           xx = 1;
           switch(cx)
           {
            case 1: piszc(8); // Backspace
                    piszs(" 7461");
                    while(xx != 0x1B)
                    {
                        piszs(" a:");
                        xx = gethex();
                        if(ENTER && !ESC)
                        {
                            piszs(", d:");
                            yy = gethex();
                            if(ENTER && !ESC)
                            {
                                i2c1_write_a(0x8C);
                                i2c1_write_dn(xx);
                                i2c1_write_de(yy);
                                piszs("< ");
                            }
                            else
                                piszs(" NACK ");
                        }
                        xx = getch();
                        piszc(8);
                    }
                    break;

            case 2: piszc(8); // Backspace
                    piszs(" 6588");
                    while(xx != 0x1B)
                    {
                        piszs(" d1:");
                        xx = gethex();
                        if(ENTER && !ESC)
                        {
                            piszs(", d2:");
                            yy = gethex();
                            piszs(", d3:");
                            mx = gethex();
                            if(ENTER && !ESC)
                            {
                                if(i2c1_write_a(0x22) >= 0)
                                {
                                    i2c1_write_dn(xx);
                                    i2c1_write_dn(yy);
                                    i2c1_write_de(mx);
                                    piszs("< ");
                                }
                                else	
                                    piszs(" NACK ");
                            }
                            else
                                piszs(" NENT ");
                        }
                        for(f=0; f<8; f++)
                        {
                            RDS_str[f] = '.';
                        }
                        RDS_str[8] = 0;
                        xx = getch();
                        piszc(8);
                    }
                    break;
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           case 3: piszc(8); // Backspace
                   piszs(" STA310");
                   while(xx != 0x1B)
                   {
                       piszs(" a:");
                       xx = gethex();
                       if(ENTER && !ESC)
                       {
                           piszs(", d:");
                           yy = gethex();
                           if(ENTER && !ESC)
                           {
                               if(i2c_write_a(DDAdr) >= 0)
                               {
                                   i2c_write_dn(xx);
                                   i2c_write_de(yy);
                                   piszs("< ");
                               }
                               else	
                                   piszs(" NACK ");
                           }
                           else
                               piszs(" NENT ");
                           xx = getch();
                           piszc(8);
                       }
                   }
                   break;
        case 4:
        // TEST DD/STA310/
        if(DDAdr)
        {
            piszs("\n\r");

            piszs("STA_IRQB[");
            if(STA_IRQB)
              {
               piszs("1]\n\r");
              }
            else
              {
               piszs("0]\n\r");
              }

            for(f = 0; f <= 0xBF; f++)
            {
                piszhex(f);
                piszc('=');
                piszhex(i2c_read_reg(DDAdr, f));
                piszc(' ');

                if((f & 0x03) == 0x03)
                    piszs(" | ");
                if((f & 0x0F) == 0x0F)
                    piszs("\n\r");

            }
        }
        break;

        case 5:    piszc(8); // Backspace
                   piszs(" STA310-Load:\n\r");

                   i2c_write_reg(DDAdr, 0x10, 0x01); // SOFTRESET (5 linii)
                   i2c_write_reg(DDAdr, 0x2B, 0x08); // BRAKPOINT
                   i2c_write_reg(DDAdr, 0x3A, 0x00); // CLOCKCMD
                   while(i2c_read_reg(DDAdr, 0xFF) != 1); // Czekaj na Boot RAM
                   i2c_write_reg(DDAdr, 0xB5, 0x01); // Enable use audio PLL

                   f=0x2000;
                   xx=Tab_8[f];
                   while(xx && (xx != 0x00FF))
                   {
                       f++;
                       yy = Tab_8[f];
                       if(i2c_write_a(DDAdr) >= 0)
                           {
                               i2c_write_dn(xx);
                               i2c_write_de(yy);
                               piszhex(xx);
                               piszc('=');
                               piszhex(yy);
                               piszs("< ");
                           }
                       else	
                               piszs(" NACK ");
                       f++;
                       xx=Tab_8[f];
                   }
                   break;

           case 6:
           // TEST DD/STA310/
           if(DDAdr)
           {
               piszs("\n\r Reset STA310 ..");
               for(f = 0x40; f <= 0xFE; f++)
               {
                   piszhex(f);
                   piszc(',');
                   piszhex(i2c_write_reg(DDAdr, f, 0));
                   if((f & 0x03) == 0x03)
                       piszs(" ");
                   if((f & 0x0F) == 0x0F)
                       piszs("\n\r");

               }
           }
           break;
//----------------------------------------------------------------
           case 7:  piszc(8); // Backspace
                    /*i2c1_write_a(0x22);
                    i2c1_write_dn(0x20); // RESET
                    i2c1_write_dn(0x00);
                    i2c1_write_de(0x00);
                    delayx(100);
                    i2c1_write_a(0x22);
                    i2c1_write_dn(0xF2);
                    i2c1_write_dn(0xA0);
                    i2c1_write_de(0x64);
                    delayx(20);
                    i2c1_write_a(0x22);
                    i2c1_write_dn(0xD2);
                    i2c1_write_dn(0xA0);
                    i2c1_write_de(0x66);*/
                    piszs("\n\r RDS: ");
                    for(f=0; f<64; f++)
                    {
                        
                    Timer_1 = 100;
                    while((FIO3PIN & DAVN_M) && Timer_1); // czekam na DAVN = '0'
                    if((FIO3PIN & DAVN_M)==0)
                        piszc('^');
                    else
                        piszc(' ');
                    c1 = i2c1_read_a1(0x23);
                    if(c1 >= 0)
                    {
                        c2 = i2c1_read_dn();
                        c3 = i2c1_read_dn();
                        c4 = i2c1_read_dn();
                        c5 = i2c1_read_dn();
                        c6 = i2c1_read_dn();
                        c7 = i2c1_read_de();

                        if((f & 0x01) == 0)piszs("\n\r ");

                        // Dane RDS
                        xx = c7 & 0xE0;
                        yy = c6 & 0x03; // Error Lavel
                        mx = 0;
                        if((xx < 0x70) && (yy < 3)) // poprzedni blok
                        {
                            switch(xx)
                            {
                            case    0x00   :   RDSA = (c4 << 8) + c5;
                                            break;
                            case    0x20   :   RDSB = (c4 << 8) + c5;
                                            mx++;
                                            break;
                            case    0x40   :   RDSC = (c4 << 8) + c5;
                                            break;
                            case    0x60   :   RDSD = (c4 << 8) + c5;
                                            break;
                            }
                        }
                        xx = c1 & 0xE0;
                        yy = c1 & 0x03; // Error Lavel
                        if((xx < 0x70) && (yy < 3)) // 0x10 = '1' oznacza synchronizacje
                        {
                            switch(xx)
                            {
                            case    0x00   :   RDSA = (c2 << 8) + c3;
                                            break;
                            case    0x20   :   RDSB = (c2 << 8) + c3;
                                            mx++;
                                            break;
                            case    0x40   :   RDSC = (c2 << 8) + c3;
                                            break;
                            case    0x60   :   RDSD = (c2 << 8) + c3;
                                            break;
                            }
                        }
                        if((RDSB & 0xF800) == 0 ) // Grupa 0A
                        {
                            mx = RDSB & 0x0003; // index znakow
                            switch(mx)
                            {
                            case    0x00  : if(RDSD)
                                            {
                                            RDS_str[0] = RDSD >> 8;
                                            RDS_str[1] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x01  : if(RDSD)
                                            {
                                            RDS_str[2] = RDSD >> 8;
                                            RDS_str[3] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x02  : if(RDSD)
                                            {
                                            RDS_str[4] = RDSD >> 8;
                                            RDS_str[5] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x03  : if(RDSD)
                                            {
                                            RDS_str[6] = RDSD >> 8;
                                            RDS_str[7] = RDSD & 0x00FF;
                                            }
                                            break;   
                            }
                        }
                        piszs(RDS_str);
                        piszc('`');
                        piszhl(c1);
                        piszc('/');
                        piszhl(c2);
                        piszhl(c3);
                        piszc('/');
                        piszhl(c4);
                        piszhl(c5);
                        piszc('/');
                        piszhl(c6);
                        piszc('`');
                        piszhl(c7);
                        piszs(" B:");
                        piszhl(RDSB >> 8);
                        piszhl(RDSB & 0x00FF);
                        piszs(" D:");
                        piszhl(RDSD >> 8);
                        piszhl(RDSD & 0x00FF);
                        piszs(", ");
                        piszc(RDSD >> 8);
                        piszc(RDSD & 0xFF);
                        Tab_8[(f*8)+0x2000] = c1;
                        Tab_8[(f*8)+0x2001] = c2;
                        Tab_8[(f*8)+0x2002] = c3;
                        Tab_8[(f*8)+0x2003] = c4;
                        Tab_8[(f*8)+0x2004] = c5;
                        Tab_8[(f*8)+0x2005] = c6;
                        Tab_8[(f*8)+0x2006] = c7;
                        Tab_8[(f*8)+0x2007] = RDSB;
                    }
                    else	
                        piszs(" NACK ");
                    }
                    break;

           case 8:  piszc(8); // Backspace ABCD
                    //i2c1_write_a(0x22);
                    //i2c1_write_de(0x20); // RESET
                    //delayx(20);
                    //i2c1_write_a(0x22);
                    //i2c1_write_de(0xD2);

                    piszs("\n\r RDS: ");
                    for(f=0; f<80; f++)
                    {
                        for(ff = 0; ff < 8; ff++)
                        {
                          RDS_In[ff] = 0; // A, B, C, D
                          RDSt[ff] = 0; // 0x10, 0x30, 0x50, 0x70
                        }

                        my = 0;
                        cx = 0;
                        cy = 0;

                        for(ff = 0; ff < 8; ff += 2)
                        {
                         // Pobirz max 8 slow
                         Timer_1 = 50;
                         while((FIO3PIN & DAVN_M) && Timer_1); // czekam na DAVN = '0'
                         if((FIO3PIN & DAVN_M)==0)
                          c1 = i2c1_read_a1(0x23);
                         if(c1 >= 0)
                         {    
                          c2 = i2c1_read_dn();
                          c3 = i2c1_read_dn();
                          c4 = i2c1_read_dn();
                          c5 = i2c1_read_dn();
                          c6 = i2c1_read_dn();
                          c7 = i2c1_read_de();
                         }
                         mx = c1 & 0xF0;
                         if(mx == 0xF0)
                             cy++;

                         // mx = 0x10 -> A1, D0
                         // mx = 0x30 -> B1, A1
                         // mx = 0x50 -> C1, B1
                         // mx = 0x70 -> D1, C1

                         // Sekwencje 'dobre': 0x30, 0x70 lub 0x50, 0x10

                         RDSt[ff] = mx;
                            if(((c1 & 0x03) < 3) && (c1 & 0x10))// Stopa bledow < 3 i synchronizacja
                            {
                             AB = c5 | (c4 << 8);
                             CD = c3 | (c2 << 8);
                             RDS_In[ff] = AB;
                             RDS_In[ff+1] = CD;
                            }

                         if(ff > 1)
                         {    
                            my = (RDSt[ff-2] << 8) + mx; 
                            switch(my)
                             {
                             case 0x5010: // B1, C1, D1, A2 
                                 RDSB = RDS_In[ff-2];
                                 RDSD = RDS_In[ff];
                                 cx++;
                                 break;
                                  
                             case 0x3070: // A1, B1, C1, D1
                                 RDSB = RDS_In[ff-1];
                                 RDSD = RDS_In[ff+1];
                                 cx++;
                                 break;
                             }
                              
                         }
                         if(cx)
                             break;
                        }

                        if(cy > 3)
                        {
                            piszs("RDS ERR!");
                            break;
                        }

                        if((f & 0x07) == 0)piszs("\n\r ");

                        // Dane RDS
                        if((RDSB & 0xF800) == 0 ) // Grupa 0A
                        {
                            mx = RDSB & 0x0003; // index znakow
                            switch(mx)
                            {
                            case    0x00  : if(RDSD)
                                            {
                                            RDS_str[0] = RDSD >> 8;
                                            RDS_str[1] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x01  : if(RDSD)
                                            {
                                            RDS_str[2] = RDSD >> 8;
                                            RDS_str[3] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x02  : if(RDSD)
                                            {
                                            RDS_str[4] = RDSD >> 8;
                                            RDS_str[5] = RDSD & 0x00FF;
                                            }
                                            break;   
                            case    0x03  : if(RDSD)
                                            {
                                            RDS_str[6] = RDSD >> 8;
                                            RDS_str[7] = RDSD & 0x00FF;
                                            }
                                            break;   
                            }
                        }
                        piszs(RDS_str);
                        /*piszc('`');
                        piszhl(c1);
                        piszc('/');
                        piszhl(c2);
                        piszhl(c3);
                        piszc('/');
                        piszhl(c4);
                        piszhl(c5);
                        piszc('/');
                        piszhl(c6);
                        piszc('`');
                        piszhl(c7); */
                        piszs(" B:");
                        piszhl(RDSB >> 8);
                        piszhl(RDSB & 0x00FF);
                        /*piszs(" D:");
                        piszhl(RDSD >> 8);
                        piszhl(RDSD & 0x00FF);*/
                        piszs(", ");
                        /*piszc(RDSD >> 8);
                        piszc(RDSD & 0xFF); */

                    }
                    break;

           default:  piszc(8); // Backspace
                     gotoxy(7,1);
                     piszs(" RDS PS:[ .......]");
                       RDSDx = 0;
                       mx = 0;
                       while(KlawX() != 0x1B)
                       {
                           mx = RDS_RD(zs);
                           if(mx)
                           {
                               piszs("\010\010\010\010\010\010\010\010\010");
                               gotoxy(16,1);
                               piszs(zs); // RDS_PS1
                               piszc(']');
                           }
                           if(mx > 2)
                                   break;
                      }
                   piszc('<');
                   break;
           }
		   }
		   

// Test ---------------------------
           if(uc == 'g')
           {
            /* Frames
              piszs(" ^I=");
              piszhex(Frames);
              ARM_CPSR = enableIRQ();
              T2MCR = 0x0003; // 0x0003 INTERRUPT */

              gotoxy(1,1);

              piszs(" Test Timer'a: ");
              ch1 = RTC_SEC;
              while(ch1 == RTC_SEC);
              ch1 = RTC_SEC;
              Timer_1 = 1000;
              while(ch1 == RTC_SEC); 
              xx = 1000 - Timer_1;
              piszdec(xx, 3);
           }

// Test ---------------------------
           if(uc == 'G')
           {
            // Frames
             piszs("\n\r");
             gotoxy(1,1);

             //piszs(" ^F=");
             //piszhex(Buf_Ex_32[0]);
             //ARM_CPSR = enableFIQ();
             //T1MCR = 0x0003; // 0x0003 INTERRUPT

             piszs("Fx=");
             /*sekundy = RTC_SEC;
             xx = sekundy;
             while(sekundy == RTC_SEC);
             sekundy = RTC_SEC;
             T0TC = 0;
             while(sekundy == RTC_SEC);
             sekundy = RTC_SEC;
             xx = T0TC;*/
             xx = ALFreq;
             piszdec(xx,6);

             for(f=1;f<10;f++)
             {
                 ADCm();
                 gotoxy(10,1);
                 piszs("*L:");
                 piszdec(ADCLLm, 4);
                 piszs("*R:");
                 piszdec(ADCLRm, 4);
                 piszc(' ');
                 delayx(0x0000A000);
             }
           }

// Test ---------------------------
           if(uc == 'L')
           {
            // SPI -> SD sec

              gotoxy(1,1);
              piszs("SD_SEC(");piszdec(cur_sec,0);piszs("):");
              xx = gethex();
  
              if((xx >= 0x00) && ENTER)
               {
                piszs("<OK\n\r");
                cur_sec = xx;
               }
              else
                piszs("NACK");
           }

// Test ---------------------------
/*           if(uc == 'O')
           {
            // SPI -> SD
              rdsd_ok = 0;
              SD_SECTORS = 0;
              piszc(8);

              xx = Open_SD();
              if(xx == 0x00)
              {
               piszs("\n\r #Idle, Op Cond, CRC-X, 512, SD");
               if(BlkAddr)
                piszs("_HC_");
               else
                piszs("_SD_");

               piszs("0x");
               piszhex(SD_SECTORS);
               piszc('/');
               piszdec(SD_SECTORS, 0);
               piszc('/');
               piszhex(SD_FILE_FORMAT);
               piszs(" N:");
               piszs(SD_Name);
               piszs(" S:");
               piszhex((long)SD_SN);
               piszs("\n\r");
              }
              else
              {
               piszhl(xx);
               BlkAddr = 0;
               SD_SECTORS = 0;
               SD_FILE_FORMAT = 0;
              }
           }*/

// Set memory --------------------------------------
  if(uc == '^')
  {
   piszs("\010\n\r");
       gotoxy(1,1);
   piszs("Set AL REG:");
   xx = gethex();
   piszc('<');
   if(xx <= 15)
   for(ff=xx;ff<=15;ff++)
   {
    piszc('(');piszhex(al_read_4(0xC00+ff));piszc(')');piszc('=');
    yy = gethex();
    if(ESC)
    {
     piszc('<');
     break;
    }
    else
     if(ENTER)
       al_write_4(0xC00+ff, yy);
    if(ff < 15)
      piszc(',');
    piszhex(ff + 1);
   }
   else
    piszs(" adres za duzy !\n\r");
  }

// = Odczyt Partycji =============================================================
  if(uc == 'o')
  {
   LCD_X;
   piszc(8);
   LCD_On;
   gotoxy(1,1);
   piszs(" Odczyt Part. SD .. ");
   gotoxy(1,2);
   LCD_Off;
 
   Open_SD();
     
   secl = 0;
   sech = 0;

   Zapal_SD;
   xx = read_n_sec();
   Zgas_SD;

   LCD_On;

   if(!xx)
   {
    ch_ptr = Tab_8 + 0x21B0;
    memcpy(&Part_HDD, ch_ptr, 80);
    Pierwszy_Sektor = Part_HDD.P_Pierwszy_Sektor;
    Liczba_Sektorow = Part_HDD.P_Liczba_Sektorow;
    if((!Liczba_Sektorow)||((Tab_8[0x2000]==0xEB)&&(Tab_8[0x2003]==0x4D)))
    {
     Liczba_Sektorow = SD_SECTORS;
     Pierwszy_Sektor = 0;
     Part_HDD.P_Liczba_Sektorow = Liczba_Sektorow;
     Part_HDD.P_Pierwszy_Sektor = Pierwszy_Sektor;
    }
    DIR_OK = 0;
    piszs(" S:");
    piszhex(Pierwszy_Sektor);
    piszs(" T:");
    piszhex(Liczba_Sektorow);
    piszc(' ');
   }
   else
    piszs(" Error ! ");

   LCD_X;
   gotoxy(1,2);
   LCD_Off;

// = Odczyt Boot_Sec ===============================================
   Boot_0 = Pierwszy_Sektor;
   secl = Boot_0;
   sech = Boot_0; // + 641;

   Zapal_SD;
   xx = read_n_sec();
   Zgas_SD;

   if(!xx)
   {
    ch_ptr = Tab_8 + 0x2000;
    memcpy(&Boot_HDD, ch_ptr, 80);
    secl = Boot_0;

    SecPerClus = (unsigned char)Boot_HDD.Boot_SecPerClus;
    SecPerClus = SecPerClus & 0x00FF;
    SecPerClusL = (long)SecPerClus;

    FAT_0 = Boot_0 + (long)Boot_HDD.Boot_RsvdSecCnt;  // zwykle 1   ...
    FAT_1 = FAT_0 + (long)Boot_HDD.Boot_FATSz16;
    DIR_0 = FAT_1 + (long)Boot_HDD.Boot_FATSz16;
    DIRSec = ((Boot_HDD.Boot_RootEntCnt * 32) + (Boot_HDD.Boot_BytesPerSec - 1)) / Boot_HDD.Boot_BytesPerSec;
    DATA_0 = DIR_0 + DIRSec;
// MAX Klaster
    xx = Liczba_Sektorow - ((unsigned long)DATA_0 - (unsigned long)Boot_0);
    MAX_Klaster = xx / (unsigned long)SecPerClusL;

    secl = (unsigned long)FAT_0;
    sech = secl + (unsigned long)Boot_HDD.Boot_FATSz16 - (unsigned long)1;
    // Odczyt Fat'a ~256 sectorow

    DIR_DOT = 0; // 0 - root DIR, 1 - podkatalog
    Klaster = 0;
    Poziom = 0;

// ilosc clustr'ow na jedno okno (8kB = 16 sector'ow)
   BigClus = 0,
   Ulamek = 0;
   if(SecPerClus > 16)
   {
    BigClus = SecPerClus >> 4;
    Ulamek = BigClus;
   }


    piszs("SecPerClus:0x");
    piszhex(SecPerClus);
    piszc(' ');

    piszs("FAT_0:0x");
    piszhex(FAT_0);
    piszc(' ');

    piszs("FAT_1:0x");
    piszhex(FAT_1);
    piszc(' ');

    piszs("DIR_0:0x");
    piszhex(DIR_0);
    piszc(' ');

    piszs("DIRSec:0x");
    piszhex(DIRSec);
    piszc(' ');

    piszs("DATA_0:0x");
    piszhex(DATA_0);
    piszc(' ');
    
    LCD_On;
    gotoxy(1,2);

    piszs("All/Free:");
    piszdec(Liczba_Sektorow>>11,0);
    piszc('/');
    piszdec(Wolne_Sec()>>11,0);
    piszs("M \n\r");

    if(SecPerClus & 0xF0)
        Poslizg_X = Poslizg_40 / SecPerClus;

// Read_root_DIR
    secl = DIR_0;
    sech = DIR_0 + 47;
    if (DIRSec < 47)
    {
     sech = DIR_0 + DIRSec;
    }

    Zapal_SD;
    xx = read_n_sec();
    Zgas_SD;

    LCD_X;
   }
  }
// -------------------------------------------------------------------------------

// Mazanie pliku
  if(uc == 'D')
  {
      piszc(8);
      gotoxy(1,1);
      piszs("\n\rDEL SD, INDEX:");
      ENTER = 0;
      INDEX = getdec();
      if((INDEX <= Indexow) && INDEX && DIR_OK && ENTER)
      {
          INDEXB = Tab_Indexb(INDEX);    
          piszc('>');
          piszdec(INDEX, 0);
          MazaniePlikow(INDEXB);
      }
  }

// = Odczyt Katalogu Karty SD ====================================================
  if(uc == 'k')
  {
   piszc(8);
   CLS_LCD();//gotoxy(1,1);
   piszs("\n\r");
   gotoxy(1,1);
   piszs("DIR SD, INDEX:");
   INDEX = getdec();
   if(INDEX > Indexow)
    INDEX = Indexow;
   piszc('>');
   piszdec(INDEX, 0);
   yy = INDEX;
   Input_BS = 0;

   if(INDEX && DIR_OK)
   {
    Klaster = Tab_Klaster(INDEX);
    xx = Read_DIR(Klaster);
   }
   else
   {
// Powtorny odczyt katalogu
    if(!ENTER)
     {
      if(DIR_DOT)
      {
       Klaster = Klaster_dot;
       xx = Read_DIR(Klaster);
      }
      else
      {
       xx = Read_DIR(0);
       Poziom = 0;
       DIR_DOT = 0;
      }
     }
    if(!xx)
     DIR_OK = 1;
   }
   if(xx == 1)
   {
    piszs(" File ");
    INDEX = yy;
  
    AtrybTot = Tab_Atrybut(INDEX);
    if(AtrybTot & 0x0400)
    {
     Set_IN7();
     Graj_PCM(INDEX);
     delayx(0x00000100);
     Restore_IN();
     /* if(DDAdr)
     {
         MUTE_On();Timer_M = 500;
         New_STA310();
         CircleSurr();
         VCROut();
         SPDIFOut(1);
         MUTE_Off();
         if(SPDIF)
             update_decoder = 1;
     } */
     Display_Freq(19,2);
    }
  
    if(AtrybTot & 0x0200)
    {
     Graj_WAV(INDEX);
     delayx(0x00000100);
     /* if(DDAdr)
     {
         MUTE_On();Timer_M = 500;
         New_STA310();
         CircleSurr();
         VCROut();
         SPDIFOut(1);
         MUTE_Off();
         if(SPDIF)
             update_decoder = 1;
     } */
     Display_Freq(19,2);
    }
  
    if(AtrybTot & 0x0100)
    {
     Set_IN7();
 
     Timer_M = 49;
     MUTE_On();

     Graj_MP3(INDEX);

     delayx(0x00000100);
     while(Timer_M);
     MUTE_Off();

     Restore_IN();
     Display_Freq(19,2);
     Input_BS = 0;
    }
    uc = 0;
   }
   else
       piszs("*Error*");
  }
// ----------------------------------------------------------------
 
// Identyfikacja/Odczyt Katalogu Pendriv'a ====================================================
  if(uc == 'p')
  {
   piszc(8);
   gotoxy(1,1);

   DIR_OK_P = 0;

   xx = Open_VDIP();

   uc = 0;
  }
// ----------------------------------------------------------------

// Odczyt Katalogu Pendriv'a ====================================================
  if(uc == 'l')
  {
   piszc(8);
   CLS_LCD();
   gotoxy(1,1);
   Input_BS = 0;
   
   if(DIR_OK_P)
   {
         piszs("\n\rDIR PD, INDEX:");
         INDEXP = getdec();
         if(INDEXP > IndexowP)
          INDEXP = IndexowP;
         piszc('>');
         piszdec(INDEXP, 0);
    
         if(!INDEXP)
         {
      // Powtorny odczyt katalogu
          Open_VDIP();
         }
         
         AttP = Get_NameP(zs);

         if((INDEXP == 1) && (AttP == 0x10) && (zs[0]=='.')) 
         {
             piszs(" CD ..");
             WR_VDIP(0x02); // CD ..
             WR_VDIP(0x20);
             WR_VDIP(0x2E);
             WR_VDIP(0x2E);
             WR_VDIP(0x0D);
    
             while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR
    
             Open_VDIP();
             INDEXP = 0;
             AttP = 0;
         }
         else
         {
             if(AttP == 0x10)
             {
                 piszs(" CD ");
                 piszs(zs);
                 xx = strlen(zs);
                 WR_VDIP(0x02); // CD
                 WR_VDIP(0x20);
                 for(f=0;f<xx;f++)
                     WR_VDIP(zs[f]);
                 WR_VDIP(0x0D);

                 while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR
    
                 Open_VDIP();
                 INDEXP = 0;
                 AttP = 0;
             }
        
             if(AttP == 0x120)
             {
// Plik *.MP3 -----------------------------------------------------------------------------------
                 piszs(" Open ");
                 piszs(zs);
                 xx = strlen(zs);
                 WR_VDIP(0x0E); // OPR - OPEN FILE r
                 WR_VDIP(0x20);
                 for(f=0;f<xx;f++)
                     WR_VDIP(zs[f]);
                 WR_VDIP(0x0D);
                 while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR

                 Set_IN7();
                 Graj_MP3_P(Rozmiar_Pliku_P);
                 delayx(0x00000100);
                 while(Timer_M);
                 MUTE_Off();

                 xx = strlen(zs);
                 WR_VDIP(0x0A); // CLF - CLOSE FILE
                 WR_VDIP(0x20);
                 for(f=0;f<xx;f++)
                     WR_VDIP(zs[f]);
                 WR_VDIP(0x0D);
                 while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR

                 Restore_IN();

                 /* if(DDAdr)
                 {
                     MUTE_On();Timer_M = 500;
                     New_STA310();
                     CircleSurr();
                     VCROut();
                     SPDIFOut(1);
                     MUTE_Off();
                     if(SPDIF)
                         update_decoder = 1;
                 } */

                 Display_Freq(19,2);

                 Timer_1 = 200;
                 while(Timer_1 && (RD_VDIP() != 0x0D) ); // Poczekaj na '>' CR

                 xx = strlen(zs);
                 WR_VDIP(0x0A); // CLF
                 WR_VDIP(0x20);
                 for(f=0;f<xx;f++)
                     WR_VDIP(zs[f]);
                 WR_VDIP(0x0D);

                 while(RD_VDIP() != 0x0D ); // Poczekaj na '>' CR

                 INDEXP = 0;
                 AttP = 0;
             }

             if(AttP == 0x20)
             {
                 piszs(" File ");
                 INDEXP = 0;
                 AttP = 0;
             }
         }
   }
   uc = 0;
  }

// Test ---------------------------
          if(uc == 'i')
           {
            // SPI -> SD
            rdsd_ok = 0;
            piszs(" SD_RD_Sec_");
            Zapal_SD;
            for(f=0;f<48;f++)
            {
             ch_ptr = Tab_8 + 0x2000 + (f<<9);

             xx = SD_Read(ch_ptr, f + cur_sec); // 231
             
             if(xx)
             {
              piszc('~');
              piszhex(xx);
              piszc('~');
              break;
             }
            }
            if(!xx)
            {
              rdsd_ok = 1;
              piszc('^');
              piszdec(f,2);
            }
            Zgas_SD;
           }

// Test ---------------------------
           if(uc == 'I')
           {
            // SPI -> SD
            rdsd_ok = 0;
            piszs(" SD_RD_Mul_..");
            Zapal_SD;
            for(f=0;f<48;f=f+16)
            {
             ch_ptr = Tab_8 + 0x2000 + (f<<9);

            
             xx = disk_read (0, ch_ptr, f + cur_sec, 16); // 231
             
             if(xx)
             {
              piszc('~');
              piszhex(xx);
              piszc('~');
              break;
             }
            }
            if(!xx)
            {
              rdsd_ok = 1;
              piszc('^');
              piszdec(f,2);
            }
            Zgas_SD;
           }

// Test ---------------------------
/*           if(uc == 'k')
           {
            // SPI -> SD
            piszs(" SD_WR_");
            Zapal_SD;
            for(f=0;f<48;f++)
            {
             ch_ptr = Tab_8 + 0x2000 + (f<<9);

             xx = SD_Write(ch_ptr, f + cur_sec); // 231
             
             if(xx)
             {
              piszc('~');
              piszhex(xx);
              piszc('~');
              break;
             }
            }
            if(!xx)
            {
              piszc('^');
              piszdec(f,2);
            }
            Zgas_SD;
           } */

// Test ---------------------------
           if(uc == 'J')
           {
            // SPI -> SD
            piszs(" SD_WR_Multi_?");
            if(getch() == 'T')
            {
                piszc(8);
                piszs("..");
                Zapal_SD;
                for(f=0;f<48;f=f+16)
                {
                 ch_ptr = Tab_8 + 0x2000 + (f<<9);
                 //xx = SD_Write_M(ch_ptr, f + cur_sec); // 231
    
                 // Zapal
                 xx = disk_write(0, ch_ptr, f + cur_sec, 16); 
                 // Zgas
    
                 if((xx) || (counts < 16))
                 {
                  piszc('~');
                  piszhex(xx);
                  piszc('!');
                  piszhl(counts); 
                  piszc('~');
                  break;
                 }
                }
                if(!xx)
                {
                  piszc('^');
                  piszdec(f,2);
                }
                Zgas_SD;
            }
           }

// Test -------------------------------------------------------------------------------------
           if(uc == 'n')
           {
               xx = 0xFE;
               if(DIR_DOT)
                   xx = SD_Read((void*)Buf_8_2k, 231); // x == 0 oznacza OK, 231
               if(xx)
                   xx = Open_Part();
               if(!xx && SD_SECTORS)
                   Nawigacja_SD();
               Display_Input();
           }

// Test -------------------------------------------------------------------------------------
           if(uc == 'N')
           {
               if(!DIR_OK_P)
                   Open_VDIP();
               if(DIR_OK_P)
                   Nawigacja_VDIP();
               Display_Input();
           }


// Test MP3 ---------------------------------------------------------------------------------
/*            CTRL1B = CTRL1;
            CTRL1 = 0x43;
            LD_Latch_n(CTRL1, 1);
            CTRL2B = CTRL2;
            CTRL2 = 0x45;
            LD_Latch_n(CTRL2, 2);
            CTRL3B = CTRL3;
            CTRL3 = 0x5A;
            LD_Latch_n(CTRL3, 3);
            BIT_EN_1;
            i2c_write_STA015(0x72, 0x01);  // RUN_MODE
            xx = 0x2000;
            yy = xx;
            piszs(" STA015_RUN.. ");
            while(xx < 0x7FFF)
            {
             for(ff=0;ff<252;ff++)
             {
              if(IOPIN1 & 0x00000010)
              {
               SPI1(Tab_8[xx]);
               xx++;
               if(xx >= 0x7FFF)
                 break;
              }
             }
             if(KlawX() == 0x1B)
              break;
             if((xx - yy) >= 0x0800)
             {
              yy = xx;
              piszc('^');piszhex(xx);
             }
            }
            BIT_EN_0;
            delayx(0x007FFF);
            i2c_write_STA015(0x72, 0x00);  // RUN_MODE
            piszs(" STA015_STOP ");
            CTRL1 = CTRL1B;
            LD_Latch_n(CTRL1, 1);
            CTRL2 = CTRL2B;
            LD_Latch_n(CTRL2, 2);
            CTRL3 = CTRL3B;
            LD_Latch_n(CTRL3, 3); */
// ---------------------------------------------------------------------------------------
            // SPI -> SD
/*            piszs(" SD_WR_N_");
            Zapal_SD;
            for(f=0;f<48;f=f+16)
            {
             ch_ptr = Tab_8 + 0x2000 + (f<<9);
             xx = SD_Write_N(ch_ptr, f + cur_sec); // 231
             if(xx)
             {
              piszc('~');
              piszhex(xx);
              piszc('~');
              break;
             }
            }
            if(!xx)
            {
              piszc('^');
              piszdec(f,2);
            }
            Zgas_SD;
// ---------------------------------------------------------------------------------------
           } */


// Test ---------------------------
/*           if(uc == 'J')
           {
            // SPI -> SD
            rdsd_ok = 0;
            piszs(" SD_RD_L:");
            ch1 = RTC_SEC;
            ch2 = 0;
            while(ch1 == RTC_SEC);
            ch1 = RTC_SEC;
            Zapal_SD;
            while(ch1 == RTC_SEC) 
            {
             for(f=0;f<48;f=f+16)
             {
              ch_ptr = Tab_8 + 0x2000 + (f<<9);

              xx = disk_read (0, ch_ptr, f + cur_sec, 16); // 231
              
              if(xx)
              {
               piszc('~');
               piszhex(xx);
               piszc('~');
               break;
              }
             }
             ch2++;
             piszc('.');
            }
            if(!xx)
            {
              rdsd_ok = 1;
              piszc('^');
              piszdec(ch2,3);piszs("*24kB/sec ");
            }
            Zgas_SD;
           } */

// Test ---------------------------
/*           if(uc == 'K')
           {
            // SPI -> SD
            rdsd_ok = 0;
            piszs(" SD_WR_Sec - Test ZAPISU ? ");
            xx = getch();
            if((xx == 't')||(xx == 'T'))
            {
            ch1 = RTC_SEC;
            ch2 = 0;
            while(ch1 == RTC_SEC);
            ch1 = RTC_SEC;
            Zapal_SD;
            while(ch1 == RTC_SEC) 
            {

             for(f=0;f<48;f++)
             {
              ch_ptr = Tab_8 + 0x2000 + (f<<9);
              xx = SD_Write(ch_ptr, f + cur_sec + (ch2 * 48)); // 231
              if(xx)
              {
               piszc('~');
               piszhex(xx);
               piszc('~');
               break;
              }
             }
             ch2++;
             piszc('.');
            }
            if(!xx)
            {
              rdsd_ok = 1;
              piszc('^');
              piszdec(ch2,3);piszs("*24kB/sec ");
            }
            Zgas_SD;
            }
           } */

// Test ---------------------------
           if(uc == uc_Test_Zapisu) // Test ZAPISU !
           {
            // SPI -> SD
            rdsd_ok = 0;
            piszs(" SD_WR_Sec - Test ZAPISU ? ");
            xx = getch();
            if(xx == 'T')
            {

              Zgas_Ledy;
  
              piszs(" SD_WR_M(Test ZAPISU !):");
              ch1 = RTC_SEC;
              ch2 = 0;
              while(ch1 == RTC_SEC);
              ch1 = RTC_SEC;
              Zapal_SD; 
              while(ch1 == RTC_SEC) 
              {
               for(f=0;f<48;f=f+16)
               {
                Zapal_Zo;
  // ----------- Preerase -----------
  /*              if(preerase)
                {
                 CS_SD_0;
                
                 xx = SD_Command(SD_CMD_55, 0);               
               //piszs(" APP_CMD");
                 if(xx)
                 {
                  CS_SD_1;
                  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
               //piszhl(xx);
                  break; // Blad
                 }
  
                 CS_SD_0;
                 xx = SD_Command(SD_ACMD_23, 16);               
               //piszs(" SET_WR_BLK_ERASE_COUNT_CMD");
                 if(xx)
                 {
                  CS_SD_1;
                  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
               //piszhl(xx);
                  break; // Blad
                 }
                } */
  // --------------------------
                ch_ptr = Tab_8 + 0x2000 + (f<<9);
  
                xx = disk_write(0, Tab_8 + 0x2000 + (f<<9), f + cur_sec + (ch2 * 48), 16);
                if(xx)
                {
                 piszc('~');
                 piszhex(xx);
                 piszc('~');
  
                 Zapal_Cz;
  
                 break;
                }
               }
               ch2++;
               piszc('.');
              }
              if(!xx)
              {
                piszc('^');
  
                Zapal_Ze;
  
                piszdec(ch2,3);piszs("*24kB/sec ");
              }
              Zgas_SD;
            }
           } 

// Make DIR
           if(uc == uc_Make_Directory) // MD Make Directory
           {
               piszc(8);
               uc = 0;
               Make_DIR();
           }


// Test ---------------------------
           if(uc == 'q')
               {
                piszc(8);
                gotoxy(1,2);
                piszs("\r\nTEA s:");
                xx = TEA_Quality();
                piszdec(xx, 2); // TEA_Poziom
                piszs(" i:"); // TEA_IF = 0x38(56) = 100%
                piszdec(TEA_IF+44, 3);
                piszs("% ");
               }

// Test ---------------------------
           if(uc == 'x')
               {
                piszs("\r\nRTC H:");
                itoa(RTC_HOUR, s);
                piszs(s);
                piszs(" M:");
                piszdec(RTC_MIN, 2);//itoa(RTC_MIN, s);
                //piszs(s);
                piszs(" S:");
                piszdec(RTC_SEC, 2);//itoa(RTC_SEC, s);
                //piszs(s);
                piszc(' ');
               }
// Test ---------------------------
           if(uc == 'T')
           {
            piszc(8);
            piszs(" Test [r]=Read_STA015, [w]=Write_STA015, [x] - Test X..");
            uc = getch();
            while(uc != 0x1B)
            {
                switch(uc)
                {
                case 'r' : Read_STA015();
                           break;
                case 'w' : Write_STA015();
                           break;
                case 'x' : LCD_Off;
                           while( uc != 0x1B)
                            {
                               if((h_Bity_6 != Bity_Z6)||(h_Bity_7 != Bity_Z7))
                               {
                                   h_Bity_6 = Bity_Z6;
                                   h_Bity_7 = Bity_Z7;
                                   piszs(" Z:");
                                   piszhex(h_Bity_6);
                                   piszc('&');
                                   piszhex(h_Bity_7);

                               }
                               uc = KlawX();
                            }
                           LCD_X;
                           break;  
                default  : break;
                }
                uc = getch();
            }
            uc = 0;
           }

// Test VDIP ---------------------------
           if(uc == 't')
           {
            piszc(8);
            piszs(" Test [r]=RD_VDIP,[w]=WR_VDIP,[t]=Terminal,[h]=Hex,[p]Pilot,[s]Szumy");
            uc = getch();
            switch(uc)
            {
            case 's' :  Rec_RAM();
                        yy = Szumy();
                        piszs("SZ:");
                        gotoxy(1,1);
                        piszhex(yy);
                        break;

            case 'r' : while((uc = KlawX()) != 0x1B)
                       {
                        for(f=0;f<999;f++)
                        {
                         xx = RD_VDIP();
                         if((xx & 0x0100) == 0)
                         {  
                          if((xx > 0x1B) && (xx < 0x7F))
                              piszc(xx);
                          else
                              piszc('.');
                         }
                        }
                       }
                       piszs("*END*");
                       break;
            case 'w' : piszs(" WR:(hex)");
                       //WR_VDIP(0x11);
                       //WR_VDIP(0x0D); // Extended command
                       piszc('^');
                       while(uc!=0x1B)
                       {
                        //piszs(" x:");
                        xx = gethex();
                        WR_VDIP(xx);
                        uc = getch();
                        if(uc == ' ')
                         piszc(uc);
                       }
                       break;
            case 't' : piszs(" T:");
                       mx = 1;
                       yy = 0; 
                       WR_VDIP(0x11);
                       WR_VDIP(0x0D); // Extended command
                       //piszc('^');
                       while(uc != 0x1B)
                       {
                         //piszs(" x:");
                         //xx = gethex();
                         if((uc = KlawX()) > 0)
                         {
                          if(uc == '`')
                              uc = '~';
                          if(uc != '@')
                              WR_VDIP(uc);
                          piszc(uc);
                          if(uc == 0x0D)
                          {
                              uc = 0;
                              piszc(10);
                              yy = 0;
                          }
                          if(uc == '@')
                          {
                              mx = 1 - mx;
                              if(mx)
                                  piszs("(A)");
                              else
                                  piszs("(.)");
                          }
                         }
                         for(f=0;f<999;f++)
                         {
                          xx = RD_VDIP();
                           if((xx & 0x0100) == 0)
                           {
                               yy = yy + 1;

                               if(mx)
                               {
                                   if(xx == 0x0D)
                                   {
                                       piszc(0x0D);
                                       piszc(10);
                                   }
                                   if((xx > 0x1F) && (xx < 0x7F))
                                       piszc(xx);
                                   else
                                       if(xx != 0x0D)
                                       {
                                       piszc('`');
                                       piszhl(xx);
                                       piszc('`');
                                       }
                               }

                               if(!mx)
                               {
                                   if(yy < 193)
                                   {
                                       if(xx == 0x0D)
                                       {
                                           piszc(0x0D);
                                           piszc(10);
                                       }
                                       if((xx > 0x1F) && (xx < 0x7F))
                                           piszc(xx);
                                   }

                                   switch(yy) 
                                      {
                                      case 250 : piszs("+250");
                                             break;
                                      case 500 : piszs("+500");
                                             break;
                                      case 1000 : piszs("+1000");
                                             break;
                                      case 10000 : piszs("+10k");
                                             break;
                                      case 100000 : piszs("+100k");
                                             break;
                                      case 250000 : piszs("+250k");
                                             break;
                                      case 500000 : piszs("+500k");
                                             break;
                                      case 1000000 : piszs("+1M");
                                             break;
                                      case 2000000 : piszs("+2M");
                                             break;
                                      case 3000000 : piszs("+3M");
                                             break;
                                      case 4000000 : piszs("+4M");
                                             break;
                                      case 5000000 : piszs("+5M");
                                             break;
                                      case 10000000 : piszs("+10M");
                                             break;
                                      case 25000000 : piszs("+25M");
                                             break;
                                      case 50000000 : piszs("+50M");
                                             break;
                                      }
                                   if((yy & 0x000003FF) == 0)
                                       piszc('.'); 
                                  }
                               }
                         }
                       }
                       break;
            case 'h' : piszs(" H:");
                       WR_VDIP(0x10);
                       WR_VDIP(0x0D); // Shorted command
                       mx = 1;
                       yy = 0; 
                       // piszc('^');
                       ESC = 0;
                       while(!ESC)
                       {
                         //piszs(" x:");
                         xx = gethex();
                         if(ENTER)
                         {
                           WR_VDIP(xx);
                           piszc(' ');
                         }
                         else
                           piszc('*');
                         ENTER = 0 ;        
                         for(f=0;f<9999;f++)
                         {
                          xx = RD_VDIP();
                          if((xx & 0x0100) == 0)
                          {
                            piszhl(xx);
                            piszc(' ');
                          }
                         }
                       }
                       break;
              case 'p' : piszs(" P:");
                      while(uart0Getch() != 0x1B)
                        {
// - PILOT ------------------------------------------
                        xx = getpilot();

                        if(xx)
                          {
                          piszs(" {");
                          piszhl(xx>>8);
                          piszhl(xx & 0x00FF);
                          piszc('}');
                          }
                        }
            default  : break;
            }
            uc = 0;
// Set Shorted Hexadecimal Command
            WR_VDIP('S');
            WR_VDIP('C');
            WR_VDIP('S');
            WR_VDIP(0x0D);

           }
// --------------------------------------------------------------------

// Nagrywanie - Rec...
/*           if(uc == 'r')
           {
            RecLoop = 0;
            Nagrywanie_X();
           } */
// Nagrywanie w petli
           if(uc == 'R')
           {
            RecLoop = 1;
            Stat_REC = Input;
            Nagrywanie_X();
           }
// Test ---------------------------
           if(uc == 'E')
           {
             ELcd_X++;
             ELcd_X = ELcd_X & 0x07;
             ELcd = ELcd_X;
             if(!ELcd_X)
               ELcd_X++;
             if(ELcd == 4)
               ELcd++;
             SLcd = ELcd_X & 0x05;

             uart0Putch('*');
             if(ELcd_X & 0x04)
               uart0Putch('S');
             if(ELcd_X & 0x02)
               uart0Putch('E');
             if(ELcd_X & 0x01)
               uart0Putch('L');
             uart0Putch('*');
           }

// Test ---------------------------
/*           if(uc == 'e')
               {
                xx = 0x7E;
                piszs("\r\n *RD PCF a:");
                piszhl(xx);

                xx = i2c_read_a1(xx);
                if(xx >= 0)
                    {
                     piszs(" d1:");

                     piszhl(xx);
                    }
                else
                    piszs(" *** I2C Error !");

                xx = i2c_read_dn();
                if(xx >= 0)
                    {
                     piszs(" d2:");

                     piszhl(xx);
                    }
                else
                    piszs(" *** I2C Error !");

                xx = i2c_read_dn();
                if(xx >= 0)
                    {
                     piszs(" d3:");

                     piszhl(xx);
                    }
                else
                    piszs(" *** I2C Error !");

                xx = i2c_read_de();
                if(xx >= 0)
                    {
                     piszs(" d4:");

                     piszhl(xx);
                    }
                else
                    piszs(" *** I2C Error !");
                piszs(" *** ");
               } */

// Test ---------------------------
/*           if(uc == 'z')
               {
                xx = 0x76;
                piszs("\r\n *** I2C a:");
                piszhl(xx);
                xx = i2c_write_a(xx);
                if(xx >= 0)
                    {
                     piszs(" d:");
                     xx = 0xAA;
                     xx = i2c_write_de(xx);
                     piszhl(xx);
                    }
                else
                    piszs(" *** I2C Error !");
                piszs(" *** ");
               }*/

// TEA5768HL
                             if((uc == '/')||(uc == '*')) // '-' '+'
                             {
                              //I2C0_SPEED(LOW_S, LOW_S);

                              // LCD_Off;

                              FIO4SET |= 0x10000000;
                              delayx(0x0007);

                              if(uc == '*')
                                  FM_Plus_Minus('+');
                              else
                                  FM_Plus_Minus('-');

                              // LCD_X;

                               //delayx(0x0001);
                               //I2C0_SPEED(HIGH_S, HIGH_S);
                             }
                               
// TEA5768HL
                             if(uc == uc_Freq_Adj) // '-' '+'
                             {
                              //I2C0_SPEED(LOW_S, LOW_S);

                              gotoxy(1,2);
                              piszs("FMADJ[+ - ESC ENTER 7 8] ");

                              FIO4SET |= 0x10000000;
                              delayx(0x0007);
                              
                              uc = getch();
                              while((uc == '+')||(uc == '-'))
                              {    
                                  FM_Plus_Minus(uc);
                                  TEA_Quality();
                                  LCD_On; // Tylko LCD
                                  ECHO_Off;
                                  gotoxy(9,2);

                                  piszs(" Q:");
                                  piszdec(yy ,2); // Quality 0..15
                                  piszc('/'); // TEA_IF = 0x38(56) = 100%
                                  piszdec(TEA_IF + 44, 3); // Dostrojenie w [%]

                                  gotoxy(18,2);
                                  piszc(' ');
                                  gotoxy(1,2);
                                  LCD_X; //ELcd = ELcd_X;  

                                  uc = getch();
                              }
                              
                              if(uc == 0x0D)
                              {
                                  switch(_FM_x) // Zapisz FM
                                  {
                                  case  0 : _FM_0 = _FM_;
                                            break;
                                  case  1 : _FM_1 = _FM_;
                                            break;
                                  case  2 : _FM_2 = _FM_;
                                            break;
                                  case  3 : _FM_3 = _FM_;
                                            break;
                                  case  4 : _FM_4 = _FM_;
                                            break;
                                  case  5 : _FM_5 = _FM_;
                                            break;
                                  case  6 : _FM_6 = _FM_;
                                            break;
                                  case  7 : _FM_7 = _FM_;
                                            break;
                                  case  8 : _FM_8 = _FM_;
                                            break;
                                  case  9 : _FM_9 = _FM_;
                                            break;
                                  }
                                  gotoxy(1,1);
                                  piszs("WR");
                                  piszc(_FM_x + '1');
                                  //piszc('=');
                                  Flag_C = 0x534F4D43; // Flaga 'CMOS'
                                  delayx(0x00034567);
                              }

                               //delayx(0x0001);
                               //I2C0_SPEED(HIGH_S, HIGH_S);

                              if((uc != '7')&&(uc != '8'))
                                  uc = ' ';
                              if(uc == '7')
                                  uc = 'v';
                              if(uc == '8')
                                  uc = 'c';
                             }
                               

// TEA5768HL
                             if((uc == 'F')||(uc == 'f')||(uc == uc_Freq))
                             {
                              gotoxy(1,1);
                              piszs("\n\r");
                              gotoxy(1,1);
                              piszs("FM[");
                              piszc(_FM_x + '1');
                              piszs("](");
                              piszdec(_FM_,6);
                              piszs("k):");

                              ENTER = 0;

                              xx = getdec(); // x = ( _FM_[kHz] -(+) 225[kHz] ) / 12.5[kHz]
                              
                              if(ENTER)
                              {
                                strcpy(L_RDS_S, " RDS... ");
                                Display_RDS = 0;  
                                if((xx > 87400)&&(xx < 108100))
                                {
                                  _FM_ = xx;
                                  switch(_FM_x) // Zapisz FM
                                  {
                                  case  0 : _FM_0 = _FM_;
                                            break;
                                  case  1 : _FM_1 = _FM_;
                                            break;
                                  case  2 : _FM_2 = _FM_;
                                            break;
                                  case  3 : _FM_3 = _FM_;
                                            break;
                                  case  4 : _FM_4 = _FM_;
                                            break;
                                  case  5 : _FM_5 = _FM_;
                                            break;
                                  case  6 : _FM_6 = _FM_;
                                            break;
                                  case  7 : _FM_7 = _FM_;
                                            break;
                                  case  8 : _FM_8 = _FM_;
                                            break;
                                  case  9 : _FM_9 = _FM_;
                                            break;
                                  }
                                  gotoxy(1,1);
                                  piszs("WR");
                                  piszc(_FM_x + '1');
                                  //piszc('=');
                                  Flag_C = 0x534F4D43; // Flaga 'CMOS'
                                  delayx(0x00034567);
                                }

                                if((xx >= 1)&&(xx <= 10))
                                {
                                    _FM_x = xx - 1;
                                    Ustaw_Prg(xx);
                                }
                                else
                                    Ustaw_Prg(_FM_x + 1);

                                piszc('=');
                                piszdec(_FM_,6);
                            }

                           }
                               
// TEA5768HL
// Test ---------------------------
           if((uc == 'c')||(uc == 'v'))
               {
                // I2C0_SPEED(LOW_S, LOW_S);
                gotoxy(1,2);
                FIO4SET |= 0x10000000;
                delayx(0x0001);

                if(uc == 'c')
                 VnC = 0;
                else
                 VnC = 1;
                 
                freq = oblicz_freq( _FM_ );

                Flag_C = 0x534F4D43; // Flaga 'CMOS'

                xx = 0xC0;
                xx = i2c_write_a(xx);
                if(xx >= 0)
                {
                     xx = freq >> 8; // 2C 1E (1D)
                     xx = i2c_write_dn(xx);
                     if(xx >= 0)
                       c1 = xx;
                     else
                        goto i2c_error;

                     xx = freq & 0x00FF; // 3D 26 (A2) [93MHx (88,4MHz)]
                     xx = i2c_write_dn(xx);
                     if(xx >= 0)
                       c2 = xx;
                     else
                        goto i2c_error;

                     if(VnC == 0)
                       xx = 0x00; // LOW/HIGH side: bit 4
                     else
                       xx = 0x91; // LOW/HIGH side: bit 4
                     xx = i2c_write_dn(xx);
                     if(xx >= 0)
                       c3 = xx;
                     else
                        goto i2c_error;

                     if(VnC == 0)
                       xx = 0x00; // XTAL 32k: bit 4
                     else
                       xx = 0x80; // XTAL 32k: bit 4
                       
                     xx = i2c_write_dn(xx);
                     if(xx >= 0)
                       c4 = xx;
                     else
                        goto i2c_error;

                     if(uc == 'c')
                       xx = 0x00;
                     else
                       xx = 0x00; // 40 - De-emphasis - bit 6: 0 -> 50us, 1 -> 75us
                     xx = i2c_write_de(xx);
                     if(xx >= 0)
                       c5 = xx;
                     else
                        goto i2c_error;

                     if(VnC == 0)
                       piszs(">IF HIGH SIDE<");
                     else
                       piszs(">IF LOW SIDE <");
                     delayx(0x00023456);

                    //I20CONCLR = 0xFF;
                    //I20CONSET = 0x40;
                }
                else
                {
    i2c_error:      piszs("*I2C Error*");
                    delayx(0x0001);
                    I20CONCLR = 0xFF;
                    I20CONSET = 0x40;
                }
               }
// --------------------------------------------------------------------                 
         }
    }
   } // while
}

// ####################################################################

int i2c_write_STA015(char _sadr_, char _dane_)
{
 if(i2c_write_a(I2C_STA015) == -1)
  return(-1);
 else
 {
  i2c_write_dn(_sadr_);
  return(0x0100 + i2c_write_de(_dane_));
 }
}

int i2c_read_STA015(char _sadr_)
{
 if(i2c_write_a(I2C_STA015) == -1)
  return(-1);
 else
 {
  i2c_write_dn(_sadr_);
  return(i2c_read_a(I2C_STA015) & 0x00FF);
 }
}

// ====================================================================
void delayx(int x)
{
 for(_delay_x_=1; _delay_x_ < x ;_delay_x_++)
 {
  _delay_x_ = _delay_x_  * 8;
  _delay_x_ = _delay_x_  >> 3;
 }
}

// ====================================================================
void piszc(char x)
{
char xlcdl;
 xlcdl = xlcd;
 xlcdl--;
 xlcdl = xlcdl & 0x1F;
 if(xlcdl > 23)
     xlcdl = 23;
 xlcdl++;
 xlcd = xlcdl;
// T_LCD[ylcd-1][xlcdl-1] = x;
 xlcd++;
 if(ELcd & 0x1)
   zapis_lcd_d(x); // LCD & Symulacja
 if(ELcd & 0x02)
   uart0Putch(x); // ECHO
}

void gotoxy(char x, char y)
{
/* int xx, yy;
 xx=0;
 yy=0;
 if(x)xx=x-1; // x=1,2..16
 xx=xx&0xF;
 if(y==2)yy=0x40; // y=1,2
 xx=xx+yy+0x80;
 delayc();
 zapis_lcd_c(xx);
 delayc(); */
 if(x)x--; // x=1,2..24
 x=x & 0x1F;
 if(x > 23)
     x = 23;
 y--;
 if(y)y=0x40; // y=1,2
 x=(x + y) | 0x80;
 if(ELcd)
 {
  zapis_lcd_c(x);
  zapis_lcd_ci(x); // LCD
  delayx(1000);
 }
}

void CLS_LCD(void)
{
    zapis_lcd_c(0x01);
//    zapis_lcd_ci(0x01); // LCD
    delayx(0x00011234);
}

void zapis_lcd_c(unsigned char x)
{
// Symulacja
  if(ELcd & 0x04)
  {
      uart0Putch(0x04);
      uart0Putch(x);
  }
// LCD
  if(ELcd & 0x01)
    zapis_lcd_ci(x);
}

void zapis_lcd_d(unsigned char x)
{
    if(x>=0x80)
        x = '*';
    if((x<=7)||(x>0x1B))
    {    
// LCD
        zapis_lcd_di(x);
// Symulacja
        if(ELcd & 0x04)
        {
            uart0Putch(0x05);
            uart0Putch(x);
        }
    }
    if(((Last_lcd_d==0x0A)&&(x == 0x0D))||((Last_lcd_d==0x0D)&&(x == 0x0A)))
        gotoxy(1,2);
    Last_lcd_d = x;
}

void piszl(char x)
{
 x=x&0x0F;
 x=hex2ascii(x);
 piszc(x);
}

void piszhl(char x)
{
 char h;
 h=x&0x0F0;
 h=h>>4;
 h=h&0x0F;
 h=hex2ascii(h);
 piszc(h);
 x=x&0x0F;
 x=hex2ascii(x);
 piszc(x);
}

void piszs(char *s)
{
 char fl, xl;
 for(fl=0;fl<65;fl++)
 {
  xl = s[fl];
  if(!xl)break;
  piszc(xl);
 }
}

int hex2ascii(int x)
{
 int y;
 y=x&0x0F;
 if(y>9)
  y=y+55;
 else
  y=y+48;
 return y;
}

void piszdec(unsigned int xdec, unsigned char lend)
{
char zs[65];
int xl;
unsigned int fl;

 lend = lend & 0x07;

 itoa(xdec, zs);
 if((xdec < 0) || (lend == 0)) 
 {
     piszs(zs);
 }
 else
 {
  xl = strlen(zs) - lend;
  for(fl=0;fl<lend;fl++)
  {
   if(xl>=0)
    piszc(zs[xl]);
   else
    piszc('0');
   xl++; 
  }
 }
}

int piszhex(long unsigned int x)
{
 if(x>0x0FFFFFFF)
  {
      piszhl(x >> 24);
      piszhl(x >> 16); 
      piszhl(x >> 8); 
      piszhl(x);
      return(8); 
  }
 if(x>0x00FFFFFF)
  {
      piszl(x >> 24);
      piszhl(x >> 16); 
      piszhl(x >> 8); 
      piszhl(x);
      return(7); 
  }
 if(x>0x000FFFFF)
  {
      piszhl(x >> 16); 
      piszhl(x >> 8); 
      piszhl(x);
      return(6); 
  }
 if(x>0x0000FFFF)
  {
      piszl(x >> 16); 
      piszhl(x >> 8); 
      piszhl(x);
      return(5); 
  }
 if(x>0x00000FFF)
  {
      piszhl(x >> 8); 
      piszhl(x);
      return(4); 
  }
 if(x>0x000000FF)
  {
      piszl(x >> 8); 
      piszhl(x);
      return(3); 
  }
 if(x>0x0000000F)
  {
      piszhl(x);
      return(2); 
  }
 if(x<=0x0000000F)
  {
      piszhl(x);
      return(1); 
  }
 return(0);
}

void itoa(int n, char s[])
 {
  int i, sign;

//  return(sprintf(s, "%d", n));
 
     if ((sign = n) < 0)  /* record sign */
         n = -n;          /* make n positive */
     i = 0;
     do {       /* generate digits in reverse order */
         s[i++] = n % 10 + '0';   /* get next digit */
     } while ((n /= 10) > 0);     /* delete it */
     if (sign < 0)
         s[i++] = '-';
     s[i] = '\0';
     reverse(s);
 }

void reverse(char s[])
{
     int i, j;
     char c;
 
     for (i = 0, j = strlen(s)-1; i<j; i++, j--) 
     {
         c = s[i];
         s[i] = s[j];
         s[j] = c;
     }
}

// SD-MMC #################################################3

int SD_Command(unsigned char dat, uint32_t arg)
{
// SPI -> SD -----------------------------------------------
 int xx, f;

   xx = SPI(dat | 0x40); // CMD0 - Idle_Stat, CMD1...
   xx = SPI(arg >> 24); // A3
   xx = SPI(arg >> 16); // A2
   xx = SPI(arg >> 8); // A1
   xx = SPI(arg); // A0
   xx = SPI(0x95); // CRC
  
//   delayx(0x0001);
                
   for(f=0;f<10000;f++)
    {
      xx = 0xFF & SPI(0xFF); // R1
      if(xx != 0xFF)
        break; 
    }
 return(xx);
}

int SD_Reset()
{
// SPI -> SD --------------------------------------------
 int xx, f;

 S0SPCCR = SPI_LOW; //SPI_LOW
 delayx(0x07);

   CS_SD_1; // CS_SD# nie aktywny

   for(f=0;f<12;f++)
   {
    xx = SPI(0xFF);
   }

   CS_SD_0; // CS_SD# aktywny
   xx = SPI(0x40); // CMD0 - Idle_Stat
   xx = SPI(0x00); // A3
   xx = SPI(0x00); // A2
   xx = SPI(0x00); // A1
   xx = SPI(0x00); // A0
   xx = SPI(0x95); // CRC

   delayx(0x0001);
                
   for(f=0;f<1000;f++)
    {
      IOCLR0 |= 1 << 16; // CS_SD#
      xx = 0xFF & SPI(0xFF); // R1
      IOSET0 |= 1 << 16; // CS_SD#
      if(xx != 0xFF)
        break; 
    }
   CS_SD_1;
   SPI(0xFF); // po zakonczeniu komendy trzeba poczekac

//piszs("Idle:");piszhl(xx);
   if(xx != 0x01)return(0xFF); // Blad

// Idle State OK
   CS_SD_0;
   for(f=0;f<500;f++)
   {
    xx = SD_Command(SD_CMD_1, 0);
    if(!xx)break;
   }
   CS_SD_1;
   SPI(0xFF); // po zakonczeniu komendy trzeba poczekac

//piszs("CMD_1:");piszhl(xx);
   if(xx)return(0xFF); // Blad

// Op Cond OK
   CS_SD_0;
   xx = SD_Command(SD_CMD_59, 0); // CRC Off
   CS_SD_1;
   SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszs("CMD_59:");piszhl(xx);
   CS_SD_0;
   xx = SD_Command(SD_CMD_16, 512); // Block Len = 512
   CS_SD_1;
   SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszs("CMD_16:");piszhl(xx);

   delayx(0x07);
   S0SPCCR = cur_spi_spd; //SPI_HIGH
   delayx(0x07);
   return(xx);
}

// Read SC_MMC sector -------------------------------------
int SD_Read(char *buf, uint32_t sec)
{
// SPI -> SD
 int xx, f;

 if (!BlkAddr) sec = sec << 9;	/* Convert to byte address if needed */

 delayx(0x07);
 S0SPCCR = cur_spi_spd; //SPI_HIGH
 delayx(0x07);

 Zgas_Ledy;

 CS_SD_0;
 for(f=0;f<100;f++)
 {
   xx = SD_Command(SD_CMD_17, sec);
   if(!xx) break;
   delayx(0x07);
 }
//piszs(" RD_CMD_");
 if(xx)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0100 + xx); // Blad
 }

 Zapal_Cz;

// czekaj na bit startu 0xFE
//piszs(" RD_STR_");
 for(f=0;f<50000;f++)
    {
      xx = 0xFF & SPI(0xFF); // START BLOCK BYTE
      if(xx == 0xFE)
        break; 
    }
 if(xx != 0xFE)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0200 + 0xFF); // Brak bajtu startu
 }

// transfer danych
//piszs(" RD_512_");
// for(f=0;f<512;f++)buf[f] =SPI(0xFF); // Dane

 Zgas_Ledy;
 Zapal_Zo; 

  S0SPCR = 0x0024; // 16 bitow
  for(f=0;f<512;f=f+8)
  {
    S0SPDR = 0xFFFF; // Czytaj
    while(!(S0SPSR & 0x80)); // wait for Transit complete
    xx = S0SPDR; // Read dane 16b
    S0SPDR = 0xFFFF; //  Czytaj nastepne dane [A]
	*buf++ = xx >> 8; // Dane L
    *buf++ = xx; // H
// - 2, 3 -----------------------------------------------
    // [A]
    while(!(S0SPSR & 0x80)); // wait for Transit complete
    xx = S0SPDR; // Read dane 16b
    S0SPDR = 0xFFFF; //  Czytaj nastepne dane [B]
    *buf++ = xx >> 8; // Dane L
    *buf++ = xx; // H
// - 4, 5 -----------------------------------------------
    // [B]
    while(!(S0SPSR & 0x80)); // wait for Transit complete
    xx = S0SPDR; // Read dane 16b
    S0SPDR = 0xFFFF; //  Czytaj nastepne dane [C]
	*buf++ = xx >> 8; // Dane L
    *buf++ = xx; // H
// - 6, 7 -----------------------------------------------
	// [ C]
	while(!(S0SPSR & 0x80)); // wait for Transit complete
    xx = S0SPDR; // Read dane 16b
	*buf++ = xx >> 8; // Dane L
    *buf++ = xx; // H
  }
  S0SPCR = 0x0820; // 8 bitow

//piszs("512 ");
 // 2 bajty CRC
 SPI(0xFF); // Dane
 SPI(0xFF); // Dane
 CS_SD_1;
 SPI(0xFF); // po zakonczeniu komendy trzeba poczekac

 Zgas_Ledy;
 Zapal_Ze;

// OK
 xx = 0;
 return(xx);
}

// Write SC_MMC sector -------------------------------------
int SD_Write(char *buf, uint32_t sec)
{
// SPI -> SD
 int xx, f;

 if (!BlkAddr) sec = sec << 9;	/* Convert to byte address if needed */

 delayx(0x07);
 S0SPCCR = cur_spi_spd; //SPI_HIGH
 delayx(0x07);

 Zgas_Ledy;

 CS_SD_0;
 xx = SD_Command(SD_CMD_24, sec);               
//piszs(" WR_CMD_");
 if(xx)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0100 + xx); // Blad
 }

// wyslij na bit startu 0xFE
  SPI(0xFE);
// transfer danych
//piszs(" WR_512_");
// for(f=0;f<512;f++)
//    {
//      xx = buf[f];
//      SPI(xx); // Dane
//    }
 S0SPCR = 0x0024; // 16 bitow
 for(f=0;f<512;f=f+8)
 {
   xx = *buf++ << 8; // Dane L
   xx = xx + *buf++; // H
   S0SPDR = xx; // Zapisz
   xx = *buf++ << 8; // Dane L next [A]
   xx = xx + *buf++; // H next [A]
   while(!(S0SPSR & 0x80)); // wait for Transit complete
// - 2, 3 -----------------------------------------------
   S0SPDR = xx; // Zapisz [A]
   xx = *buf++ << 8; // Dane L [B]
   xx = xx + *buf++; // H [B]
   while(!(S0SPSR & 0x80)); // wait for Transit complete
// - 4, 5 -----------------------------------------------
   S0SPDR = xx; // Zapisz [B]
   xx = *buf++ << 8; // Dane L [C]
   xx = xx + *buf++; // H [C]
   while(!(S0SPSR & 0x80)); // wait for Transit complete
// - 6, 7 -----------------------------------------------
   S0SPDR = xx; // Zapisz [C]
   while(!(S0SPSR & 0x80)); // wait for Transit complete
 }
 S0SPCR = 0x0820; // 8 bitow

//piszs("512 ");
 // 2 bajty CRC
 SPI(0xA5); // Dane
 SPI(0xA5); // Dane

 Zapal_Cz;

 delayx(0x0007);

// Potwierdzenie - akceptacja danych
 xx = SPI(0xFF);
 if((xx & 0x0F) != 0x05)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0200 + xx); // Blad zapisu
 }

// Wait for write end (karta zwiera DO do masy)
 f=0x00FFFFFF;
 while( (SPI(0xFF) == 0 ) && f)f--;
 if(f<1)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0300); // Blad zapisu
 }

 CS_SD_1;
 SPI(0xFF); // po zakonczeniu komendy trzeba poczekac

 Zgas_Ledy;
 Zapal_Ze;

// OK
 xx = 0;
 return(xx);
}

// Write SC_MMC sector -------------------------------------
int SD_Write_M(char *buf, uint32_t sec)
{
// SPI -> SD
 int xx, f, m;
// Test Led
 Zgas_Ledy;

 if (!BlkAddr) sec = sec << 9;	/* Convert to byte address if needed */

 delayx(0x07);
 S0SPCCR = cur_spi_spd; //SPI_HIGH
 delayx(0x07);

 CS_SD_0;
 xx = SD_Command(SD_CMD_25, sec);               
//piszs(" WR_CMD_");
 if(xx)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0100 + xx); // Blad
 }

// wyslij na bit startu 0xFE

// SPI(0xFC); // Start Multi

// transfer danych
//piszs(" WR_512_");
// for(f=0;f<512;f++)
//    {
//      xx = buf[f];
//      SPI(xx); // Dane
//    }

 for(m=0;m<=16;m++)
 {
  CS_SD_0; 

  if(m<16)
  {
    SPI(0xFC); // Start Bloku

    delayx(0x07);

    S0SPCR = 0x0024; // 16 bitow
    for(f=0;f<512;f=f+8)
    {
      xx = *buf++ << 8; // Dane L
      xx = xx + *buf++; // H
      S0SPDR = xx; // Zapisz
      xx = *buf++ << 8; // Dane L next [A]
      xx = xx + *buf++; // H next [A]
      while(!(S0SPSR & 0x80)); // wait for Transit complete
   // - 2, 3 -----------------------------------------------
      S0SPDR = xx; // Zapisz [A]
      xx = *buf++ << 8; // Dane L [B]
      xx = xx + *buf++; // H [B]
      while(!(S0SPSR & 0x80)); // wait for Transit complete
   // - 4, 5 -----------------------------------------------
      S0SPDR = xx; // Zapisz [B]
      xx = *buf++ << 8; // Dane L [C]
      xx = xx + *buf++; // H [C]
      while(!(S0SPSR & 0x80)); // wait for Transit complete
   // - 6, 7 -----------------------------------------------
      S0SPDR = xx; // Zapisz [C]
      while(!(S0SPSR & 0x80)); // wait for Transit complete
    }
    S0SPCR = 0x0820; // 8 bitow

   // 2 bajty CRC
   SPI(0xA5); // Dane
   SPI(0xA5); // Dane
   
   // Potwierdzenie - akceptacja danych
   xx = SPI(0xFF);
   if(((xx & 0x0F) != 0x05) && (xx != 0))
   {
    CS_SD_1;
    SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
    //piszhl(xx);
    return(0x2000 + xx + (m<<8)); // Blad zapisu
   }
  }
  else
   SPI(0xFD);

//  CS_SD_1;
//  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//  CS_SD_0;

  Zapal_Cz;

  delayx(0x0007);

  // Wait for write end (karta zwiera DO do masy)
  f=0xFFFF;
  while( (SPI(0xFF) == 0 ) && f)f--;
  if(f<1)
  {
   CS_SD_1;
   SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
   return(0x3000+(m<<8)); // Blad zapisu
  }
  
  Zgas_Ledy;
  Zapal_Ze;
 }

  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac

// OK
 xx = 0;
 return(xx);
}

// Write SC_MMC sector -------------------------------------
int SD_Write_N(char *buf, uint32_t sec)
{
// SPI -> SD
 int xx, m;
// Test Led
 Zgas_Ledy;

 if (!BlkAddr) sec = sec << 9;	/* Convert to byte address if needed */

 delayx(0x07);
 S0SPCCR = cur_spi_spd; //SPI_HIGH
 delayx(0x07);

 CS_SD_0;
 xx = SD_Command(SD_CMD_55, 0);               
//piszs(" APP_CMD");
 if(xx)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0100 + xx); // Blad
 }

 CS_SD_0;
 xx = SD_Command(SD_ACMD_23, 16);               
//piszs(" SET_WR_BLK_ERASE_COUNT_CMD");
 if(xx)
 {
  CS_SD_1;
  SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
//piszhl(xx);
  return(0x0200 + xx); // Blad
 }

 for(m=0;m<16;m++)
 {
  if(m==1) 
  {
    CS_SD_0;
    xx = SD_Command(SD_CMD_55, 0);               
   //piszs(" APP_CMD");
    if(xx)
    {
     CS_SD_1;
     SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
   //piszhl(xx);
     return(0x0100 + xx); // Blad
    }

    CS_SD_0;
    xx = SD_Command(SD_ACMD_23, 1);               
   //piszs(" SET_WR_BLK_ERASE_COUNT_CMD");
    if(xx)
    {
     CS_SD_1;
     SPI(0xFF); // po zakonczeniu komendy trzeba poczekac
   //piszhl(xx);
     return(0x0200 + xx); // Blad
    }
  }
  xx = SD_Write(buf + (m<<9), sec + m);
  if(xx)break; 
 }
  Zgas_Ledy;
  Zapal_Ze;

// OK
 return(xx);
}

// -- SD -----------------------------------------------
int read_n_sec()
{
unsigned long xx, l_s;
char *uip;
 xx = (unsigned long)Tab_8 + 0x2000;
 uip = (char *)xx;
 l_s = sech - secl + 1;
 xx = disk_read (0, uip,  secl, l_s); //Tab_8 + 0x2000
 return(xx);
}

int read_n_sec_x(unsigned long differ)
{
unsigned long xx, l_s;
char *uip;
 xx = (unsigned long)Tab_8 + differ;
 uip = (char *)xx; 
 l_s = sech - secl + 1;
 xx = disk_read (0, uip, secl, l_s);//Tab_8 + differ
 return(xx);
}

int read_n_sec_p(char *ptr)
{
int xx, l_s;
 l_s = sech - secl + 1;
 xx = disk_read (0, ptr,  secl, l_s);
 return(xx);
}

// -- SD -----------------------------------------------
int write_n_sec()
{
unsigned long xx, l_s;
char *uip;
 xx = (unsigned long)Tab_8 + 0x2000;
 uip = (char *)xx; 
 l_s = sech - secl + 1;
 xx = disk_write (0, uip,  secl, l_s); //Tab_8 + 0x2000
 return(xx);
}

int write_n_sec_x(unsigned long differ)
{
unsigned long xx, l_s;
char *uip;
 xx = (unsigned long)Tab_8 + differ;
 uip = (char *)xx;
 l_s = sech - secl + 1;
 xx = disk_write (0, uip,  secl, l_s); //Tab_8 + differ
 return(xx);
}

int write_n_sec_p(char *ptr)
{
int xx, l_s;
 l_s = sech - secl + 1;
 xx = disk_write (0, ptr,  secl, l_s);
 return(xx);
}

// ACII Hex -> bin +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
unsigned long asciih2bin(char *asci)
{
 int32_t xx;
 int uc, n;
 xx = 0;
 for(n = 0;n < strlen(asci); n++)
 {
  uc = asci[n];
  if((uc >= 0x30) && (uc<='f'))
  {
   if((uc>=0x30) && (uc<=0x39))
    xx = (xx << 4) + (uc - 0x30);
   uc = uc & 0x4F;
   if((uc>=0x41) && (uc<=0x46))
    xx = (xx << 4) + (uc - 0x37);
  }
 }
 return(xx);
}
// ----------------------------------------------------------------------------

// Get Hex ++++++++++++++++++++++++++++++++++++++++++++++
unsigned long gethex(void)
{
 int32_t xx;
 int uc;
 char sw;
 sw = 0;
 xx = 0;
 ESC=0;
 BACK=0;
 TAB=0;
 ENTER=0;
 while(1)
 {
  uc = KlawX();
  if((uc == 0x1B)||(uc == '`'))
  {
   uc = 0;
   ESC=1;
   return(-1);
  }
  if(uc == 0x08)
  {
   uc = 0;
   BACK=1;
   return(0);
  }
  if((uc == 0x0D)||(uc == '<'))
  {
   uc = 0;
   return(xx);
  }
  if(uc == 0x09)
  {
   uc = 0;
   return(xx);
   TAB=1;
  }
  if(uc == '+')
  {
   sw = 1;
   piszc('+');
   xx = 0;
  }
  if((uc >= 0x30) && (uc<='f') && (sw == 0))
  {
   if((uc>=0x30) && (uc<=0x39))
   {
    xx = (xx << 4) + (uc - 0x30);
    piszc(uc);
    ENTER++;
   }
   uc = uc & 0x4F;
   if((uc>=0x41) && (uc<=0x46))
   {
    xx = (xx << 4) + (uc - 0x37);
    piszc(uc);
    ENTER++;
   }
  }
  if((uc >= 0x30) && (uc<=0x39) && (sw > 0))
  {
   xx = (xx * 10) + (uc - 0x30);
   piszc(uc);
   ENTER++;
  }
 }
 return(-1);
}
// ----------------------------------------------------------------------------

// Get DEC ++++++++++++++++++++++++++++++++++++++++++++++
unsigned long getdec(void)
{
 int32_t xx;
 int uc, radx;
 radx = 1;
 xx = 0;
 ESC=0;
 BACK=0;
 TAB=0;
 ENTER=0; 
 while(1)
 {
  uc = KlawX();
  if((uc == 0x1B)||(uc == '`'))
  {
   uc = 0;
   ESC=1;
   return(-1);
  }
  if(uc == 0x08)
  {
   uc = 0;
   BACK=1;
   return(0);
  }
  if((uc == 0x0D)||(uc == '<'))
  {
   uc = 0;
   return(xx);
  }
  if(uc == 0x09)
  {
   uc = 0;
   TAB=0;
   return(xx);
  }
  if((uc == 'x')||(uc == 'X'))
  {
   radx = 0;
   piszc('0');
   piszc('x');
   xx = 0;
  }
  if((uc >= 0x30) && (uc<='f') && !radx )
  {
   if((uc>=0x30) && (uc<=0x39))
   {
    xx = (xx << 4) + (uc - 0x30);
    piszc(uc);
    ENTER++;
   }
   uc = uc & 0x4F;
   if((uc>=0x41) && (uc<=0x46))
   {
    xx = (xx << 4) + (uc - 0x37);
    piszc(uc);
    ENTER++;
   }
  }
  if((uc >= 0x30) && (uc<=0x39) && radx )
  {
   xx = xx * 10;
   xx += uc - 0x30;
   piszc(uc);
   ENTER++;
  }
 }
 return(-1);
}

// ----------------------------------------------------------------------------

// Zapis danych do EPM3064
void LD_Latch_n(unsigned char dane, unsigned char latch)
{
unsigned char locf, maskd;

 maskd = 0x01;
 IOCLR0 |= 1 << 10; // DATA
 IOCLR0 |= 1 << 11; // CLK
 IOCLR0 |= 1 << 5;  // Latch_2
 IOCLR0 |= 1 << 4;  // Latch_3
 FIO2CLR |= 1 << 5; // Latch_1
 delayx(1); // delay
 for(locf=0;locf<8;locf++) 
 {
  if(dane & maskd)
   IOSET0 |= 1 << 10; // DATA = 1
  else
   IOCLR0 |= 1 << 10; // DATA = 0
  delayx(5); // delay
  IOSET0 |= 1 << 11; // CLR
  delayx(5); // delay
  IOCLR0 |= 1 << 11; // CLR
  delayx(5); // delay
  maskd = maskd << 1;
  maskd = maskd & 0xFE;
 }
 switch(latch)
 {
 case 1 : 
   FIO2SET |= 1 << 5; // Latch_1
   delayx(5); // delay
   FIO2CLR |= 1 << 5; // Latch_1
   delayx(5); // delay
   break;
 case 2 : 
   IOSET0 |= 1 << 5; // Latch_2
   delayx(5); // delay
   IOCLR0 |= 1 << 5; // Latch_2
   delayx(5); // delay
   break;
 case 3 : 
   IOSET0 |= 1 << 4; // Latch_3
   delayx(5); // delay
   IOCLR0 |= 1 << 4; // Latch_3
   delayx(5); // delay
 default:
   break;
 }
 IOCLR0 |= 1 << 10; // DATA
 IOCLR0 |= 1 << 11; // CLK
 IOCLR0 |= 1 << 5;  // Latch_2
 IOCLR0 |= 1 << 4;  // Latch_3
 FIO2CLR |= 1 << 5; // Latch_1
}
// ============================================================================

// Zapis do WM8770 (A6..A0, D8..D0)
int write_WM8770(unsigned char adr, WORD data)
{
int fx, fy;
// Ustaw Bramki SCK1: SCK1 -> WM8770 10xx xxxx; SCK1 -> STA015 01xx xxxx
CTRL1 = CTRL1 & (~0x40);
CTRL1 = CTRL1 | 0x80;
LD_Latch_n(CTRL1, 1);
// Wyslij dwa bajty przez SPI1
WM_CE_0; 
fy = adr << 1;
fy = fy + ((data >> 8) & 0X1F); 
fx = SPI1(fy);
fy = data & 0x00FF;
fx = SPI1(fy);
WM_CE_1;
return fx;
}
// ============================================================================

long int oblicz_freq(unsigned int a )
{
long int lx;
 if(VnC > 0)
  lx = a + (long)225;
 else
  lx = a - (long)225;

 lx = lx << 1;
 lx = lx / (long)25;

 lx = lx + (long)KKWARC; // kalibracja kwarcu

 return lx;
}

// ---------------------------------------------------------------------------
long int oblicz_FM(unsigned int b)
{
long int ly;                   
 ly = b - (long)KKWARC;

 ly = ly * 25;
 ly = ly >> 1;

 if(VnC)
  ly = ly - (long)225;
 else
  ly = ly + (long)225;

 return ly;
}

// ============================================================================

#include "Functions_STA.c"

// --------------------------------------------------------------------------

#include "FunkcjeX.c"

// --------------------------------------------------------------------------

#include "MmcSdCmd.c"

// ==========================================================================

